;	---------------------------------------------------------------
;	BPLSUBS.CPY - Basic Plotting Routines using MOVETO,DRAWTO
;	---------------------------------------------------------------
;
;	(c) Copyright 1986 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle  5/25/86
;	cloned from SDSUBS.CPY
;
	include	PLSDL.CPY
;
;	This module provides the DSPAT, DSFPAT,DSVTXT, DSVFNT,
;	DSREC and DSFREC routines.  Note that DSPOLY is NOT provided.
;
;	use of this module requires:
;
;	Local MOVETO(si,di) and DRAWTO(si,di) near procedures, and
;	PSCALE DW n, where n is number of pixels per pattern bit.
;
;	DSPAT - set current line pattern from AX
;
DSPAT:	entry
	call	setlp
	exit
;
setlp	proc	near
	mov	CurPat,ax
	mov	bp,curpat	;initialize line pattern
	mov	upatrn,bp
	mov	bp,pscale	;set pattern multiple
	mov	pcount,bp
	ret
setlp	endp
;
;
;	DSREC - draw a rectangle of current color and pattern
;
;	SI = X1, DI = Y1
;	DX = X2, AX = Y2
;
DSREC:	entry
	mov	x1,si		;save parameters
	mov	y1,di
	mov	x2,dx
	mov	y2,ax
	mov	si,x1		;left side
	mov	di,y1
	mov	dx,x1
	mov	ax,y2
	call	doline
	mov	si,x1		;top side
	mov	di,y2
	mov	dx,x2
	mov	ax,y2
	call	doline
	mov	si,x2		;right side
	mov	di,y2
	mov	dx,x2
	mov	ax,y1
	call	doline
	mov	si,x2		;bottom
	mov	di,y1
	mov	dx,x1
	mov	ax,y1
	call	doline
	exit
;
;	DSFREC - draw a rectangle filled with the current color and mode
;
;	SI = X1, DI = Y1
;	DX = X2, AX = Y2
;
DSFREC:	entry
	mov	pstat,0		;flag start of line
	mov	x1,si		;save parameters
	mov	y1,di
	mov	x2,dx
	mov	y2,ax
	mov	dx,x2		;get parameters
	mov	si,X1
	cmp	dx,si		;get lowest X to SI
	jge	frlow
	xchg	dx,si
frlow:	mov	scanx,si	;save in scanx
	mov	cx,dx		;CX = pixel loop count
	sub	cx,si
	inc	cx
frec:	mov	ax,Y2		;set up next line
	mov	di,Y1
	mov	dx,scanx
	mov	si,dx
	inc	scanx		;bump line scanner
	push	bx
	push	cx
	call	DRWLINE		;draw vertical line
	pop	cx
	pop	bx
	loop	frec		;loop for all lines
	exit
;
