;	DGNONE.ASM - Null Digitizer Driver
;
;	(c) Copyright 1986,88 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle  5/26/86
;	new .BIN driver format 12/05/88 SB
;
	NAME	DGNONE
;
devrev	equ	0			;driver code revision #
dpti	equ	0			;dots per ten inches
cfgctl	equ	1			;null mouse
;
	include	DGDRV.CPY
;
;	------------------------------------------------------------------
;	DGINIT - initialize digitizer driver
;	------------------------------------------------------------------
;
DGINIT:	entry
	sub	ax,ax			;return AX 0 = OK
	exit
;
;	------------------------------------------------------------------
;	DGEND - stop using digitizer
;	------------------------------------------------------------------
;
DGEND:	entry
	exit
;
;	------------------------------------------------------------------
;	DGREAD - read digitizer position & buttons
;
;	AX = DGDAV (digitizer data available status)
;		=0 no dig data available
;		=1 button up tracking coordinate
;		=2 LEFT button selected (or only button)
;		=3 RIGHT button selected
;		=4 button down tracking coordinate
;		=5 SI is LEFT-picked tablet menu item # 1..DGINUM
;	SI = DIGX position for AX=1,2,3 or 4
;	DI = DIGY position for AX=1,2,3 or 4
;	------------------------------------------------------------------
;
DGREAD:	entry
	mov	ax,0			;no data available
	exit
;
;	---------- local data items --------------------------------------
;
digx	dw	1000			;current X position
digy	dw	750			;current Y position
;
;	-----------------------------------------------------------------
;	Digitizer Driver Resource Data
;
DGRSC	dw	1			;# of resources
	dw	offset	dgid		;1=driver ID text
dgid	db	'No pointing device installed.',0	;max 64 bytes
;
	include	DGLAST.CPY
