;	DSDRV.CPY - display driver header code
;
;	(c) Copyright 1986,7 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle  1/5/1986
;	modified DSSPEC to copy 9 words 3/5/86
;	modified for driver toolkit 8/16/86
;	driver interface revision 4: 3/6/87
;	int rev 5: DSSAVE/REST no mode/color/pat restore 7/14/87
;	rev 6: add DSDSKS, DSDSKR, DSCTRL, dsnada slots 3/6/88
;	rev 7: use DVRSVC RAM aloc, animation functions 8/5/88
;	rev 8: .BIN file format, vector table 9/18/88 MR
;
dsdrv	segment	public
	assume	cs:dsdrv,ds:dsdrv
;
dvrlvl	equ	8		;driver interface revision level number
dvrtyp	equ	0		;driver type (0=vectored display driver)
;
	if1
xfunc	=	0		;assume no extended functions
	endif
;
entry	macro			;enter driver procedure
	push	ds		;save old DS
	mov	bp,cs		;use local DS
	mov	ds,bp
	endm
;
exit	macro			;exit driver procedure
	pop	ds		;restore entry DS
	db	0CBH		;RETF
	endm
;
;	------------------------------------------------------------------
;	Required Equates Defined before INCLUDE DSDRV.CPY
;	------------------------------------------------------------------
;
;	DEVREV equ is Specific-Device driver code revision #
;
;	CFGCTL equ selects by bits:
;
;	   1h = Adjust dsyar/dsxar display aspect ratio
;	   2h = Use SELLPT/SELSPT to configure prompt text size
;	   4h = Call device-specific DEVCFG routine
;	
;	------------------------------------------------------------------
;	.BIN File Header & Entry Offsets Table
;	------------------------------------------------------------------
;
	org	0000h
	hlt			;signature word = xxF4h
	db	dvrtyp		;where xx = dvrtyp
	db	dvrlvl		;driver interface rev # (numeric)
	db	devrev		;device specific code revision #
	dw	xfunc		;extended functions available flag
	dw	offset enddvr+1	;# bytes in driver
	dw	cfgctl		;auto-configure bits
	dw	0		;start of config data area (unused)
	dw	offset dsidrn	;start of parameter table
	dw	offset DSRSC	;start of display resource area
	dw	offset DSINIT	;initialize display driver
	dw	offset DSEND	;end use of display driver
	dw	offset SELLPT	;config for large prompt text
	dw	offset SELSPT	;config for small prompt text
	dw	offset DEVCFG	;device-specific config routine
	dw	offset DSTXM	;switch to text screen
	dw	offset DSGRM	;switch back to graphics screen
	dw	offset DSCLEAR	;clear screen to black
	dw	offset DSERA	;select draw in backgroud color
	dw	offset DSDRAW	;select draw in current color
	dw	offset DSINV	;select draw XOR
	dw	offset DSLWT	;select line weight
	dw	offset DSCOLOR	;specify current & background color
	dw	offset DSPAT	;specify line pattern data
	dw	offset DSFPAT	;specify fill pattern data
	dw	offset DSPOINT	;draw a point
	dw	offset DSLINE	;draw a line
	dw	offset DSREC	;draw a rectangle
	dw	offset DSFREC	;draw & fill a rectangle
	dw	offset DSCIR	;draw a circle
	dw	offset DSARC	;draw an arc
	dw	offset DSPOLY	;fill a polygon area
	dw	offset dsnada
	dw	offset dsnada
	dw	offset dsnada
	dw	offset dsnada
	dw	offset DSTEXT	;display prompt text
	dw	offset DSITXT	;display inverted prompt text
	dw	offset DSTINV	;invert prompt text
	dw	offset DSTCLR	;clear prompt text to spaces
	dw	offset DSSAVE	;save graphics screen area
	dw	offset DSREST	;restore saved graphics screen
	dw	offset DSDSKS	;save screen to open disk file
	dw	offset DSDSKR	;restore screen from open disk file
	dw	offset DSCTRL	;specific device control
	dw	offset DSAUPD	;screen animation frame update
	dw	offset DSAEND	;screen animation end
	dw	offset DSSIDE	;specify stereo mode & side
	dw	offset DSRPAL	;read 48-byte palette
	dw	offset DSWPAL	;write 48-byte palette
	dw	offset dsnada	;unused
	dw	offset dsnada	;unused
	dw	offset DSSBGN	;stereo 3d begin
	dw	offset DSABGN	;animation begin
	dw	offset KSTATE	;keyboard shift state -> carry bit
	dw	offset CONRDY	;key data ready state -> carry bit
	dw	offset CONIN	;conin ->ax,dl; dl=funkey if ax=01Ch
	dw	offset CONOUT	;conout ax; 16-bit may be sent 8,8 or 16
	dw	offset CINIT	;console init - revector CTRL-C INT 23
	dw	offset CEND	;console end - restore CTRL-C INT 23
	dw	offset ASKCC	;set carry if ctrl-c pending
	dw	offset GRDEI	;graphics screen DOS error intercept INT 10
	dw	offset GRDER	;restore from GRDEI
	dw	offset TSINIT	;start use of TS routines
	dw	offset TSEND	;end use of TS routines
	dw	offset TSATRB	;select text screen attributes
	dw	offset TSCLR	;clear text screen to current attribute
	dw	offset TSINV	;invert TS columns (and finish last chr)
	dw	offset TSOUT	;send AX (or AL data if AH=0) to TS screen
	dw	offset TSPOS	;set TS cursor to si,di chr start;return cor.
	dw	offset TSGPOS	;get current TS csr pos, chr sizes
	dw	offset TSGET	;return AX chr at TS csr pos; advance csr.
	dw	offset TSPWST	;position csr to start of word at cpos.
	dw	offset TSGETW	;get word starting at cpos to ES:DI
	dw	offset TSDATA	;points to TS data area
	dw	offset CHRSIZ	;get size of chr AX: ax=string,dx=screen
	dw	offset UCASE	;change string ES:DI to uppercase
	dw	offset DSGVL	;get vector list for text string
	dw	offset DSBKSP	;backspace (erasing chr from screen)
	dw	offset DSTED	;text edit box
	dw	offset DSBLN	;draw horizontal bit-line 01h leftmost
	dw	offset DSBLNR	;draw horizontal bit-line 80h leftmost
;
dsnada:	stc			;flag unavailable
	db	0CBH		;RETF
;
