;	EGADSK.CPY - EGA/VGA Disk File Screen SAVE/RESTORE Routines
;
;	Parameter is DSKTYP equ save data format type id
;	BX = open file handle for read/write (do not close)
;
;	0 = screen save unimplimented
;	1 = 640 x 480 VGA or EGA+
;	2 = 640 x 350 EGA
;
	if	DskTyp EQ 1
DskSiz	equ	9600h
	endif
	if	DskTyp EQ 2
DskSiz	equ	6D60h
	endif
;
DPSAVE	macro	arg
	mov	al,arg		;enable selected plane read
	out	dx,al
	push	dx		;save port
	mov	ah,40h		;write to BX handle
	sub	dx,dx		;DS:0000h:dsksiz-1
	mov	cx,DskSiz	;bytes per plane
	int	21H
	pop	dx		;restore port
	endm
;
dsktw	dw	dsktyp
dsktr	dw	dsktyp
;
;	DSDSKS - Save screen image to file handle BX
;
DSDSKS:	entry
	mov	ah,40h		;write to BX handle
	lea	dx,dsktw	;DS:dsktw
	mov	cx,2		;2 bytes
	int	21H
	push	ds
	mov	ax,dwseg	;display memory segment
	mov	ds,ax
	cld			;upscan
	mov	dx,03CEH	;select read map register adrs
	mov	al,4
	out	dx,al
	inc	dx		;select read map data port
	dpsave	0
	dpsave	1
	dpsave	2
	dpsave	3
	pop	ds		;restore working segments
	call	spccm		;set current color and mode
	clc			;worked ok
	exit
;
DPREST	macro	arg
	mov	al,arg		;enable selected write plane
	out	dx,al
	push	dx		;save port
	mov	ah,3Fh		;read from BX handle
	mov	dx,bp		;DS:0000h:dsksiz-1
	mov	cx,di		;bytes per plane to read
	int	21H
	mov	ax,4201h	;seek from present posn
	sub	cx,cx		;CX:DX bytes
	mov	dx,si
	int	21h
	pop	dx		;restore port
	endm
;
;	DSDSKR - Restore screen image from file handle BX
;
DSDSKR:	entry
	mov	dsktr,0		;clear read type
	mov	ah,3Fh		;read from BX handle
	lea	dx,dsktr	;DS:dsktr
	mov	cx,2		;2 bytes
	int	21H
	mov	ax,dsktr	;is it compatible?
	cmp	ax,0
	jz	dfnotc
	cmp	ax,2
	ja	dfnotc
	mov	di,DskSiz	;set read plane count
	mov	si,0		;set skip after read count
	mov	bp,0		;set read start offset
	cmp	ax,DskTW	;this drivers' own format?
	jz	dfisc
	cmp	ax,2		;no - read ega?
	jz	rdega
	mov	si,28A0h	;read VGA file on EGA
	jmp	short dfisc
rdega:	mov	di,6D60h	;read EGA file on VGA
	mov	bp,1450h	;center on screen
	jmp	short dfisc
dfnotc:	stc			;no - not restored
	mov	ax,0		;no read type
	exit
dfisc:	SetReg	3CEH,1,0H	;disable S/R (direct data write)
	SetReg	3CEH,3,0H	;write normal data
	push	ds
	mov	ax,dwseg	;set video segment
	mov	ds,ax
	cld			;upscan
	mov	dx,03CEH	;select pixel mask register adrs
	mov	al,8
	out	dx,al
	inc	dx		;enable all pixels of a byte
	mov	al,0FFH
	out	dx,al
	mov	dx,03C4H	;select plane write mask reg adrs
	mov	al,2
	out	dx,al
	inc	dx		;select plane write mask data port
	dprest	1
	dprest	2
	dprest	4
	dprest	8
	mov	dx,03C4H	;select plane write mask reg adrs
	mov	al,2
	out	dx,al
	inc	dx		;select plane write mask data port
	mov	al,0FFH		;enable all planes
	out	dx,al
	pop	ds		;restore working segments
	call	spccm		;set current color and mode
	mov	ax,DskTR	;return loaded type code
	clc			;worked ok
	exit
;
