;	EMMSAV.CPY - Save 256K VGA screen RAM in EMM thru DVRSVC
;
;	ASBFR - allocate save buffer - set JC if error
;
ASBFR	proc	near
	mov	ax,16			;# pages needed
	mov	dx,8			;allocate EMM RAM block
	call	dword ptr DVRSVC
	jc	asbxt			;error?
	mov	word ptr SHdl,bx	;save block handle
	mov	SavSeg,ax		;and access segment
	clc				;flag aloc. ok
asbxt:	ret				;carry set if error
asbfr	endp
;
;	RSBFR - release save buffer
;
RSBFR	proc	near
	mov	bx,word ptr SHdl	;EMM RAM block handle
	mov	dx,9			;release EMM RAM block
	call	dword ptr DVRSVC
	ret				;carry set if error
rsbfr	endp
;
;	Save Entire Screen
;
;	System RAM save/restore routines
;
PSAVE	macro	arg
	local	nobmp,ploop,islast,ntlast
	mov	dx,3CFh			;select read map data port
	mov	al,arg			;enable selected plane read
	out	dx,al
	mov	cx,CS:SavNW		;loop for # of 16k pages
	rol	cx,1
	rol	cx,1
	rol	cx,1
	and	cx,7
	test	CS:SavNW,1FFFh		;bump unless mult of 16k
	jz	short nobmp
	inc	cx
nobmp:	mov	si,CS:SavSO		;display plane memory start
ploop:	push	cx			;save loop counter
	push	ES			;save context
	push	DS
	push	si
	push	bp
	push	bx
	mov	ax,bp			;access block
	mov	dx,10
	call	dword ptr CS:DVRSVC
	pop	bx			;restore context
	pop	bp
	pop	si
	pop	DS
	pop	ES
	inc	bp			;bump page #
	sub	di,di			;save plane buffer
	mov	cx,CS:SavNW		;last page size in words
	and	cx,1FFFh
	jcxz	short ntlast		;full page if = 0
	pop	ax			;full page if not last page
	push	ax
	cmp	ax,1
	jz	short islast
ntlast:	mov	cx,2000h
islast:	cld				;upscan
	rep	movsw			;copy page
	pop	cx			;loop for 4-16k blocks
	loop	short ploop
	endm
;
ssave	proc	near
	mov	SavSO,0			;entire screen
	mov	SavNW,8000h
	jmp	short savcom
xsave:	mov	si,DSYMAX		;SI:start line = DSYMAX-highY
	sub	si,ax
	sub	ax,di			;DI:#lines=last-first+1
	inc	ax
	mov	di,ax
	mov	bx,dsxmax		;BX=# bytes per line
	inc	bx
	shr	bx,1
	shr	bx,1
	shr	bx,1
	mov	ax,si			;calc starting offset
	mul	bx
	mov	SavSO,ax
	mov	ax,di			;calc # words to save
	mul	bx
	inc	ax
	shr	ax,1
	mov	SavNW,ax
savcom:	push	es			;save working segments
	push	ds
	mov	bx,word ptr SHdl	;EMM page handle
	mov	ES,SavSeg		;save buffer segment
	mov	DS,dwseg		;display memory segment
	mov	dx,03CEH		;select read map register adrs
	mov	al,4
	out	dx,al
	sub	bp,bp			;EMM page start
	psave	0
	psave	1
	psave	2
	psave	3
	pop	ds			;exit dsgsav
	pop	es
	call	spccm			;set current color and mode
	ret
ssave	endp
;
PREST	macro	arg
	local	nobmp,ploop,islast,ntlast
	mov	dx,3C5h			;select plane write mask data port
	mov	al,arg			;enable selected plane read
	out	dx,al
	mov	cx,CS:SavNW		;loop for # of 16k pages
	rol	cx,1
	rol	cx,1
	rol	cx,1
	and	cx,7
	test	CS:SavNW,1FFFh		;bump unless mult of 16k
	jz	short nobmp
	inc	cx
nobmp:	mov	di,CS:SavSO		;display plane memory start
ploop:	push	cx			;save loop counter
	push	ES			;save context
	push	DS
	push	di
	push	bp
	push	bx
	mov	ax,bp			;access block
	mov	dx,10
	call	dword ptr CS:DVRSVC
	pop	bx			;restore context
	pop	bp
	pop	di
	pop	DS
	pop	ES
	inc	bp			;bump page #
	sub	si,si			;restore plane buffer
	mov	cx,CS:SavNW		;last page size in words
	and	cx,1FFFh
	jcxz	short ntlast		;full page if = 0
	pop	ax			;full page if not last page
	push	ax
	cmp	ax,1
	jz	short islast
ntlast:	mov	cx,2000h
islast:	cld				;upscan
	rep	movsw			;copy page
	pop	cx			;loop for 4-16k blocks
	loop	short ploop
	endm
;
srest	proc	near
	SGREG	5,0			;write mode 0
	mov	bx,word ptr SHdl	;EMM page handle
	push	es			;save working segments
	push	ds
	mov	ES,dwseg		;set video segment
	mov	DS,SavSeg		;save buffer segment
	cld				;upscan
	mov	dx,03CEH		;select pixel mask register adrs
	mov	al,8
	out	dx,al
	inc	dx			;enable all pixels of a byte
	mov	al,0FFH
	out	dx,al
	mov	dx,03C4H		;select plane write mask reg adrs
	mov	al,2
	out	dx,al
	sub	di,di			;display plane memory start
	sub	bp,bp			;EMM page start
	prest	1
	prest	2
	prest	4
	prest	8
	mov	dx,03C4H		;select plane write mask reg adrs
	mov	al,2
	out	dx,al
	inc	dx			;select plane write mask data port
	mov	al,0FFH			;enable all planes
	out	dx,al
	pop	ds			;exit dsgsav
	pop	es
	call	spccm			;set current color and mode
	ret
srest	endp
;
SavSO	dw	0			;save byte starting offset
SavNW	dw	2000h			;save # words
;
