;	PL7475.ASM - plotter driver for HP 7475,7550,7470,7440,7220
;			and Roland (PNC-1000) CAMM-1 Sign Maker
;
;	(c) Copyright 1986 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle  5/25/1986
;	modified for driver toolkit 8/16/86
;	added DSCIR/DSARC/DSPOLY/plpwid 1/11/87 MR
;	revised for rev 4 drivers 3/27/87
;	revised for new .BIN driver format 
;	  and added other small-bed plotters  12/29/88 SB
;	devrev=1: Color 0; Separate endstgs 08/13/89 SB
;	devrev=2: added Roland CAMM-1 12/31/89 SB
;	devrev=3: fixed 7220 quirks 4/05/90 SB
;
	name	PL7475
;
devrev	equ	3			;driver code revision #
cfgctl	equ	0000Eh			;port,dest,devcfg
dstmsk	equ	0FFFFh			;all destinations valid
;	This driver supports PID values 25..29 & 60
;
	include	PLDRV.CPY
;
;	---------------------------------------------------------------
;	DEVCFG - Select Turrent changing desired or not
;	(All CONIN/CONOUT must use DOS functions)
;	---------------------------------------------------------------
;
DEVCFG:	entry
psagn:	mov	dx,prsl			;select plotter message
	mov	ah,9
	int	21H
	mov	ah,7			;get key
	int	21H
	push	ax			;echo choice
	mov	dl,al
	mov	ah,2
	int	21H
	pop	ax
	cmp	al,3
	jnz	noabt1
	mov	abflag,1
	exit
noabt1:	cmp	al,13			;CR?
	jz	short dfltpt
	sub	al,'1'			;range 0..5
	jl	dfltpt
	cmp	al,5
	ja	dfltpt			;use default if out-of-range
	jmp	short okptp
dfltpt:	mov	al,0			;CR default is 7475
okptp:	mov	bl,al			;setup parameters
	sub	bh,bh
	mov	al,maxpct[bx]		;max resolution choice #
	mov	maxpc,al
	mov	al,minpct[bx]		;min resolution choice #
	mov	minpc,al
	shl	bx,1			;desired resolution prompt
	mov	ax,rdtbl[bx]		;resolution dialog prompt #
	mov	rdlptr,ax
	mov	ax,pidtbl[bx]		;plotter id rsc.
	mov	plidrn,ax
	mov	ax,pntbl[bx]		;prog logic print id #
	mov	prnum,ax
	mov	ax,nptbl[bx]		;max # pens
	mov	plnpens,ax
	mov	ax,tptbl[bx]		;pldpti
	mov	pldpti,ax
	mov	ax,tmtbl[bx]		;turrent change avail<>0
	mov	tflag,ax
	mov	ax,pdevid[bx]		;device id #
	mov	pid,ax
	mov	dx,ccrlf		;crlf to end dialog
	mov	ah,9
	int	21H
	mov	tcenab,0		;assume no turret changing
	cmp	tflag,0			;capable of changing turrents?
	jz	tcexit			;no
	mov	dx,tcqz			;yes, ask if turret changing
	mov	ah,9
	int	21H
	mov	ah,7			;get key
	int	21H
	push	ax			;echo choice
	mov	dl,al
	mov	ah,2
	int	21H
	pop	ax
	cmp	al,3
	jnz	noabt2
	mov	abflag,1
	exit
noabt2:	cmp	al,13			;CR?
	jz	short tcexit
	cmp	al,'Y'			;answer Y?
	jz	dotchg
	cmp	al,'y'
	jnz	tcexit
dotchg:	mov	tcenab,1		;enable turret changing
tcexit:	mov	dx,ccrlf		;append crlf
	mov	ah,9
	int	21H
	exit
;
;	---------------------------------------------------------------
;	PLLOAD - load initialization of the plotter driver
;	PFLOAD - load plotter driver - no port init (Plot to File)
;
;	This will only be called once per program execution
;	before any other display driver calls.  It must:
;	1 - test for correct plotter hardware available
;	2 - allocate any required buffer memory from DOS
;	3 - perform global & local variable initialization
;	4 - initialize the plotter hardware
;	5 - set AX=error code:
;	    0=ok
;	    1=not enough memory
;	    2=not enough EMM memory
;	    3=device unavailable/unuseable
;	---------------------------------------------------------------
;
PFLOAD:	entry
	mov	word ptr DVRSVC,di	;save pointer to driver services
	mov	word ptr DVRSVC+2,ES
	mov	dx,11			;init destination for PTF
	mov	cx,0
	call	dword ptr DVRSVC	;do it
	jmp	short ldcom
PLLOAD:	entry
	mov	word ptr DVRSVC,di	;save pointer to driver services
	mov	word ptr DVRSVC+2,ES
	mov	dx,11			;init for configured destination
	mov	cx,dest
	mov	ax,idata
	cmp	prnum,4			;if 7220 then use 2400 baud
	jnz	id96
	mov	ax,0BAH			;0BAH = 2400-7-1-E
id96:	mov	bx,port
	call	dword ptr DVRSVC	;do it
ldcom:	sub	ax,ax			;ax=0: device available for use
	exit
;
;	---------------------------------------------------------------
;	PLOTQ - Ask any Plot-specific questions
;
;	All answers are stored in the PLQDTA area
;	DSXMAX table data must be valid after PLOTQ
;	---------------------------------------------------------------
;
PLOTQ:	entry
	mov	ax,pid			;save pid in qdata area
	mov	Qpid,ax
	mov	abflag,0		;clear abort flag
	mov	CurTur,0		;init need turret change
	RSCMSG	rdlptr			;display size selection dialog
	CONIN				;get keypress
	cmp	al,3			;ctrl-C?
	jnz	noabt3
	mov	abflag,1		;set abort flag
	exit
noabt3:	CONOUT				;echo it
	sub	ah,ah
	cmp	al,'1'
	jb	pikdf			;assume default (CR) is picked
	jz	tndig			;'1' may mean 2 digits
	sub	al,'0'
	cmp	al,9			;use default if over 9 
	ja	pikdf
	dec	ax
	jmp	short pikok		;save model # picked 
tndig:	CONIN				;first digit was a '1'
	CONOUT				;echo 2nd keypress
	cmp	al,'0'
	jb	pikdf			;if not 0-2 then assume total=1
	cmp	al,'2'
	ja	pikdf
	sub	al,'0'-10		;range 10-12
	dec	ax
	jmp	short pikok
pikdf:	mov	ax,0			;default = sel #1 = zeroth index'r
pikok:	sub	ah,ah
	add	al,minpc		;range minpc..maxpc
	cmp	al,minpc
	jl	usedfv
	cmp	al,maxpc
	jbe	usersl
usedfv:	mov	al,minpc		;default is minpc (low res)
usersl:	sub	ah,ah			;save size selection
	mov	Qrval,ax
	mov	ax,13			;end dialog
	CONOUT
	mov	bx,Qrval		;make word select index
	shl	bx,1			;update parameter data
	mov	ax,xmtbl[bx]
	mov	dsxmax,ax
	mov	ax,ymtbl[bx]
	mov	dsymax,ax
	mov	ax,xatbl[bx]
	mov	dsxar,ax
	mov	ax,yatbl[bx]
	mov	dsyar,ax
;
; special case: if Qpid = CAMM1 AND Qrval = 1600 mm paper size,
;		then pldpti must be halved to 5080, not 10160.
;
	mov	Qcamm,0			;assume it's not the special case
	cmp	Qpid,60			;CAMM-1?
	jnz	diavel			;no
	mov	al,minpc
	sub	ah,ah
	add	ax,7
	cmp	Qrval,ax		;1600 mm sizes?
	jbe	diavel			;no
	mov	pldpti,5079
	mov	plpwid,6
	mov	Qcamm,1			;needed in PLSTART
;
diavel:	RSCMSG	10			;velocity dialog
	CONIN
	sub	ah,ah
	push	ax
	CONOUT				;echo it
	RSCMSG	12			;crlf
	pop	ax
	cmp	al,'T'			;select transparency?
	jz	setLV
	cmp	al,'t'
	jnz	setHV
setLV:	mov	Qvels,offset lvstg	;low velocity for transparencies
	jmp	short velok
SetHV:	mov	Qvels,offset hvstg	;high velocity - normal
velok:	sub	ax,ax			;ax=0: device available for use
	exit
;
;	---------------------------------------------------------------
;	PLSTART - Plotter-Specific start new plot dialog
;
;	CX = desired # of copies
;	---------------------------------------------------------------
;
PLSTART: entry	
	mov	ax,pid
	cmp	Qpid,ax			;qpid = pid?
	je	short pidok
	mov	abflag,1		;no - abort plot
	exit
pidok:	mov	abflag,0		;clear abort flag
	mov	bx,Qrval		;make word select index
	shl	bx,1			;update parameter data
	mov	ax,xmtbl[bx]
	mov	dsxmax,ax
	mov	ax,ymtbl[bx]
	mov	dsymax,ax
	mov	ax,xatbl[bx]
	mov	dsxar,ax
	mov	ax,yatbl[bx]
	mov	dsyar,ax
	mov	si,istbl[bx]
	mov	isptr,si
	call	plstg			;send init string
	mov	si,Qvels
	call	plstg			;send velocity select
	test	Qcamm,1			;special case for 1600 mm?
	jz	psxit			;no
	mov	pldpti,5079
	mov	plpwid,6
psxit:	exit
;
;	---------------------------------------------------------------
;	PLSTAT - Check & return AX = 0=ok/-1 to calcel status
;	---------------------------------------------------------------
;
PLSTAT:	entry
	or	ax,abflag		;return local abort status
	exit
;
;	---------------------------------------------------------------
;	PLCOMP - Plot pass complete
;
;	One pass through all vectors has been completed.  Set AX=0
;	If the plot is done, or set AX=-1 if another pass is needed
;	for multi-copy or banding use.  If complete, finish the
;	plot & perform any cleanup (paper eject/unload, etc).
;	---------------------------------------------------------------
;
PLCOMP:	entry
	mov	si,offset estg		;send ending string
	call	plstg
	cmp	prnum,1			;if 7550 then 
	jnz	id55
	mov	si,offset pgstg		;send PG; string
	call	plstg
id55:	sub	ax,ax			;plot complete
	exit
;
;	---------------------------------------------------------------
;	PLUNLD - end use of the plotter driver
;
;	This will only be called once per program execution
;	before program termination.  It must:
;	1 - restore any interrupt vectors changed by this driver
;	2 - release any allocated buffer memory
;	---------------------------------------------------------------
;
PLUNLD:	entry
	exit
;
;	DSCOLOR - specify current drawing color
;
DSCOLOR: entry
	mov	si,ax			;map color to pen number
	and	si,15
	cmp	si,CurCV		;color changed?
	jnz	plcct	
	jmp	plcxt			;no, exit w/o change
plcct:	mov	bx,prnum
	shl	bx,1
	mov	bx,cmtbl[bx]		;BX is address of cmap_
	cmp	bx,0			;is there only 1 pen?
	jz	plcxt			;yes
	mov	CurCV,si		;
	shl	si,1			;word index
	mov	ax,[bx+si]
	mov	CurClr,ax		;save new color
	test	byte ptr tcenab,1	;turret changing enabled?
	jz	turok
	mov	bx,prnum
	shl	bx,1
	mov	bx,tmtbl[bx]		;BX is address of tmap_
	cmp	bx,0
	jz	turok			;if zero, then no turrent    
	mov	ax,[bx+si]
	cmp	ax,CurTur		;need turret change?
	jz	turok
	mov	CurTur,ax		;yes - save new turret number
	mov	si,offset pback		;put back current pen
	call	plstg
	RSCMSG	11			;turrent change message
	CONIN
	RSCMSG	12			;end of dialog
turok:	mov	si,offset cstg		;select pen color string
	call	plstg
	mov	ax,CurClr		;pen number
	call	pldec
	mov	al,';'			;end of command
	call	plsend
plcxt:	exit
;
;	DSPOINT - draw a single point
;
;	SI = X coordinate
;	DI = Y coordinate
;
DSPOINT: entry
	call	moveto			;move to point location
	mov	si,offset ptstg		;draw a point
	cmp	prnum,4			;if 7220 then it can't use
	jnz	cirok			; "CI1,45" for a point.
	mov	si,offset ptstgx	;7220 point command
cirok:	call	plstg
	exit
;
moveto	proc	near
	mov	dx,si
	mov	ax,di
	cmp	ax,cury			;change in Y?
	jnz	domove
	cmp	dx,curx			;change in X?
	jnz	domove
	ret				;already in place
domove:	cmp	prnum,4			;7220?
	jz	setm2			;yes
	mov	si,offset mstg		;move string
	jmp	short mdcomn
setm2:	mov	si,offset m2stg		;special for 7220
mdcomn:	mov	cury,ax			;save new X,Y
	mov	curx,dx
	call	plstg
	mov	ax,curx			;send X
	test	Qcamm,1			;special case for 1600 mm?
	jz	dnrm			;no
	shl	ax,1			;yes, double it
dnrm:	call	pldec
	mov	al,','			;send comma
	call	plsend
	mov	ax,cury			;send Y
	test	Qcamm,1			;special case for 1600 mm?
	jz	dnrn			;no
	shl	ax,1			;yes, double it
dnrn:	call	pldec
	mov	al,';'			;end command
	call	plsend
	ret
moveto	endp
;
drawto	proc	near
	mov	dx,si
	mov	ax,di
	cmp	ax,cury			;change in Y?
	jnz	dodraw
	cmp	dx,curx			;change in X?
	jnz	dodraw
	ret				;already in place
dodraw:	cmp	prnum,4			;7220?
	jz	setd2			;yes
	mov	si,offset dstg		;draw string
	jmp	short tmdc
setd2:	mov	si,offset d2stg		;special for 7220
tmdc:	call	mdcomn			;draw the line
	ret
drawto	endp
;
	include	 PLSUBS.CPY
;
;	DSCIR - draw circle on screen (will entirely fit)
;
;	AX = center X
;	DX = center Y
;	CX = radius (horizontal)
;
DSCIR:	entry
	exit
;
;	DSARC - draw arc on screen (arc's circle will entirely fit)
;
;	AX = center X
;	DX = center Y
;	CX = radius (horizontal)
;	SI = starting angle (0-1023)
;	DI = ending angle (0-1023)
;
DSARC:	entry
	exit
;
;	----------------- local use procedures ----------------------
;
;	PLSTG - send ASCIIZ string at DS:SI thru ES:DI to plotter
;
PLSTG	proc	near
	mov	ax,DS			;send ASCIIZ string
	mov	ES,ax
	mov	di,si
	mov	dx,13			;using Driver Services
	call	dword ptr DVRSVC
	ret				;characters sent
plstg	endp
;
;	PLDEC - send decimal of AX to plotter
;
PLDEC	proc	near
	mov	dx,15			;AX as decimal ASCII
	call	dword ptr DVRSVC
	ret
pldec	endp
;
;	PLSEND - send character in AL to plotter
;
PLSEND	proc	near
	mov	dx,12
	call	dword ptr DVRSVC
	ret
plsend	endp
;
;	----------------- local data items -------------------------
;
	align	4
DVRSVC	dd	0		;pointer to driver svcs
;
Curx	dw	-1
Cury	dw	-1
CurClr	dw	-1		;current color # (mapped)
CurPat	dw	-1		;current line pattern
CurCV	dw	-1		;current color number (unmapped)
CurTur	dw	1		;current turret number
pscale	dw	45		;16 bit pattern every 3/4" (750/16)
abflag	dw	0		;abort plot flag
tflag	dw	0		;turrent avail
isptr	dw	offset iniP0	;init string
;
cmap2	dw	2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1
tmap2	dw	1,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8
;
cmap6	dw	6,1,2,3,4,5,6,1,2,3,4,5,6,1,2,3
tmap6	dw	1,1,1,1,1,1,1,2,2,2,2,2,2,3,3,3
;
cmap8	dw	8,1,2,3,4,5,6,7,8,1,2,3,4,5,6,7
tmap8	dw	1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2
;
xmtbl	dw	10364,16639,11039,16157,  10169,16449,10869,15969
	dw	  10299,10899,   10299,10899,   15999, 15999
	dw	15599, 22559, 16071, 21151, 31999, 31999, 14039, 18799
	dw	31999, 31999,  7019,  9399
;
ymtbl	dw	 7961,10364, 7220,11039,   7839,10169, 7599,10869
	dw	   7549, 7549,    7549, 7549,    10239, 11399
	dw	10679, 15599,  9975, 16071, 14039, 18799, 31999, 31999
	dw	 7019,  9399, 31999, 31999
;
yatbl	dw	 7961, 2073, 7220,11039,   7839,10169, 7599,10869
	dw	   7549, 7549,    7549, 7549,    16, 57
	dw	  171,   173,   155,   190,   219,   147,   500,   250
	dw	  219,   147,  1000,   500
;
xatbl	dw	10364, 3328,11039,16157,  10169,16449,10869,15969
	dw	  10299,10899,   10299,10899,   25, 80
	dw	  250,   250,   250,   250,   500,   250,   219,   147
	dw	 1000,   500,   219,   147
;
istbl	dw	offset iniP0, offset iniP1, offset iniP0, offset iniP1
	dw	offset iniP4, offset iniP5, offset iniP4, offset iniP5
	dw	offset iniP0, offset iniP0, offset iniP0, offset iniP0
	dw	offset iniPC, offset iniPC
	dw	offset iniDG, offset iniDG, offset iniDG, offset iniDG
	dw	offset iniDG, offset iniDG, offset iniDG, offset iniDG
	dw	offset iniDG, offset iniDG, offset iniDG, offset iniDG
;
cmtbl	dw	offset cmap6, offset cmap8, offset cmap2, offset cmap8
	dw	offset cmap8, offset cmap8
tmtbl	dw	offset tmap6, offset tmap8, offset tmap2, offset tmap8
;	dw	offset tmap8,  0
;
tptbl	dw	10208,10160,10110,10150,10159,10159	;pldpti varies
pidtbl	dw	2,3,4,5,6,16		;plotter id text resource #s
nptbl	dw	6,8,2,8,8,8		;max # pens
pntbl	dw	0,1,2,3,4,5		;logic switch: printer id number
prnum	dw	0
pdevid	dw	25,26,27,28,29,60	;unique plotter device id #
pid	dw	25			;current config dev id #
rdtbl	dw	7,7,8,8,9,17		;plot sizes text resource #s
rdlptr	dw	7			;plot size dialog text rsc #
maxpct	db	3,7,9,11,13,25		;max answer #
maxpc	db	3
minpct	db	0,4,8,10,12,14		;min answer #
minpc	db	0
tcenab	db	0			;turret change enabled
;
iniP0	db	'IN;PS 4;IP;IW;',0	;7475,Asize, 7470, 7440
iniP1	db	'IN;PS 3;IP;IW;',0	;7475,Bsize
iniP4	db	'DF;IP;',0		;7550,Asize
iniP5	db	'DF;IP;',0		;7550,Bsize
iniPC	db	27,'.(IN;',0		;7220
iniDG	db	'DF;IW;',0		;CAMM-1
;
hvstg	db	'VS;',0
lvstg	db	'VS 08;',0
pback	db	'SP 0;',0
cstg	db	'PU;SP ',0
sstg	db	'LT ',0
mstg	db	'PU ',0
dstg	db	'PD ',0
m2stg	db	'PU;PA ',0		;7220 only
d2stg	db	'PD;PA ',0		;7220 only
;
estg	db	'PU;PA0,0;SP 0;',0
pgstg	db	' PG;',0
;
ptstg	db	'CI 1,45;',0
ptstgx	db	'SM+;PR 0,0;SM;PA;',0
sstg0	db	'LT;',0
;
;	---------------- global data items -------------------------
;
plidrn	dw	1		;plotter id text resource #
dsxmax	dw	10364		;# X dots -1
dsymax	dw	7961		;# Y dots -1
dsyar	dw	7961		;aspect ratio Y/X
dsxar	dw	10364
pldpti	dw	10208		;# of dots per 10 inches
plnpens	dw	6		;# of plotter pens
plpwid	dw	12		;pen width in horizontal lines
plflags	dw	5000H		;need pen sorting, supports plot to file
ptft1	db	'HPG'		;plot to full file type
ptft2	db	'HPG'		;plot to image file type
port	dw	0		;destination port # 0..N
dest	dw	1		;config destination # 0..N (COM1)
idata	dw	00E7H		;init 9600-N-2-8
	dw	0,0,0,0,0	;reserved
;
PLQDTA	dw	8		;# bytes of PLOTQ data
Qpid	dw	0		;PLOTQ stored pid value
Qrval	dw	0		;plot size picked
Qvels	dw	offset hvstg	;velocity string
Qcamm	dw	0		;flag for CAMM-1 resolution reduction
;
;	---------------- Plot Driver Text Resources ----------------
;
PLRSC	dw	17		;# of resources provided
	dw	offset plid	;1=generic plotter ID
	dw	offset plid0	;2=7475 plotter ID
	dw	offset plid1	;3=7550 plotter ID
	dw	offset plid2	;4=7470 plotter ID
	dw	offset plid3	;5=7440 plotter ID
	dw	offset plid4	;6=7220 plotter ID
	dw	offset sizq1	;7=4 size selection,A&B
	dw	offset sizq2	;8=2 size selection,A
	dw	offset sizq3	;9=2 size selection,B
	dw	offset velqiz	;10=velocity quiz
	dw	offset tchg	;11=change turrent message
	dw	offset diaend	;12=cr/lf
ccrlf	dw	offset crlf	;13=cr/lf for DEVCFG
tcqz	dw	offset asktc	;14=turrent quiz
prsl	dw	offset prntsl	;15=plotter choices
	dw	offset plid5	;16=CAMM-1 sign maker ID
	dw	offset sizq4	;17=8 size selection
;
plid	db	'HP small-bed pen plotters.',0
plid0	db	'HP 7475 (IBM 7372) 6-pen plotter:',0
plid1	db	'HP 7550 (IBM 6182) 8-pen plotter:',0
plid2	db	'HP 7470 (IBM 7371) 2-pen plotter:',0
plid3	db	'HP 7440 (IBM 6180) 8-pen plotter:',0
plid4	db	'HP 7220 8-pen plotter:',0
plid5	db	'Roland (PNC-1000) CAMM-1 Sign Maker:',0
;
sizq1	db	13
	db	'  1 -  A size (8.5"x11"),',13
	db	'  2 -  B size (11"x17"),',13
	db	'  3 - A4 size (210x297mm),',13
	db	'  4 - A3 size (297x420mm)',13
	db	13,'Select paper size  1..4[1]: ',0
;
sizq2	db	13
	db	'  1 -  A size (8.5"x11"),',13
	db	'  2 - A4 size (210x297mm),',13
	db	13,'Select paper size  1..2[1]: ',0
;
sizq3	db	13
	db	'  1 -  B size (11"x17"),',13
	db	'  2 - A3 size (285x400mm),',13
	db	13,'Select paper size  1..2[1]: ',0
;
sizq4	db	13
	db	' Key -  Mode     Media (mm)  Plot (mm) ',13
	db	'  1  -  ISO A3   420 x 297   390 x 267,',13
	db	'  2  -  ISO A2   594 x 420   564 x 390,',13
	db	'  3  -  ANSI B   431 x 297   401 x 267,',13
	db	'  4  -  ANSI C   558 x 431   528 x 401,',13
	db	'  5  -  EXP -X   830 x 381   800 x 351,',13
	db	'  6  -  EXP -X   830 x 500   800 x 470,',13
	db	'  7  -  FREE-Y   381 x 830   351 x 800,',13
	db	'  8  -  FREE-Y   500 x 830   470 x 800,',13
	db	'  9  -  EXP -X  1630 x 381  1600 x 351,',13
	db	' 10  -  EXP -X  1630 x 500  1600 x 470,',13
	db	' 11  -  FREE-Y   381 x1630   351 x1600,',13
	db	' 12  -  FREE-Y   500 x1630   470 x1600,',13
	db	13,'Select paper size  1..12[1]: ',0
;
velqiz	db	13,'Transparency or Normal paper T[N]: ',0
tchg	db	13,'Change pen turret if desired, then press RETURN',0
diaend	db	13,0
;
crlf	db	13,10,'$'
asktc	db	13,10,'Turret changing desired Y[N]: $'
prntsl	db	13,10,'Supported plotters:',13,10,13,10
	db	'  1 - HP 7475 (IBM 7372) 6-pen plotter.',13,10
	db	'  2 - HP 7550 (IBM 6182) 8-pen plotter.',13,10
	db	'  3 - HP 7470 (IBM 7371) 2-pen plotter.',13,10
	db	'  4 - HP 7440 (IBM 6180) 8-pen plotter.',13,10
	db	'  5 - HP 7220 8-pen plotter.',13,10
	db	'  6 - Roland (PNC-1000) CAMM-1 Sign Maker.',13,10
	db	13,10,'Select your plotter 1..6[1]: $'
;
	include	PLLAST.CPY
