;	PL7585.ASM - plotter driver for HP 7570,7580,7585(86)
;		     7595(96), & DXL/EXL
;
;	(c) Copyright 1986 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle  5/25/1986
;	modified for driver toolkit 8/16/86
;	added DSCIR/DSARC/DSPOLY/plpwid 1/11/87 MR
;	added auto-paper-sizing 2/13/87 MR
;	modified for rev 4 drivers 3/23/87
;	added auto/manual size, turret change options 4/10/87 MR
;	new .BIN driver format and added other models 01/10/89 SB
;	devrev=1: added DXL & EXL models 06/23/89 SB
;	devrev=2: added clones and compatibles 09/22/89 SB
;	devrev=3: added ESC codes for Xon/Xoff & Hardwire 11/02/89 SB
;	devrev=4: turned DSCIR/DSARC on 2/09/90 SB
;
	name	PL7585
;
devrev	equ	4			;driver code revision #
cfgctl	equ	0000Eh			;port,dest,devcfg
dstmsk	equ	0FFFFh			;all destinations valid
;	this driver supports PID values 30..34
;
	include	PLDRV.CPY
;
;	DSCIR/DSARC now in use - only works with solid lines
;
;	---------------------------------------------------------------
;	DEVCFG - Select Turrent changing, Roll Feed  desired or not
;	(All CONIN/CONOUT must use DOS functions)
;	---------------------------------------------------------------
;
DEVCFG:	entry
	mov	asenab,0		;assume no paper sizing
	mov	mxenab,0		;assume not Metric sizes
	mov	tcenab,0		;assume no turret changing
	mov	c16flg,0		;assume no 16-color machines
	mov	Qrlfd,0			;assume no roll feed mode
psagn:	mov	dx,prsl			;select plotter message
	mov	ah,9
	int	21H
	mov	ah,7			;get key
	int	21H
	push	ax			;echo choice
	mov	dl,al
	mov	ah,2
	int	21H
	pop	ax
	cmp	al,3			;^C?
	jnz	noabt2
	mov	abflag,1
	exit
noabt2:	cmp	al,13			;CR?
	jz	short dfltpt
	sub	al,'1'			;range 0..5
	jl	dfltpt
	cmp	al,5
	ja	dfltpt
	jmp	short okptp
dfltpt:	mov	al,3			;CR default is 7595
okptp:	mov	bl,al			;setup parameters
	sub	bh,bh
	mov	prnum,bx		;prog logic id #
;
	mov	dx,apsl			;ask if auto paper sizing
	mov	ah,9
	int	21H
	mov	ah,7			;get key response
	int	21H
	push	ax			;echo choice
	mov	dl,al
	mov	ah,2
	int	21H
	pop	ax
	cmp	al,'1'			;answer US?
	jz	doUS			;yes
	cmp	al,'2'			;answer Met?
	jz	doMet			;yes
	cmp	al,'3'			;automatic?
	jz	doAT			;yes
doUS:	jmp	short acexit		;enabled U.S. sizes
doMet:	mov	mxenab,1		;enable metric sizes
	jmp	short acexit
doAT:	mov	asenab,1		;enable auto paper sizing
;
acexit:	mov	bx,prnum
	test	mxenab,1		;metric version?
	jz	usaok
	add	bx,6			;yes - indexes for metrics
usaok:	mov	al,maxpct[bx]		;max resolution choice #
	mov	maxpc,al
	mov	al,minpct[bx]		;min resolution choice #
	mov	minpc,al
	shl	bx,1			;desired resolution prompt
	mov	ax,rdtbl[bx]		;resolution dialog prompt #
	mov	rdlptr,ax
	mov	ax,pidtbl[bx]		;printer id rsc.
	mov	plidrn,ax
	mov	ax,pdevid[bx]		;device id #
	mov	pid,ax
	mov	qpid,ax
	mov	dx,crlf			;crlf to end dialog
	mov	ah,9
	int	21H
;
	mov	dx,askl			;turrent change enabled?
	mov	ah,9
	int	21H
	mov	ah,7			;get key response
	int	21H
	push	ax			;echo choice
	mov	dl,al
	mov	ah,2
	int	21H
	pop	ax
	cmp	al,3			;^C?
	jnz	noabt3
	mov	abflag,1
	exit
noabt3:	cmp	al,'Y'			;answer Y?
	jz	dotchg
	cmp	al,'y'
	jnz	tcexit
dotchg:	mov	tcenab,1		;enable turrent changing
tcexit:	mov	dx,crlf			;append crlf
	mov	ah,9
	int	21H
;
	mov	ax,prnum		;if prnum = 2, 3, or 5
	cmp	ax,0			; then ask roll feed quiz
	jz	rfexit
	cmp	ax,1
	jz	rfexit
	cmp	ax,4
	jz	rfexit
	mov	dx,rfqz			;roll feed desired?
	mov	ah,9
	int	21H
	mov	ah,7			;get key response
	int	21H
	push	ax			;echo choice
	mov	dl,al
	mov	ah,2
	int	21H
	pop	ax
	cmp	al,3			;^C?
	jnz	noabt4
	mov	abflag,1
	exit
noabt4:	cmp	al,'Y'			;answer Y?
	jz	dorfd
	cmp	al,'y'
	jnz	rfexit
dorfd:	mov	Qrlfd,1			;enable roll feed mode
rfexit:	mov	dx,crlf			;append crlf
	mov	ah,9
	int	21H
;
	cmp	prnum,5			;is it the "compatibles" pick?
	jz	docm16			;yes
	jmp	notc16			;no
docm16:	mov	dx,ask16		;does it have 16-color capability?
	mov	ah,9
	int	21H
	mov	ah,7			;get key response
	int	21H
	push	ax			;echo choice
	mov	dl,al
	mov	ah,2
	int	21H
	pop	ax
	cmp	al,3			;^C?
	jnz	noabt5
	mov	abflag,1
	exit
noabt5:	cmp	al,'Y'			;answer Y?
	jz	docmap
	cmp	al,'y'
	jnz	cexit
docmap:	mov	c16flg,1		;16-colors enabled
cexit:	mov	dx,crlf			;append crlf
	mov	ah,9
	int	21H
;
notc16:	mov	dx,crlf			;append crlf
	mov	ah,9
	int	21H
	exit
;
;	---------------------------------------------------------------
;	PLLOAD - load initialization of the plotter driver
;	PFLOAD - load plotter driver - no port init (Plot to File)
;
;	This will only be called once per program execution
;	before any other display driver calls.  It must:
;	1 - test for correct plotter hardware available
;	2 - allocate any required buffer memory from DOS
;	3 - perform global & local variable initialization
;	4 - initialize the plotter hardware
;	5 - set AX=error code:
;	    0=ok
;	    1=not enough memory
;	    2=not enough EMM memory
;	    3=device unavailable/unuseable
;	---------------------------------------------------------------
;
PFLOAD:	entry
	mov	word ptr DVRSVC,di	;save pointer to driver services
	mov	word ptr DVRSVC+2,ES
	mov	dx,11			;init destination for PTF
	mov	cx,0
	call	dword ptr DVRSVC	;do it
	jmp	short ldcom
PLLOAD:	entry
	mov	word ptr DVRSVC,di	;save pointer to driver services
	mov	word ptr DVRSVC+2,ES
	mov	dx,11			;init for configured destination
	mov	cx,dest
	mov	ax,idata
	mov	bx,port
	call	dword ptr DVRSVC	;do it
ldcom:	sub	ax,ax			;ax=0: device available for use
	exit
;
;	---------------------------------------------------------------
;	PLOTQ - Ask any Plot-specific questions
;
;	All answers are stored in the PLQDTA area
;	DSXMAX table data must be valid after PLOTQ
;	---------------------------------------------------------------
;
PLOTQ:	entry
	mov	ax,pid			;save pid in qdata area
	mov	qpid,ax
	mov	abflag,0		;clear abort flag
	mov	CurTur,0		;init need turret change
	test	byte ptr asenab,1	;auto paper sizing
	jnz	aps
noapsj:	jmp	noaps
aps:	RSCMSG	15			;auto mode message
	CONIN				;CR to continue...
	mov	ah,3			;any junk chr in buffer?
	mov	dx,port
	int	14H
	test	ah,1
	jz	nodav
	mov	ah,2			;read junk chr to clear it
	mov	dx,port
	int	14H
	cmp	dest,1			;is Hardwire H.S. required?
	jnz	aps2			;no
	mov	si,offset HWstg		;yes, send esc codes for 
	call	plstg			;H.W.H.S. first
aps2:	cmp	dest,2			;is Xon/Xoff required?
	jnz	nodav			;no
	mov	si,offset XXstg		;yes, send esc code for 
	call	plstg			;Xon/Xoff first
nodav:	mov	si,offset rdhcl		;read hard clip limits
	call	plstg
	mov	si,offset bfr		;point to read buffer
nxinp:	push	si
	mov	dx,23			;read plotter data
	call	dword ptr DVRSVC
	jc	short noaps		;error: use normal paper sizing
	pop	si			;store it
	mov	[si],al
	inc	si
	cmp	al,13			;CR?
	jnz	nxinp
	mov	si,offset bfr		;get max X value (1/2 scale)
	call	SCNDEC
	mov	bx,ax			;save it
	call	SCNDEC			;get max y value
	jmp	pscom			;continue paper sizing
;
noaps:	RSCMSG	rdlptr			;paper size selection
	CONIN				;get answer
	cmp	al,3			;ctl-C?
	jnz	noabt1
	mov	abflag,-1
	exit
noabt1:	CONOUT				;echo it
	sub	al,'1'			;range minpc..maxpc
	add	al,minpc
	cmp	al,minpc
	jl	usedfv
	cmp	al,maxpc
	jbe	usersl
usedfv:	mov	al,minpc		;default is minpc (smallest)
usersl:	sub	ah,ah			;save paper pick
	push	ax
	mov	ax,13			;end dialog
	CONOUT
	pop	si			;make word select index
	shl	si,1			;update parameter data
	mov	bx,xmtbl[si]		;get size max values
	mov	ax,ymtbl[si]
pscom:	mov	Qistg,offset istgn	;assume normal x/y
	cmp	ax,bx			;if maxy>maxx then
	jle	norot
	xchg	ax,bx			;rotate plot 90 degrees
	mov	Qistg,offset istgr
norot:	mov	dsxmax,bx		;save rot/normal init
	mov	qxmax,bx		;and max values
	mov	dsymax,ax
	mov	qymax,ax
	shr	bx,1			;get half values
	shr	ax,1
	mov	xofst,bx
	mov	yofst,ax
	shr	bx,1			;get approx aspect ratios
	shr	ax,1
	mov	dsxar,bx
	mov	dsyar,ax
	RSCMSG	16			;velocity dialog
	CONIN
	sub	ah,ah
	push	ax
	CONOUT				;echo it
	RSCMSG	18			;crlf
	pop	ax
	cmp	al,'T'			;select transparency?
	jz	setLV
	cmp	al,'t'
	jnz	setHV
setLV:	mov	Qvels,offset lvstg	;low velocity for transparencies
	jmp	short velok
SetHV:	mov	Qvels,offset hvstg	;high velocity - normal
velok:	sub	ax,ax			;ax=0: device available for use
	exit
;
;	---------------------------------------------------------------
;	PLSTART - Plotter-Specific start new plot dialog
;
;	CX = desired # of copies
;	---------------------------------------------------------------
;
PLSTART: entry
	mov	ax,pid			;qpid = pid?
	cmp	qpid,ax
	je	short pidok
	mov	abflag,1		;no - abort plot
	exit
pidok:	mov	bx,qxmax		;recover PLOTQ answers
	mov	ax,qymax
	mov	dsxmax,bx		;and max values
	mov	dsymax,ax
	shr	bx,1			;get half values
	shr	ax,1
	mov	xofst,bx
	mov	yofst,ax
	shr	bx,1			;get approx aspect ratios
	shr	ax,1
	mov	dsxar,bx
	mov	dsyar,ax
	cmp	dest,1			;is Hardwire H.S. required?
	jnz	chk2			;no
	mov	si,offset HWstg		;yes, send esc codes for 
	call	plstg			;H.W.H.S. first
chk2:	cmp	dest,2			;is Xon/Xoff required?
	jnz	inndp			;no
	mov	si,offset XXstg		;yes, send esc code for 
	call	plstg			;Xon/Xoff first
inndp:	mov	si,Qistg		;send init string
	call	plstg
	test	Qrlfd,1			;if roll feed 
	jz	sndqs			;then
	mov	si,offset rfstg		;send  EC;
	call	plstg
sndqs:	mov	si,Qvels		;send velocity select
	call	plstg
	mov	abflag,0		;clear abort flag
	exit
;
;	---------------------------------------------------------------
;	PLSTAT - Check & return AX = 0=ok/-1 to calcel status
;	---------------------------------------------------------------
;
PLSTAT:	entry
	or	ax,abflag		;return local abort status
	exit
;
;	---------------------------------------------------------------
;	PLCOMP - Plot pass complete
;
;	One pass through all vectors has been completed.  Set AX=0
;	If the plot is done, or set AX=-1 if another pass is needed
;	for multi-copy or banding use.  If complete, finish the
;	plot & perform any cleanup (paper eject/unload, etc).
;	---------------------------------------------------------------
;
PLCOMP:	entry
	test	Qrlfd,1			;if roll feed 
	jz	nendp			; then
	mov	si,offset endstr	;   send ending string w/ AF;
	jmp	short xmend		; else
nendp:	mov	si,offset endstn	;   send ending string w/ NR;
xmend:	call	plstg
	sub	ax,ax			;plot complete
	exit
;
;	---------------------------------------------------------------
;	PLUNLD - end use of the plotter driver
;
;	This will only be called once per program execution
;	before program termination.  It must:
;	1 - restore any interrupt vectors changed by this driver
;	2 - release any allocated buffer memory
;	---------------------------------------------------------------
;
PLUNLD:	entry
	exit
;
;	DSCOLOR - specify current drawing color
;
DSCOLOR: entry
	mov	si,ax			;map color to pen number
	and	si,15
	cmp	si,CurCV		;color changed?
	jz	plcxt			;no, exit w/o change
	mov	CurCV,si		;yes
	shl	si,1			;word index
	test	c16flg,1		;16-colors?
	jz	doc8			;no
	mov	ax,cmap16[si]		;yes - use this map
	jmp	short doc16
doc8:	mov	ax,cmap[si]
doc16:	mov	CurClr,ax		;save new color
	test	byte ptr tcenab,1	;turret changing enabled?
	jz	turok
	mov	ax,tmap[si]		;need turret change?
	cmp	ax,CurTur
	jz	turok
	mov	CurTur,ax		;yes - save new turret number
	mov	si,offset pback		;put back current pen
	call	plstg
	RSCMSG	17			;turrent change message
	CONIN
	RSCMSG	18			;end of dialog

turok:	mov	si,offset cstg		;select pen color string
	call	plstg
	mov	ax,CurClr		;pen number
	call	pldec
	mov	al,';'			;end of command
	call	plsend
plcxt:	exit
;
;	DSPOINT - draw a single point
;
;	SI = X coordinate
;	DI = Y coordinate
;
DSPOINT: entry
	call	moveto			;move to point location
	mov	si,offset ptstg		;draw a point
	call	plstg
	exit
;
moveto	proc	near
	mov	dx,si
	mov	ax,di
	cmp	ax,cury			;change in Y?
	jnz	domove
	cmp	dx,curx			;change in X?
	jnz	domove
	ret				;already in place
domove:	mov	si,offset mstg		;move string
mdcomn:	mov	cury,ax			;save new X,Y
	mov	curx,dx
	call	plstg
	mov	ax,curx			;send X,Y coordinate
	mov	dx,cury
	call	SENDXY
	mov	al,';'			;end command
	call	plsend
	ret
moveto	endp
;
drawto	proc	near
	mov	dx,si
	mov	ax,di
	cmp	ax,cury			;change in Y?
	jnz	dodraw
	cmp	dx,curx			;change in X?
	jnz	dodraw
	ret				;already in place
dodraw:	mov	si,offset dstg
	call	mdcomn			;draw the line
	ret
drawto	endp
;
	include	PLSUBS.CPY
;
;	DSCIR - draw circle on screen (will entirely fit)
;
;	AX = center X
;	DX = center Y
;	CX = radius (horizontal)
;
DSCIR:	entry
	cmp	CurPat,-1		;use this only if style=solid line
	jz	cirok
	exit
cirok:	push	cx			;save radius
	mov	si,ax
	mov	di,dx
	call	moveto			;move to center of circle
	lea	si,circ			;circle command
	call	plstg
	pop	ax			;radius
	shl	ax,1			;correct for 0.5 scaled coordinates
	call	pldec
	mov	al,';'			;end command
	call	plsend
	exit
;
;	DSARC - draw arc on screen (arc's circle will entirely fit)
;
;	AX = center X
;	DX = center Y
;	CX = radius (horizontal)
;	SI = starting angle (0-1023)
;	DI = ending angle (0-1023)
;
DSARC:	entry
	cmp	CurPat,-1		;use this only if style=solid line
	jz	arcok
	exit
arcok:	and	si,3FFH			;range limit bearing angles
	and	di,3FFH
	sub	di,si			;calc arc width
	jg	awok
	add	di,1024			;if neg, add 360 degrees
awok:	push	di			;save arc width
	push	ax			;save X & Y for arc cmd
	push	dx
	push	ax			;save X & Y for sp calc
	push	dx
	push	si			;save start and rad for sp calc
	push	cx
	mov	bx,si			;DeltaY=Radius*SIN(StartAng)
	mov	ax,cx
	call	ISIN
	mov	bp,dx			;hold DeltaY in BP
	pop	ax			;DeltaX=Radius*COS(StartAng)
	pop	bx
	call	ICOS			;DX = DeltaX
	pop	ax			;start Y ->BP
	add	bp,ax
	pop	ax			;Start X ->DX
	add	dx,ax
	mov	si,dx			;SI,DI = move to point
	mov	di,bp
	call	moveto			;move to arc start
	lea	si,arc1			;arc command
	call	plstg
	pop	dx			;center X,Y
	pop	ax
	call	SENDXY
	mov	al,','			;arc width
	call	plsend
	pop	ax			;angle width
	call	PLANG
	mov	al,';'			;end command
	call	plsend
	mov	curx,-1			;flag next move required
	exit
;
;	----------------- local use procedures ----------------------
;
;	PLSTG - send ASCIIZ string at DS:SI thru ES:DI to plotter
;
PLSTG	proc	near
	mov	ax,DS			;send ASCIIZ string
	mov	ES,ax
	mov	di,si
	mov	dx,13			;using Driver Services
	call	dword ptr DVRSVC
	ret				;characters sent
plstg	endp
;
;	PLDEC - send decimal of AX to plotter
;
PLDEC	proc	near
	mov	dx,15			;AX as decimal ASCII
	call	dword ptr DVRSVC
	ret
pldec	endp
;
;	PLANG - Send angle 0..1023 as degrees 360.00
;
PLANG	proc	near
	and	ax,1023
	mul	k3600			;scale
	div	k1024
	sub	dx,dx			;mark end
	push	dx
	mov	bp,20h			;space delimiter
	push	bp
	mov	bp,1			;first flag
alup1:	sub	dx,dx			;get digit
	mov	bx,10
	div	bx
	add	dx,48			;convert to ASCII
	push	dx
	cmp	bp,1			;need decimal point?
	jnz	short adpok
	mov	bp,2Eh			;yes
	push	bp
	mov	bp,0			;flag dp used
adpok:	cmp	ax,0			;end of conversion?
	jnz	short alup1
alup2:	pop	ax			;get character
	cmp	ax,0			;end of number?
	jz	short axt
	call	PLSEND			;no - send character
	jmp	short alup2
axt:	ret
plang	endp
;
;	PLSEND - send character in AL to plotter
;
PLSEND	proc	near
	mov	dx,12
	call	dword ptr DVRSVC
	ret
plsend	endp
;
;	SENDXY send AX,DX (X,Y) coordinate
;
SENDXY	proc	near
	push	dx			;save Y
	sub	ax,xofst		;correct for center origin
	shl	ax,1			;correct for 0.5 scaled coord.
	jge	cpdec
	push	ax
	mov	al,'-'
	call	plsend
	pop	ax
	not	ax
cpdec:	call	pldec
	mov	al,','			;send comma
	call	plsend
	pop	ax			;send Y
	sub	ax,yofst		;correct for center origin
	shl	ax,1			;correct for 0.5 scaled coord.
	jge	cpdec2
	push	ax
	mov	al,'-'
	call	plsend
	pop	ax
	not	ax
cpdec2:	call	pldec
	ret
sendxy	endp
;
;	SCNDEC - Scan decimal # from ASCII string at SI
;
SCNDEC	proc	near
	cld
	sub	dx,dx		;clear buffer
nxscd:	lodsb			;get chr
	cmp	al,'-'		;ignore - sign
	jz	nxscd
	cmp	al,'0'		;digit?
	jb	scnxt
	cmp	al,'9'
	jbe	isdgt
scnxt:	mov	ax,dx		;result in AX
	ret
isdgt:	and	ax,000FH	;make digit binary
	shl	dx,1		;bfr*10+digit
	mov	cx,dx
	shl	dx,1
	shl	dx,1
	add	dx,cx
	add	dx,ax
	jmp	nxscd		;get next digit
scndec	endp
;
;	----------------- local data items -------------------------
;
	align	4
DVRSVC	dd	0			;pointer to driver svcs
xofst	dw	2250			;origin offset to plotter
yofst	dw	1385
k3600	dw	3600			;arc scaling constants
k1024	dw	1024
CurClr	dw	-1			;current color #
CurCV	dw	-1			;current color number (unmapped)
CurPat	dw	0FFFFH			;current line pattern
pscale	dw	23			;16 bit pattern every 3/4" (375/16)
;
;	sizes =   A     B     C     D     E     F
xmtbl	dw	10576,16192,11592,17208			;7570-US
	dw	 3238, 7556,10096,16192			;7580-US
	dw	 2990, 7300, 7290,15910,21040,20250	;7585-US
	dw	 4948, 7516,10536,16152,21232,20250	;7595-US
	dw	 4507, 7555,10095,16191,21271		;EXL -ENG
	dw	       8063,11111,17207,23303		;EXL -ARCH
	dw	 4268, 8768, 8768,17768,23060		;HPGL -ENG
	dw	            11280,15740			;7570-MET
	dw	 3120, 7320,10800,15740			;7580-MET
	dw	 2900, 6980, 7074,15320,22390 		;7585-MET
	dw	 5300, 7280,11240,15700,22660		;7595-MET
	dw	 4859, 7319,10799,15719,22679		;EXL -MET
	dw	      16119,23229,11719,24519		;EXL -XMET
	dw	 4164, 8540, 8540,17308,24560		;HPGL -MET
;
ymtbl	dw	7556,10576, 8064,11592			;7570-US
	dw	4988, 4988, 8036,10576			;7580-US
	dw	4700, 4700,10275,10260,16380,14500	;7585-US
	dw	3198, 4948, 7516,10536,16632,14500	;7595-US
	dw	3717, 4987, 8035,10575,16671		;EXL -ENG
	dw	      5495, 8543,11591,17687		;EXL -ARCH
	dw	5600, 5600,11412,11412,17768		;HPGL -ENG
	dw	            7320,11280			;7570-MET
	dw	5340, 5340, 7800,11280			;7580-MET
	dw	5030, 5030,10984,10960,15940		;7585-MET
	dw	3080, 5300, 7280,11240,16180		;7595-MET
	dw	3599, 5339, 7799,11279,16199		;EXL -MET
	dw	     11599,15599, 8399,17399		;EXL -XMET
	dw	5976, 5976,12164,12164,17308		;HPGL -MET
;
;
pidtbl	dw	 2, 3, 4, 5, 6,24,  2, 3, 4, 5, 6,24	;prntr id text rsc #s
prnum	dw	 5
pdevid	dw	30,31,32,33,34,34, 30,31,32,33,34,34	;unique pltr dev id #
pid	dw	33					;curr config dev id #
rdtbl	dw	 7, 8, 9, 9,10,25, 11,12,13,13,14,26	;resolu text rsc #s
rdlptr	dw	 9					; "  dialog txt rsc #
maxpct	db	 3, 7,13,19,28,33, 35,39,44,49,58,63	;max answer #
maxpc	db	19
minpct	db	 0, 4, 8,14,20,29, 34,36,40,45,50,59	;min answer #
minpc	db	14
;
	even
cmap16	dw	0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
cmap	dw	8,1,2,3,4,5,6,7,8,1,2,3,4,5,6,7
tmap	dw	2,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2
;
CurTur	dw	0		;current turret number
abflag	dw	0		;abort flag
c16flg	dw	0		;16-color flag
curx	dw	-1
cury	dw	-1
;
asenab	db	0		;auto paper sizing not enabled
mxenab	db	0		;metric sizes not enabled
tcenab	db	0		;turret change not enabled
;
rdhcl	db	'OH;',0		;read hard clip limits
bfr	db	36 dup ('$')	;HCL read buffer
;
rfstg	db	'EC;',0
istgr	db	'IP;RO 90;',0
istgn	db	'IP;RO 00;',0
hvstg	db	'VS;',0
lvstg	db	'VS 08;',0
endstn	db	'PU;SP 0;NR;',0
endstr	db	'PU;SP 0;AF;',0
pback	db	'SP 0;',0
cstg	db	'PU;SP ',0
sstg	db	'LT ',0
mstg	db	'PU ',0
dstg	db	'PD ',0
ptstg	db	'CI 1,45;',0
sstg0	db	'LT;',0
circ	db	'CI ',0
arc1	db	'PD;AA',0
xxstg	db	27,'.(;',27,'.P1:IN;',0
hwstg	db	27,'.(;',27,'.@;3:IN;',0
;
;	---------------- global data items --------------------
;
plidrn	dw	1		;plotter id text resource #
dsxmax	dw	4499		;# X dots -1
dsymax	dw	2789		;# Y dots -1
dsyar	dw	28		;aspect ratio Y/X
dsxar	dw	45
pldpti	dw	5083		;# of dots per 10 inches
plnpens	dw	8		;# of pens
plpwid	dw	6		;pen width in horiz lines
plflags	dw	7003H		;pen sort, plot to file, circs, arcs
ptft1	db	'HPG'		;plot to full file type
ptft2	db	'HPG'		;plot to image file type
port	dw	0		;destination port # 0..N 
dest	dw	1		;config destination # 0..N (COM1)
idata	dw	00E7H		;init 9600-N-2-8
	dw	0,0,0,0,0	;reserved
;
PLQDTA	dw	12		;#bytes of PLOTQ data
qpid	dw	0		;PLOTQ stored pid value
qxmax	dw	0		;PLOTQ paper size
qymax	dw	0
qistg	dw	0		;PLOTQ init string
qvels	dw	0		;PLOTQ velocity
qrlfd	dw	0		;roll feed init flag
;
;	----------------- Plot Driver Text Resources -----------------
;
PLRSC	dw	27		;# of resources provided
	dw	offset plid	;1=generic plotter ID
	dw	offset plid0	;2=7570 ID
	dw	offset plid1	;3=7580 ID
	dw	offset plid2	;4=7585 ID
	dw	offset plid3	;5=7595 ID
	dw	offset plid4	;6=DXL/EXL ID
	dw	offset us70	;7=7570 US sizes
	dw	offset us80	;8=7580 US sizes
	dw	offset us85	;9=7585,95 US sizes
	dw	offset usxl	;10=DXL/EXL US sizes
	dw	offset mt70	;11=7570 DIN sizes
	dw	offset mt80	;12=7580 DIN sizes
	dw	offset mt85	;13=7585,95 DIN sizes
	dw	offset mtxl	;14=DXL/EXL DIN sizes
	dw	offset dlog 	;15=auto paper dialog
	dw	offset vlqz	;16=velocity quiz
	dw	offset tchg	;17=change turrent msg
	dw	offset dend	;18=cr/lf
prsl	dw	offset pltl	;19=plotter selection quiz
apsl	dw	offset aptl	;20=media selects
askl	dw	offset askp	;21=turrent quiz
crlf	dw	offset crfl	;22=cr/lf for DEVCFG
rfqz	dw	offset askrf	;23=roll-feed mode quiz
	dw	offset plid5	;24=HPGL-comp ID
	dw	offset usgr	;25=HPGL-comp US sizes
	dw	offset mtgr	;26=HPGL-comp DIN sizes
ask16	dw	offset askc16	;27=16-color quiz
;
plid	db	'Hewlett-Packard large format plotters.',0
plid0	db	'HP 7570 (IBM 6184) 8-pen plotter:',0
plid1	db	'HP 7580 (IBM 7374) 8-pen plotter:',0
plid2	db	'HP 7585,86 (IBM 7375) 8-pen plotter:',0
plid3	db	'HP 7595,96 (IBM 6186) 8-pen plotter:',0
plid4	db	'HP DraftPro DXL/EXL 8-pen plotter:',0
plid5	db	'HPGL compatible large format plotter:',0
;
dlog	db 	'Put paper in plotter,',13
	db	'press plotter HOLD and REMOTE buttons,',13
	db	'then press RETURN key to continue.',13,0
vlqz	db 	'Transparency or Normal paper T[N]: ',0
tchg	db 	'Change pen turret if desired, then press RETURN',0
dend	db 	13,0
;
US70	db	13,'key - paper size  - long edge along platen?',13
	db	'  1 -  17x22 inch (Eng C)    Yes',13
	db	'  2 -  22x34 inch (Eng D)     No',13
	db	'  3 -  18x24 inch (Arch C)   Yes',13
	db	'  4 -  24x36 inch (Arch D)    No',13
	db	13,'Select paper size 1..4[1]: ',0
;
US80	db	13,'key -  paper size  - long edge along platen?',13
	db	'  1 -  8.5x11 inch (Eng A)    Yes',13
	db	'  2 -   11x17 inch (Eng B)     No',13
	db	'  3 -   17x22 inch (Eng C)     No',13
	db	'  4 -   22x34 inch (Eng D)     No',13
	db	13,'Select paper size 1..4[1]: ',0
;
US85	db	13,'key -  paper size  - long edge along platen?',13
	db	'  1 -   8.5x11 inch (Eng A)   Yes',13
	db	'  2 -    11x17 inch (Eng B)    No',13
	db	'  3 -    17x22 inch (Eng C)   Yes',13
	db	'  4 -    22x34 inch (Eng D)    No',13
	db	'  5 -    34x44 inch (Eng E)    No',13
	db	'  6 -    30x42 inch (Eng F)    No',13
	db	13,'Select paper size 1..6[1]: ',0
;
USXL	db	13,'key -  paper size (normal orientation)',13
	db	'  1 -   8.5x11 inch (Eng A) ',13
	db	'  2 -    11x17 inch (Eng B) ',13
	db	'  3 -    17x22 inch (Eng C) ',13
	db	'  4 -    22x34 inch (Eng D) ',13
	db	'  5 -    34x44 inch (Eng E) ',13
	db	'  6 -    12x18 inch (Arch B) ',13
	db	'  7 -    18x24 inch (Arch C) ',13
	db	'  8 -    24x36 inch (Arch D) ',13
	db	'  9 -    36x48 inch (Arch E) ',13
	db	13,'Select paper size 1..9[1]: ',0
;
USGR	db	13,'key -  paper size  -  long edge along platen?',13
	db	'  1 -   8.5x11 inch (Eng A)    Yes',13
	db	'  2 -    11x17 inch (Eng B)     No',13
	db	'  3 -    17x22 inch (Eng C)    Yes',13
	db	'  4 -    22x34 inch (Eng D)     No',13
	db	'  5 -    34x44 inch (Eng E)     No',13
	db	13,'Select paper size 1..5[1]: ',0
;
MT70	db	13,'key -  paper size   -  long edge along platen?',13
	db	'  1 -   420x594 mm (Din A2)     Yes',13
	db	'  2 -   594x841 mm (Din A1)      No',13
	db	13,'Select paper size 1..2[1]: ',0
;
MT80	db	13,'key -  paper size   - long edge along platen?',13
	db	'  1 -   210x297 mm (Din A4)    Yes',13
	db	'  2 -   297x420 mm (Din A3)     No',13
	db	'  3 -   420x594 mm (Din A2)     No',13
	db	'  4 -   594x841 mm (Din A1)     No',13
	db	13,'Select paper size 1..4[1]: ',0
;
MT85	db	13,'key -  paper size   - long edge along platen?',13
	db	'  1 -   210x 297 mm (Din A4)   Yes',13
	db	'  2 -   297x 420 mm (Din A3)    No',13
	db	'  3 -   420x 594 mm (Din A2)   Yes',13
	db	'  4 -   594x 841 mm (Din A1)    No',13
	db	'  5 -   841x1189 mm (Din A0)    No',13
	db	13,'Select paper size 1..5[1]: ',0
;
MTXL	db	13,'key -  paper size (normal orientation)',13
	db	'  1 -   210x 297 mm (Din A4)  ',13
	db	'  2 -   297x 420 mm (Din A3)  ',13
	db	'  3 -   420x 594 mm (Din A2)  ',13
	db	'  4 -   594x 841 mm (Din A1)  ',13
	db	'  5 -   841x1189 mm (Din A0)  ',13
	db	'  6 -   610x 860 mm (Din RA1) ',13
	db	'  7 -   860x1220 mm (Din RA0) ',13
	db	'  8 -   450x 640 mm (Din SRA2)',13
	db	'  9 -   900x1280 mm (Din SRA0)',13
	db	13,'Select paper size 1..9[1]: ',0
;
MTGR	db	13,'key -  paper size  -  long edge along platen?',13
	db	'  1 -   210x 297 mm (Din A4)   Yes',13
	db	'  2 -   297x 420 mm (Din A3)    No',13
	db	'  3 -   420x 594 mm (Din A2)   Yes',13
	db	'  4 -   594x 841 mm (Din A1)    No',13
	db	'  5 -   841x1189 mm (Din A0)    No',13
	db	13,'Select paper size 1..5[1]: ',0
;
pltl	db	13,10,'Supported 8-pen plotters:',13,10
	db	'  1 -  HP 7570 (IBM 6184)',13,10
	db	'  2 -  HP 7580 (IBM 7374)',13,10
	db	'  3 -  HP 7585,86 (IBM 7375)',13,10
	db	'  4 -  HP 7595,96 (IBM 6186)',13,10
	db	'  5 -  HP DraftPro DXL/EXL',13,10
	db	'  6 -  HPGL compatibles and/or 16 colors',13,10
	db	13,10,'Select your plotter 1..6[4]: $'
aptl	db	13,10,13,10
	db	'What paper sizes do you wish to use?',13,10
	db	' 1 - U.S.',13,10
	db	' 2 - Metric.',13,10
	db	' 3 - Automatic.',13,10 
	db	13,10,'Select media sizes 1..3[1]: $'
askp	db	13,10,'Turret changing desired Y[N]: $'
crfl	db	13,10,'$'
askrf	db	13,10,'Roll-Feed mode desired Y[N]: $'
askc16	db	13,10,'16 colors without changing turrents Y[N]: $'
;
	include	PLLAST.CPY
;
