;	PLDRV.CPY - plotter driver header code
;
;	(c) Copyright 1986 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle  5/25/1986
;	modified for driver toolkit 8/16/86
;	updated for pattern fill 8/3/87 MR (PLPOLY func. differs)
;	rev 6 - PLHDL, extra no-functions added to jump table 6/18/88 MR
;	rev 7 - use DVRSVC for memory aloc 8/13/88 MR
;	11/23/88 - removed DSVFNT,DSVTXT from jump table MR
;	rev 8: .BIN driver format, vector table 11/24/88 MR
;
pldrv	segment	public
	assume	cs:pldrv,ds:pldrv
;
dvrlvl	equ	8			;driver interface revision level number
dvrtyp	equ	1			;driver type (1=plotter driver)
;
	if1
xfunc	=	0			;assume no extended functions
	endif
;
entry	macro				;enter driver procedure
	push	ds			;save old ds
	mov	bp,cs			;use local ds
	mov	ds,bp
	endm
;
exit	macro				;exit driver procedure
	pop	ds			;restore entry ds
	db	0CBH			;RETF
	endm
;
;	------------------------------------------------------------------
;	Required Equates Defined before INCLUDE PLDRV.CPY
;	------------------------------------------------------------------
;
;	DEVREV equ is Specific-Device driver code revision #
;	DSTMSK equ 0FFFFh ;valid destinations mask (unimplemented)
;
;	CFGCTL equ selects by bits:
;
;	1h = Display aspect ratio
;	2h = Communications channel
;	4h = Communications port
;	8h = Call device-specific DEVCFG routine
;	
;	------------ DVRSVC & Local Resource Macros ----------------------
;
RSCMSG	macro	rnum,vlst
	ifnb	<vlst>
	mov	bx,offset vlst		;bx->varlist
	endif
	ifnb	<rnum>
	mov	si,rnum			;si = resource #
	endif
	shl	si,1
	mov	si,PLRSC[si]
	mov	ax,DS			;set ES:SI-> text
	mov	ES,ax
	mov	dx,21			;send formatted message
	call	dword ptr DVRSVC
	endm
;
CONIN	macro
	mov	dx,16			;get key to AL
	call	dword ptr DVRSVC
	endm
;
CONOUT	macro
	mov	dx,19			;echo to console
	call	dword ptr DVRSVC
	endm
;
PSTATL	macro
	mov	dx,22			;position to status line
	call	dword ptr DVRSVC
	endm
;
LINEIN	macro	bfr
	mov	ax,DS
	mov	ES,ax
	mov	di,offset bfr
	mov	dx,20			;get text ASCIIZ line to ES:DI
	call	dword ptr DVRSVC
	endm
;
I2GET	macro	bfr
	mov	ax,DS			;ES:SI -> text string
	mov	ES,ax
	ifnb	<bfr>
	mov	si,offset bfr
	endif
	mov	dx,25			;position to status line
	call	dword ptr DVRSVC
	endm
;
;	-------------- Plot Driver Header Table --------------------------
;
	org	0000H
	hlt				;signature word = xxF4h
	db	dvrtyp			;where xx = dvrtyp
	db	dvrlvl			;interface revision level
	db	devrev			;device specific code revision #
	dw	xfunc			;extended functions available flag
	dw	offset enddvr+1		;# of bytes in driver
	dw	cfgctl			;configuration control bits
	dw	dstmsk			;valid destinations mask
	dw	offset plidrn		;start of parameter table	
	dw	offset plrsc		;start of resource index
	dw	offset plqdta		;start of PLTQ data area
;	-------------- setup and control functions ------------------------
	dw	offset DEVCFG		;device specific configuration
	dw	offset PLLOAD		;load & init for plotting
	dw	offset PFLOAD		;init for fileout (no port init)
	dw	offset PLHDL		;plot to file handle #AX
	dw	offset PLOTQ		;ask plot questions
	dw	offset PLSTART		;start individual plot
	dw	offset PLSTAT		;check/set plot status
	dw	offset PLCOMP		;individual plot complete
	dw	offset PLUNLD		;plot driver unload
	dw	offset PLCTRL		;device specific control
;	---------------------- drawing modes ------------------------------
	dw	offset PLLWT		;specify pen line weight
	dw	offset DSCOLOR		;specify draw color (pen #)
	dw	offset DSPAT		;specify line style
	dw	offset DSFPAT		;specify fill style
;	-------------------- drawing functions ----------------------------
	dw	offset DSPOINT		;----drawing functions------
	dw	offset DSLINE		;draw line
	dw	offset DSREC		;draw hollow rectangle
	dw	offset DSFREC		;draw filled rectangle
	dw	offset DSCIR		;draw hollow circle
	dw	offset DSARC		;draw hollow arc
	dw	offset DSPOLY		;draw filled polygon
	dw	offset plnada		;reserved
	dw	offset plnada		;reserved
	dw	offset plnada		;reserved
	dw	offset plnada		;reserved
	dw	offset PLFNT		;local font select by name ES:DI
	dw	offset PLTXT		;local font text output
	dw	offset plnada		;reserved
	dw	offset plnada		;reserved
	dw	offset plnada		;reserved
	dw	offset plnada		;reserved
	dw	offset plnada		;reserved
	dw	offset plnada		;reserved
;
plnada:	stc				;flag unavailable
	db	0CBh			;RETF
;
