;	PLHIDMP.ASM - Houston Instrument DMP- and IOLINE plotters.
;
;	(c) Copyright 1986 Evolution Computing
;	All rights reserved.
;	cloned from PLHI51.ASM  1/17/86 Scott Boster
;	modified for the driver toolkit 8/16/86 MR
;	added multi-sizes & Ver. 5 upgrade  8/9/86 MR
;	new .BIN driver format and indiv. model #s  1/17/88 SB
;	devrev=1: added DSCIR & DSARC functions  12/21/89 SB
;	devrev=2: added IOLINE LP7200 WIDE paper sizes 08/20/90 SB
;
	name     PLHIDMP
;
devrev	equ	2			;driver code revision #
cfgctl	equ	0000Eh			;port,dest,devcfg
dstmsk	equ	0FFFFh			;all destinations valid
;	This driver supports PID values 35..42, and 65
;
	include	 PLDRV.CPY
;
;	---------------------------------------------------------------
;	DEVCFG - (All CONIN/CONOUT must use DOS functions)
;	---------------------------------------------------------------
;
DEVCFG:	entry
psagn:	mov	dx,pltl			;select plotter dialog
	mov	ah,9
	int	21H
	mov	ah,7			;get key
	int	21H
	push	ax			;echo choice
	mov	dl,al
	mov	ah,2
	int	21H
	pop	ax
	cmp	al,3			;^C?
	jnz	nxabt1
	mov	abflag,1
	exit
nxabt1:	sub	ah,ah
	cmp	al,'1'
	jb	pikdf			;assume default (CR) is picked
	jz	tndig			;'1' may mean 2 digits
	sub	al,'0'
	cmp	al,9			;over 9 is assumed 1
	ja	pikdf
	dec	ax
	jmp	short pikok		;save model # picked 
tndig:	mov	ah,7			;get 2nd key
	int	21H
	push	ax			;echo choice
	mov	dl,al
	mov	ah,2
	int	21H
	pop	ax
	cmp	al,'0'
	jb	pik1			;if not 0-5 then assume total=1
	cmp	al,'7'
	ja	pikdf
	sub	al,'0'-10		;range 10-16
	dec	ax
	jmp	short pikok
pik1:	mov	ax,0			;selection #1 = zeroth index'r
	jmp	short pikok
pikdf:	mov	ax,9			;default = DMP-56
pikok:	sub	ah,ah
	mov	PLNUM,ax
 	mov	dx,crlf			;append crlf
	mov	ah,9
	int	21H			;we now know PLNUM....
	mov	asenab,0		;assume no paper sizing
	mov	dx,apsl			;ask if auto paper sizing
	mov	ah,9
	int	21H
	mov	ah,7			;get key
	int	21H
	push	ax			;echo choice
	mov	dl,al
	mov	ah,2
	int	21H
	pop	ax
	cmp	al,3			;^C?
	jnz	nxabt2
	mov	abflag,1
	exit
nxabt2:	cmp	al,'Y'			;answer Y?
	jz	doaps
	cmp	al,'y'
	jnz	acexit
doaps:	mov	asenab,1		;enable auto paper sizing
acexit:	mov	dx,crlf			;append crlf
	mov	ah,9
	int	21H
	mov	bx,PLNUM
	mov	al,maxpct[bx]		;max paper size choice #
	mov	maxpc,al
	mov	al,minpct[bx]		;min paper size choice #
	mov	minpc,al
	shl	bx,1			;for word index
	mov	ax,rdtbl[bx]		;avail paper sizes prompt #
	mov	rdlptr,ax
	mov	ax,pntbl[bx]		;max # pens
	mov	plnpens,ax
	mov	ax,pidtbl[bx]		;plotter id rsc. #
	mov	plidrn,ax
	mov	ax,pdevid[bx]		;device id #
	mov	pid,ax
	mov	qpid,ax
	mov	dx,crlf			;crlf to end dialog
	mov	ah,9
	int	21H
	exit
;
;	---------------------------------------------------------------
;	PLLOAD - load initialization of the plotter driver
;	PFLOAD - load plotter driver - no port init (Plot to File)
;
;	This will only be called once per program execution
;	before any other display driver calls.  It must:
;	1 - test for correct plotter hardware available
;	2 - allocate any required buffer memory from DOS
;	3 - perform global & local variable initialization
;	4 - initialize the plotter hardware
;	5 - set AX=error code:
;	    0=ok
;	    1=not enough memory
;	    2=not enough EMM memory
;	    3=device unavailable/unuseable
;	---------------------------------------------------------------
;
PFLOAD:	entry
	mov	word ptr DVRSVC,di	;save pointer to driver services
	mov	word ptr DVRSVC+2,ES
	mov	dx,11			;init destination for PTF
	mov	cx,0
	call	dword ptr DVRSVC	;do it
	jmp	short ldcom
PLLOAD:	entry
	mov	word ptr DVRSVC,di	;save pointer to driver services
	mov	word ptr DVRSVC+2,ES
	mov	dx,11			;init for configured destination
	mov	cx,dest
	mov	ax,idata
	mov	bx,port
	call	dword ptr DVRSVC	;do it
ldcom:	sub	ax,ax			;ax=0: device available for use
	exit
;
;	---------------------------------------------------------------
;	PLOTQ - Ask any Plot-specific questions
;
;	All answers are stored in the PLQDTA area
;	DSXMAX table data must be valid after PLOTQ
;	---------------------------------------------------------------
;
PLOTQ:	entry
	mov	ax,pid			;save pid in qdata area
	mov	qpid,ax
	mov	abflag,0		;clear abort flag
	test	asenab,1		;auto-sizing available?
	jnz	aps			;yes
	jmp	noaps			;no
aps:	RSCMSG	23			;auto mode message
	CONIN				;CR to continue...
	mov	ah,3			;any junk chr in buffer?
	mov	dx,port
	int	14H
	test	ah,1
	jz	nodav
	mov	ah,2			;read junk chr to clear it
	mov	dx,port
	int	14H
nodav:	mov	si,offset istg		;read hard clip limits
	call	plstg
	mov	si,offset bfr		;point to read buffer
nxinp:	push	si
	mov	dx,23			;read plotter data
	call	dword ptr DVRSVC
	jc	stscn			;error: use normal paper sizing
	pop	si			;store it
	mov	[si],al
	inc	si
	cmp	al,13			;CR?
	jnz	nxinp
stscn:	mov	si,offset bfr		;parse the input data 
	cmp	byte ptr [si],'('	;test for expected Report String
	jz	stbylt
	RSCMSG	16			;error message
	jmp	short noaps		;but continue with rdlptr
stbylt:	call	SCNDEC			;get the 1st Status byte,
	mov	bx,offset sstg		;assume small chart
	test	ax,64			;does stat byte = large chart?
	jnz	smchrt			;no
	mov	bx,offset lstg		;yes
smchrt:	mov	isptr,bx
	mov	bx,PLNUM
	shl	bx,1			;build index into RTTBL
	shl	bx,1
	test	ax,64			;does stat byte = large chart =0
	jnz	s2chrt			;no
	add	bx,2			;yes,
s2chrt:	mov	bx,rttbl[bx]		;get rtn to load index
	mov	rtidx,bx
	call	SCNDEC			;get the 2nd Status byte,ignore it
	call	SCNDEC			;get pen's X pos, ignore it
	call	SCNDEC			;get pen's Y pos, ignore it
	call	SCNDEC			;get LL X pos, ignore it
	call	SCNDEC			;get LL Y pos, ignore it
	call	SCNDEC			;get UR X pos, save it
	mov	bx,ax			;save it
	call	SCNDEC			;get UR Y pos, save it
	jmp	pscom			;continue paper sizing
;
noaps:	RSCMSG	rdlptr			;paper size selection
	CONIN				;get answer
	cmp	al,3			;ctl-C?
	jnz	noabt1
	mov	abflag,-1
	exit
noabt1:	CONOUT				;echo it
	sub	al,'1'			;range minpc..maxpc
	add	al,minpc
	cmp	al,minpc
	jl	usedfv
	cmp	al,maxpc
	jbe	usersl
usedfv:	mov	al,minpc		;default is minpc (smallest)
usersl:	sub	ah,ah			;save paper pick
	push	ax
	mov	ax,13			;end dialog
	CONOUT
	pop	si
	shl	si,1			;make word select index	
	mov	bx,offset sstg
	mov	di,istbl[si]		;get init value:0=small,1=large
	cmp	di,0
	jz	dosmch
dolgch:	mov	bx,offset lstg
dosmch:	mov	isptr,bx
	mov	bx,xmtbl[si]		;update parameter data
	mov	ax,ymtbl[si]		;get size max values
	push	bx
	mov	bx,PLNUM
	shl	bx,1			;build index into RTTBL
	shl	bx,1
	cmp	di,0			;does init = large chart =0
	jnz	s3chrt			;no, small chart
	add	bx,2			;yes
s3chrt:	mov	bx,rttbl[bx]		;get rtn to load index
	mov	rtidx,bx
	pop	bx
pscom:	mov	dsxmax,bx		;save max values
	mov	qxmax,bx
	mov	dsymax,ax
	mov	qymax,ax
	shr	bx,1			;make aspect ratios
	shr	bx,1
	shr	ax,1	
	shr	ax,1
	mov	dsxar,bx
	mov	dsyar,ax
	mov	si,offset rt0 
	add	si,rtidx		;find rtn/load stg
	mov	e2ptr,si		;based on which plotter
	mov	qeptr,si		;and chart size
	mov	ax,isptr		;save lg/sm init stg
	mov	qiptr,ax
	mov	qpens,1			;assume 1 pen for PLQDTA
	cmp	plnpens,1		;if max # pens > 1 then
	jz	short pensok
askps:	RSCMSG	24			;ask current # pens
	CONIN				;get key (CTL-C abort ok)
	CONOUT
	sub	ah,ah
	cmp	al,13			;CR = assume 1 pen
	jz	short pensok	
pdig:	cmp	al,'1'
	jb	pensok			;assume 1 pen
	jz	tdig			;'1' means 2 digits
	sub	al,'0'
	cmp	al,9			;over 9 is assume 1 pen
	ja	pensok
	mov	qpens,ax		;save # pens in PLQDTA
	jmp	short pensok
tdig:	CONIN				;get 2nd key 
	CONOUT
	cmp	al,'0'
	jb	pensok			;if not 0-4 then assume 1
	cmp	al,'4'
	ja	pensok
	sub	al,'0'-10		;range 10-14
	mov	qpens,ax
pensok: RSCMSG	26			;end of dialog
	RSCMSG	25			;velocity dialog
	CONIN
	CONOUT				;echo it
	cmp	al,'T'			;select transparency?
	jz	setLV
	cmp	al,'t'
	jnz	setHV
setLV:	mov	ax,offset lvstg		;low velocity for transparencies
	mov	vsptr,ax
	jmp	short velok
SetHV:	mov	ax,offset hvstg		;high velocity - normal
	mov	vsptr,ax
velok:	mov	qvptr,ax
	RSCMSG	26			;crlf
	sub	ax,ax			;ok to plot
	exit
;
;	---------------------------------------------------------------
;	PLSTART - Plotter-Specific start new plot dialog
;
;	CX = desired # of copies
;	---------------------------------------------------------------
;
PLSTART: entry
	mov	ax,pid			;qpid = pid?
	cmp	qpid,ax
	jz	short pidok
	mov	abflag,1		;no - abort plot
	exit
pidok:	mov	ax,qiptr		;recover PLOTQ answers
	mov	isptr,ax
	mov	ax,qvptr
	mov	vsptr,ax
	mov	ax,qeptr
	mov	e2ptr,ax
	mov	ax,qpens
	mov	plnpens,ax
	mov	bx,qxmax
	mov	dsxmax,bx		;and max values
	mov	ax,qymax
	mov	dsymax,ax
	shr	bx,1			;get quarter values
	shr	ax,1
	shr	bx,1			;for approx aspect ratios
	shr	ax,1
	mov	dsxar,bx
	mov	dsyar,ax
	test	asenab,1
	jnz	vsonly
	mov	si,isptr		;send chart size init
	call	plstg	
vsonly:	mov	si,vsptr		;send velocity select
	call	plstg
	mov	abflag,0		;clear abort flag
	exit
;
;	---------------------------------------------------------------
;	PLSTAT - Check & return AX = 0=ok/-1 to calcel status
;	---------------------------------------------------------------
;
PLSTAT:	entry
	or	ax,abflag		;return local abort status
	exit
;
;	---------------------------------------------------------------
;	PLCOMP - Plot pass complete
;
;	One pass through all vectors has been completed.  Set AX=0
;	If the plot is done, or set AX=-1 if another pass is needed
;	for multi-copy or banding use.  If complete, finish the
;	plot & perform any cleanup (paper eject/unload, etc).
;	---------------------------------------------------------------
;
PLCOMP:	entry
	mov	si,offset e1stg	
	call	plstg			;send ending string, part 1
	mov	si,e2ptr
	call	plstg			;send ending string, part 2
	mov	si,offset e3stg	
	call	plstg			;send ending string, part 3
	sub	ax,ax			;plot complete
	exit
;
;	---------------------------------------------------------------
;	PLUNLD - end use of the plotter driver
;
;	This will only be called once per program execution
;	before program termination.  It must:
;	1 - restore any interrupt vectors changed by this driver
;	2 - release any allocated buffer memory
;	---------------------------------------------------------------
;
PLUNLD:	entry
	exit
;
DSCOLOR: entry
	mov	si,ax			;map color to pen number
	and	si,15
	jz	plcxt			;color zero invalid
	dec	si			;colors 0-14 now
prng:	cmp	si,plnpens		;limit to valid # pens
	jb	pnok
	sub	si,plnpens
	jmp	short prng
pnok:	mov	ax,si			;color# *5
	add	si,si
	add	si,si
	add	ax,si
	cmp	ax,CurClr		;color changed?
	jz	plcxt
	mov	CurClr,ax		;save new color
	mov	si,offset mstg		;send PenUp first
	call	plstg
	mov	si,offset cstg		;select pen color string
	add	si,CurClr		;with color offset
	call	plstg
plcxt:	exit
;
;	DSPOINT - draw a single point
;
;	SI = X coordinate
;	DI = Y coordinate
;
DSPOINT: entry
	call	moveto			;move to point location
	mov	si,offset ptstg		;draw a point
	cmp	PLNUM,0			;PC695 needs different point cmd
	jnz	dopts
	mov	si,offset pt1stg
dopts:	call	plstg
	exit
;
moveto	proc	near
 	mov	dx,si
	mov	ax,di
	cmp	ax,Cury			;change in Y?
	jnz	domove
	cmp	dx,Curx			;change in X?
	jnz	domove
	ret				;already in place
domove:	mov	si,offset mstg		;move string
mdcomn:	mov	Cury,ax			;save new X,Y
	mov	Curx,dx
	call	plstg
	mov	ax,Curx			;send X
	call	pldec
	mov	al,','			;send comma
	call	plsend
	mov	ax,Cury			;send Y
	call	pldec
	mov	al,','			;end command
	call	plsend
	ret
moveto	endp
;
drawto	proc	near
	mov	dx,si
	mov	ax,di
	cmp	ax,Cury			;change in Y?
	jnz	dodraw
	cmp	dx,Curx			;change in X?
	jnz	dodraw
	ret				;already in place
dodraw:	mov	si,offset dstg
	call	mdcomn			;draw the line
	ret
drawto	endp
;
	include	 PLSUBS.CPY
;
;	DSCIR - draw circle on screen (will entirely fit)
;
;	AX = center X
;	DX = center Y
;	CX = radius (horizontal)
;
DSCIR:	entry
	cmp	CurPat,-1		;use this only if style=solid line
	jz	cirok
	exit
cirok:	push	cx			;save radius
	mov	si,ax
	mov	di,dx
	call	moveto			;move to center of circle
	lea	si,circ			;circle command
	call	plstg
	mov	ax,Curx			;send X
	call	pldec
	mov	al,','			;send comma
	call	plsend
	mov	ax,Cury			;send Y
	call	pldec
	mov	al,','			;send comma
	call	plsend
	pop	ax			;radius
	call	pldec
	mov	al,','			;end command
	call	plsend
	exit
;
;	DSARC - draw arc on screen (arc's circle will entirely fit)
;
;	AX = center X
;	DX = center Y
;	CX = radius (horizontal)
;	SI = starting angle (0-1023)
;	DI = ending angle (0-1023)
;
DSARC:	entry
	cmp	CurPat,-1		;use this only if style=solid line
	jz	arcok
	exit
arcok:	and	si,3FFH			;range limit bearing angles
	and	di,3FFH
	sub	di,si			;calc arc width
	jg	awok
	add	di,1024			;if neg, add 360 degrees
awok:	push	di			;save arc width
	push	dx			;save Y & X for arc cmd
	push	ax
	push	ax			;save X & Y for sp calc
	push	dx
	push	si			;save start and rad for sp calc
	push	cx
	mov	bx,si			;DeltaY=Radius*SIN(StartAng)
	mov	ax,cx
	call	ISIN
	mov	bp,dx			;hold DeltaY in BP
bwok:	pop	ax			;DeltaX=Radius*COS(StartAng)
	pop	bx
	call	ICOS			;DX = DeltaX
	pop	ax			;start Y ->BP
	add	bp,ax
	pop	ax			;Start X ->DX
	add	dx,ax
	mov	si,dx			;SI,DI = move to point
	mov	di,bp
cwok:	call	moveto			;move to arc start
	lea	si,arc1			;arc command
	call	plstg
	pop	ax			;center X
	call	pldec
	mov	al,','			;send comma
	call	plsend
	pop	ax			;center Y
	call	pldec
	mov	al,','			;send comma
	call	plsend
dwok:	pop	ax			;angle width
	mul	k360
	div	k1024			;in degrees
	call	pldec
	mov	al,','			;end command
	call	plsend
	lea	si,mstg			;pen up assured here
	call	plstg
	mov	curx,-1			;flag next move required
	exit
;
;	----------------- local use procedures ----------------------
;
;	PLSTG - send ASCIIZ string at DS:SI to plotter
;
PLSTG	proc	near
	mov	ax,DS			;send ASCIIZ string
	mov	ES,ax
	mov	di,si
	mov	dx,13			;using Driver Services
	call	dword ptr DVRSVC
	ret				;characters sent
plstg	endp
;
;	PLDEC - send decimal of AX to plotter
;
PLDEC	proc	near
	mov	dx,15			;AX as decimal ASCII
	call	dword ptr DVRSVC
	ret
pldec	endp
;
;	PLSEND - send character in AL to plotter
;
PLSEND	proc	near
	mov	dx,12
	call	dword ptr DVRSVC
	ret
plsend	endp
;
;	SCNDEC - Scan decimal # from ASCII string at SI
;
SCNDEC	proc	near
	cld
	sub	dx,dx		;clear buffer
nxscd:	lodsb			;get chr
	cmp	al,'-'		;ignore - sign
	jz	nxscd
	cmp	al,'('		;ignore ( 
	jz	nxscd
	cmp	al,' '		;ignore blanks
	jz	nxscd
	cmp	al,'0'		;digit?
	jb	scnxt
	cmp	al,'9'
	jbe	isdgt
scnxt:	mov	ax,dx		;result in AX
	ret
isdgt:	and	ax,000FH	;make digit binary
	shl	dx,1		;bfr*10+digit
	mov	cx,dx
	shl	dx,1
	shl	dx,1
	add	dx,cx
	add	dx,ax
	jmp	nxscd		;get next digit
scndec	endp
;
;	----------------- local data items -------------------------
;
	align	4
DVRSVC	dd	0
isptr	dw	offset sstg		;init string
vsptr	dw	offset hvstg		;velocity string
e2ptr	dw	offset rt0		;rtn/load string
rtidx	dw	0			;rtn/load index (add to offset rt0)
CurClr	dw	-1			;current color #
CurPat	dw	-1			;current line pattern
Curx	dw	-1			;current X
Cury	dw	-1			;current Y
pscale	dw	9			;16 bit pattern every 3/4" (150/16)
abflag	dw	0			;abort flag
plnum	dw	9			;unique model id from list, 0..15
asenab	dw	0			;auto-size enable flag
k360	dw	360			;constant
k1024	dw	1024			;constant
;
xmtbl	dw	1900,3100					;PC695
	dw	2000,3000,2338,3307				;DMP29
	dw	1850,3000					;DMP40
	dw	4000,6400					;DMP41
	dw	4300,6800,4677,6622				;DMP42
	dw	4000,6400					;DMP51,51MP
	dw	4300,6800,4677,6622				;DMP52,52MP
	dw	1960,3160,4160,6560,8560,4560,6960,9360,8160	;DMP56US
	dw	2094,3063,4433,6378,9118			;DMP56MET
	dw	1960,3160,4160,6560,4560,6960			;DMP61US
	dw	2094,3063,4433,6378				;DMP61MET
	dw	1960,3160,4160,6560,8560,4560,6960,9360,8160	;DMP62US
	dw	2094,3063,4433,6378,9118			;DMP62MET
	dw	7184,8784,8784,8784,8784			;IO7200
;
ymtbl	dw	1400,1900					;PC695
	dw	1450,2000,1653,2338				;DMP29
	dw	1400,1850					;DMP40
	dw	3000,4000					;DMP41
	dw	2900,4300,3307,4677				;DMP42
	dw	3000,4000					;DMP51,51MP
	dw	3200,4300,3307,4677				;DMP52,52MP
	dw	1460,1960,3160,4160,6560,3360,4560,6960,5760	;DMP56US
	dw	1409,2094,3063,4433,6378			;DMP56MET
	dw	1460,1960,3160,4160,3360,4560			;DMP61US
	dw	1409,2094,3063,4433				;DMP61MET
	dw	1460,1960,3160,4160,6560,3360,4560,6960,5760	;DMP62US
	dw	1409,2094,3063,4433,6378			;DMP62MET
	dw	4784,7184,9584,11984,14384			;IO7200
;
istbl	dw	0,   1						;PC695
	dw	0,   1,   0,   1				;DMP29
	dw	0,   1						;DMP40
	dw	0,   1						;DMP41
	dw	0,   1,   0,   1				;DMP42
	dw	0,   1						;DMP51,51MP
	dw	0,   1,   0,   1				;DMP52,52MP
	dw	0,   1,   0,   1,   1,   0,   1,   1,   1	;DMP56US
	dw	0,   1,   0,   1,   1				;DMP56MET
	dw	0,   1,   0,   1,   0,   1			;DMP61US
	dw	0,   1,   0,   1				;DMP61MET
	dw	0,   1,   0,   1,   1,   0,   1,   1,   1	;DMP62US
	dw	0,   1,   0,   1,   1				;DMP62MET
;
rttbl	dw	 0,   0		;PC695
	dw	 8,  16 	;DMP29
	dw	24,  32		;DMP40
	dw	40,  48		;DMP41
	dw	40,  48		;DMP42
	dw	40,  48		;DMP51
	dw	56,  64		;DMP51MP
	dw	40,  48		;DMP52
	dw	56,  64		;DMP52MP
	dw	72,  80		;DMP56US
	dw	72,  80		;DMP56MET
	dw	88,  96		;DMP61US
	dw	88,  96		;DMP61MET
	dw	88,  96		;DMP62US
	dw	88,  96		;DMP62MET
	dw	72,  80		;IOLINE 3700
	dw	72,  80		;IOLINE 7200
;
maxpct	db	 1, 5, 7, 9,13,15,15,19,19,28,33,39,43,52,57,28,62
maxpc	db	19			;max answer #
;
minpct	db	 0, 2, 6, 8,10,14,14,16,16,20,29,34,40,44,53,20,58
minpc	db	14			;min answer #
;
rdtbl	dw	14,15,14,17,18,17,17,18,18,19,20,21,22,19,20,19,32
rdlptr	dw	19			;paper size dialog text rsc #
;
pntbl	dw	 4, 8, 1, 1, 1, 1,14, 1,14, 6, 6, 6, 6, 6, 6, 8, 8
					;max # pens per each model #
pidtbl	dw	 2, 3, 4, 5, 6, 7, 8, 9,10,11,11,12,12,13,13,30,31
					;plotter id text rsc #s
pdevid	dw	35,36,37,38,39,38,38,39,39,41,41,40,40,41,41,42,65
pid	dw	41			;unique plotter device id #
;
bfr	db	104 dup ('$')		;HCL read buffer
;
;	"When plotter gets an EC cmd, it moves pen to HOME & 
;	  sets the window to the present chart size."
;
istg	db	';: EC5, A ER ',0	;init,.005",Abs,Report
;
lstg	db	';: EF EC5, A ',0	;large chart
sstg	db	';: EH EC5, A ',0	;small chart
;
hvstg	db	'V32,',0		;high velocity
lvstg	db	'V06,',0		;low velocity 
;
mstg	db	'U ',0			;pen Up
dstg	db	'D ',0			;pen Down
;
ptstg	db	'zrwuqvy ',0		;marker for POINT
pt1stg	db	'M10 ',0		;PC695 only
;
e1stg	db	'U P0, U ',0		;Pen 0 
;
; Return-to-Load vectors --- offsets -- Used by:
rt0	db	'000,000',0	;+0	95-L,S
rt1	db	'205,003',0	;+8	29-L
rt2	db	'000,205',0	;+16	29-S
rt3	db	'420,000',0	;+24	40-L
rt4	db	'000,420',0	;+32	40-S
rt5	db	'375,000',0	;+40	41-L 42-L 51-L 52-L 
rt6	db	'000,375',0	;+48	41-S 42-S 51-S 52-S 
rt7	db	'695,000',0	;+56	51MP-L 52MP-L
rt8	db	'000,695',0	;+64	51MP-S 52MP-S
rt9	db	'445,061',0	;+72	56-L
rt10	db	'120,445',0	;+80	56-S
rt11	db	'822,000',0	;+88	61-L 62-L
rt12	db	'000,822',0	;+96	61-S 62-S
;
e3stg	db	', e @ ',0	;Return to Load Position
;
;	pen select table {*5 bytes}
cstg	db	'P1, ',0, 'P2, ',0, 'P3, ',0, 'P4, ',0, 'P5, ',0
	db	'P6, ',0, 'P7, ',0, 'P8, ',0, 'P2+,',0, 'P3+,',0
	db	'P4+,',0, 'P5+,',0, 'P6+,',0, 'P7+,',0, 'P1, ',0
;
circ	db	'CC ',0		;circle command
arc1	db	'D CA ',0	;arc command
;
;	------------- global data items ----------------------
;
	align	4
plidrn	dw	1		;
dsxmax	dw	1957		;# X dots -1 (for Eng. A Size)
dsymax	dw	1457		;# Y dots -1 
dsyar	dw	3		;aspect ratio Y/X
dsxar	dw	4
pldpti	dw	2000		;# of dots per 10 inches (.005")
plnpens	dw	1		;max # of pens
plpwid	dw	3		;pen width in horiz lines
plflags	dw	7003H		;needs pens sorted/PTF/solid circs&arcs
ptft1	db	'PLT'
ptft2	db	'PLT'
port	dw	0
dest	dw	2		;default is XON/XOFF COM port
idata	dw	00E7H		;init 9600-N-2-8
	dw	0,0,0,0,0
;
PLQDTA	dw	14		;#bytes of PLOTQ data
qpid	dw	0		;PLOTQ stored pid value
qxmax	dw	0		;PLOTQ paper size
qymax	dw	0
qiptr	dw	0		;PLOTQ init string
qvptr	dw	0		;PLOTQ velocity string
qeptr	dw	0		;PLOTQ rtn/load string
qpens	dw	0		;PLOTQ current # pens
;
;	-------------- Plot Driver Text Resources ----------------
;
PLRSC	dw	32		;# of resources provided
	dw	offset plid	;1=generic plotter ID
	dw	offset plid2	;2=PC695A ID
	dw	offset plid3	;3=DMP-29 ID
	dw	offset plid4	;4=DMP-40 ID
	dw	offset plid5	;5=DMP-41 ID
	dw	offset plid6	;6=DMP-42 ID
	dw	offset plid7	;7=DMP-51 ID
	dw	offset plid8	;8=DMP-51MP ID
	dw	offset plid9	;9=DMP-52 ID
	dw	offset plid10	;10=DMP-52MP ID
	dw	offset plid11	;11=DMP-56 ID
	dw	offset plid12	;12=DMP-61 ID
	dw	offset plid13	;13=DMP-62 ID
;
	dw	offset u95	;14=PC695,40 sizes
	dw	offset u29	;15=DMP29 sizes
	dw	offset ermsg	;16=error msg if not responding
	dw	offset u41	;17=DMP41,51 sizes
	dw	offset u42	;18=DMP42,52 sizes
	dw	offset u56U	;19=DMP56,62 US sizes
	dw	offset u56M	;20=DMP56,62 MET sizes
	dw	offset u61U	;21=DMP61 US sizes
	dw	offset u61M	;22=DMP61 MET sizes
;
	dw	offset dlog	;23=auto paper dialog
	dw	offset plog	;24=#pens dialog
	dw	offset vsel	;25=velocity quiz
	dw	offset dend	;26=crlf for DVRSVCs
;
pltl	dw	offset pstl	;27=plotter selection quiz
apsl	dw	offset apls	;28=AUTO sizing?
crlf	dw	offset crfl	;29=cr/lf for DEVCFG
	dw	offset plid14	;30=IOLINE 3700 ID
	dw	offset plid15	;31=IOLINE 7200 ID
	dw	offset u72U	;32=7200 sizes
;
plid	db	'Houston Instrument and DMPL-compatible plotters.',0
plid2	db	'HI PC695A plotter:',0
plid3	db	'HI DMP-29 plotter:',0
plid4	db	'HI DMP-40 plotter:',0
plid5	db	'HI DMP-41 plotter:',0
plid6	db	'HI DMP-42 plotter:',0
plid7	db	'HI DMP-51 plotter:',0
plid8	db	'HI DMP-51MP plotter:',0
plid9	db	'HI DMP-52 plotter:',0
plid10	db	'HI DMP-52MP plotter:',0
plid11	db	'HI DMP-56 plotter:',0
plid12	db	'HI DMP-61 plotter:',0
plid13	db	'HI DMP-62 plotter:',0
plid14	db	'IOLINE LP3700/4000 plotter:',0
plid15	db	'IOLINE LP7200 plotter:',0
;
u95	db	13,'key -  paper size  - long edge along platen?',13
	db	'  1 -   8.5x11 inch (Eng A)   Yes',13
	db	'  2 -    11x17 inch (Eng B)    No',13
	db	13,'Select paper size 1..2[1]: ',0
;
u29	db	13,'key -  paper size  - long edge along platen?',13
	db	'  1 -   8.5x11 inch (Eng A)   Yes',13
	db	'  2 -    11x17 inch (Eng B)    No',13
	db	'  3 -   210x297 mm  (Din A4)  Yes',13
	db	'  4 -   297x420 mm  (Din A3)   No',13
	db	13,'Select paper size 1..4[1]: ',0
;
ermsg	db	13,'Plotter does not respond in Auto-Sizing Mode.',13,0
;
u41	db	13,'key -  paper size  - long edge along platen?',13
	db	'  1 -    17x22 inch (Eng C)   Yes',13
	db	'  2 -    22x34 inch (Eng D)    No',13
	db	13,'Select paper size 1..2[1]: ',0
;
u42	db	13,'key -  paper size  - long edge along platen?',13
	db	'  1 -    18x24 inch (Arch C)  Yes',13
	db	'  2 -    24x36 inch (Arch D)   No',13
	db	'  3 -   420x594 mm  (Din A2)  Yes',13
	db	'  4 -   594x841 mm  (Din A1)   No',13
	db	13,'Select paper size 1..4[1]: ',0
;
u56U	db	13,'key -  paper size  - long edge along platen?',13
	db	'  1 -   8.5x11 inch (Eng A)   Yes',13
	db	'  2 -    11x17 inch (Eng B)    No',13
	db	'  3 -    17x22 inch (Eng C)   Yes',13
	db	'  4 -    22x34 inch (Eng D)    No',13
	db	'  5 -    34x44 inch (Eng E)    No',13
	db	'  6 -    18x24 inch (Arch C)  Yes',13
	db	'  7 -    24x36 inch (Arch D)   No',13
	db	'  8 -    36x48 inch (Arch E)   No',13
	db	'  9 -    30x42 inch (Arch F)   No',13
	db	13,'Select paper size 1..9[1]: ',0
;
u56M	db	13,'key -  paper size   - long edge along platen?',13
	db	'  1 -   210x 297 mm (Din A4)   Yes',13
	db	'  2 -   297x 420 mm (Din A3)    No',13
	db	'  3 -   420x 594 mm (Din A2)   Yes',13
	db	'  4 -   594x 841 mm (Din A1)    No',13
	db	'  5 -   841x1189 mm (Din A0)    No',13
	db	13,'Select paper size 1..5[1]: ',0
;
u61U	db	13,'key -  paper size  - long edge along platen?',13
	db	'  1 -   8.5x11 inch (Eng A)    Yes',13
	db	'  2 -    11x17 inch (Eng B)     No',13
	db	'  3 -    17x22 inch (Eng C)    Yes',13
	db	'  4 -    22x34 inch (Eng D)     No',13
	db	'  5 -    18x24 inch (Arch C)   Yes',13
	db	'  6 -    24x36 inch (Arch D)    No',13
	db	13,'Select paper size 1..6[1]: ',0
;
u61M	db	13,'key -  paper size   - long edge along platen?',13
	db	'  1 -   210x 297 mm (Din A4)   Yes',13
	db	'  2 -   297x 420 mm (Din A3)    No',13
	db	'  3 -   420x 594 mm (Din A2)   Yes',13
	db	'  4 -   594x 841 mm (Din A1)    No',13
	db	13,'Select paper size 1..4[1]: ',0
;
u72U	db	13
	db	'key -  plot area  - long edge along platen?',13
	db	'  1 -  36x24 inch -	No',13
	db	'  2 -  44x36 inch -	No',13
	db	'  3 -  44x48 inch -	Yes',13
	db	'  4 -  44x60 inch -	Yes',13
	db	'  5 -  44x72 inch -	Yes',13
	db	13,'Select paper size 1..5[1]: ',0
;
dlog	db 	13,'Load paper in plotter,',13
	db	'press appropriate buttons on plotter to initialize,',13
	db	'then press RETURN key to continue.',13,0
plog	db	13,'How many pens used on this plot? 1-14[1]: ',0
vsel	db 	13,'Transparency or Normal paper T[N]: ',0
dend	db 	13,0
;
pstl	db	13,10
	db	'Supported Houston Instruments plotters:',13,10
	db	'  1 -  PC695A',13,10
	db	'  2 -  DMP-29',13,10
	db	'  3 -  DMP-40',13,10
	db	'  4 -  DMP-41',13,10
	db	'  5 -  DMP-42',13,10
	db	'  6 -  DMP-51',13,10
	db	'  7 -  DMP-51MP',13,10
	db	'  8 -  DMP-52',13,10
	db	'  9 -  DMP-52MP',13,10
	db	' 10 -  DMP-56 U.S.',13,10 	;default PLNUM=9
	db	' 11 -  DMP-56 Metric',13,10
	db	' 12 -  DMP-61 U.S.',13,10
	db	' 13 -  DMP-61 Metric',13,10
	db	' 14 -  DMP-62 U.S.',13,10
	db	' 15 -  DMP-62 Metric.',13,10
	db	'Other DMPL-compatible plotters:',13,10
	db	' 16 -  IOLINE LP3700, LP4000',13,10
	db	' 17 -  IOLINE LP7200',13,10
	db	'Select plotter 1..17[10]: $'
apls	db	13,10
	db	'Automatic paper sizing Y[N]: $'
crfl	db	13,10,'$'
;
	include PLLAST.CPY
;
