;	PLHPPQ.ASM - plotter driver for HP Quiet-, Paint-, & Think-Jets.
;
;	(c) Copyright 1986,1987 Evolution Computing
;	All rights reserved.
;	Original PLHPLJ.ASM by Michael Riddle  5/25/1986
;	modified for driver toolkit 8/16/86
;	added DSCIR/DSARC/DSPOLY, plpwid 1/11/87
;	Added extra plot modes, banding 8/21/87 MR
;	Cloned for Ink-Jets 11/24/87 SB
;	level 7 revisions 9/06/88 SB
;	revised for .BIN driver format 12/13/88 SB
;	devrev=1:added B-size paper 11/23/90 SB
;
	name	PLHPPQ
;
devrev	equ	1			;driver code revision #
cfgctl	equ	0000Eh			;config select bits
dstmsk	equ	0FFFFh			;all destinations valid
;	This driver supports PID values 7..10 & 67
;
	include	PLDRV.CPY
;
;	---------------------------------------------------------------
;	DEVCFG - Select Specific Model of Printer
;	(All CONIN/CONOUT must use DOS functions)
;	---------------------------------------------------------------
;
DEVCFG:	entry
ctagn:	mov	dx,prsl
	mov	ah,9			;display message
	int	21H
	mov	ah,7			;get key
	int	21H
	push	ax			;echo choice
	mov	dl,al
	mov	ah,2
	int	21H
	pop	ax
	cmp	al,13			;CR?
	jz	short dfltct
	cmp	al,3			;CTRL-C?
	jz	short noadj
	sub	al,'1'			;range 0..4
	jl	ctagn
	cmp	al,4
	ja	ctagn
	jmp	short okctp
dfltct:	mov	al,byte ptr plottp	;CR default is current
okctp:	push	ax
	mov	byte ptr plottp,al	;save selection
	add	al,'1'			;store selection in message
	mov	bx,offset PLRSC+17+17	;ptp address
	mov	bx,[bx]
	mov	[bx],al
	mov	dx,offset ccrlf		;crlf to end dialog
	mov	ah,9
	int	21H
	pop	ax
	mov	PRNUM,ax
	mov	bl,al			;setup parameters
	sub	bh,bh
	shl	bx,1
	mov	ax,mntbl[bx]		;min print option
	mov	MINPR,al
	mov	ax,mptbl[bx]		;max print option
	mov	MAXPR,al
	mov	ax,rdtbl[bx]		;resolution dialog prompt #
	mov	RDLPTR,ax
	mov	ax,pidtbl[bx]		;printer id rsc.
	mov	PLIDRN,ax
	mov	ax,pdevid[bx]		;device id #
	mov	PID,ax
	mov	QPID,ax
noadj:	mov	dx,offset ccrlf		;crlf to end dialog
	mov	ah,9
	int	21H
	exit
;
minpr	db	'5'			;minimum print option
maxpr	db	'8'			;maximum print option
prnum	dw	0			;logic switch: printer id number
rdlptr	dw	2			;resolution dialog text rsc #
mntbl	dw	4,0,0,8,9		;minpr values
mptbl	dw	7,3,1,8,16		;maxpr values
rdtbl	dw	2,3,4,5,15		;resolution text resource #s
pidtbl	dw	8,9,10,11,16		;printer id text resource #s
pdevid	dw	7,8,9,10,67		;unique plotter device id #
pid	dw	7			;current config dev id #
ccrlf	db	13,10,'$'
;
;	---------------------------------------------------------------
;	PLLOAD - load initialization of the plotter driver
;	PFLOAD - load plotter driver - no port init (Plot to File)
;
;	This will only be called once per program execution
;	before any other display driver calls.  It must:
;	1 - test for correct plotter hardware available
;	2 - allocate any required buffer memory from DOS
;	3 - perform global & local variable initialization
;	4 - initialize the plotter hardware
;	5 - set AX=error code:
;	    0=ok
;	    1=not enough memory
;	    2=not enough EMM memory
;	    3=device unavailable/unuseable
;	---------------------------------------------------------------
;
PFLOAD:	entry
	mov	word ptr DVRSVC,di	;save pointer to driver services
	mov	word ptr DVRSVC+2,ES
	mov	dx,11			;init destination for PTF
	mov	cx,0
	call	dword ptr DVRSVC	;do it
	jmp	short ldcom
PLLOAD:	entry
	mov	word ptr DVRSVC,di	;save pointer to driver services
	mov	word ptr DVRSVC+2,ES
	mov	dx,11			;init for configured destination
	mov	cx,dest
	mov	ax,idata
	mov	bx,port
	call	dword ptr DVRSVC	;do it
ldcom:	mov	ax,UserMP		;# paras needed
	mov	bx,2			;no release until end!
	mov	dx,2			;allocate RAM block
	call	dword ptr DVRSVC
	jc	memerr			;error?
	mov	ax,ES:[bx]		;ok - get segment selector
	mov	AlocSeg,AX		;save it
	mov	dwseg,ax
	mov	word ptr SHdl,bx	;save RAM block handle
	mov	ax,ES
	mov	word ptr SHdl+2,ax
	sub	ax,ax			;ax=0: device available for use
	exit
lderr:	mov	ax,3			;not available for use
	exit
memerr:	mov	ax,1			;not enough memory
	exit
;
;	---------------------------------------------------------------
;	PLUNLD - end use of the plotter driver
;
;	This will only be called once per program execution
;	before program termination.  It must:
;	1 - restore any interrupt vectors changed by this driver
;	2 - release any allocated buffer memory
;	---------------------------------------------------------------
;
PLUNLD:	entry
	les	bx,SHdl			;RAM block handle
	mov	dx,3			;release RAM block
	call	dword ptr DVRSVC
	exit
;
;	---------------------------------------------------------------
;	PLOTQ - Ask any Plot-specific questions
;
;	All answers are stored in the PLQDTA area
;	DSXMAX table data must be valid after PLOTQ
;	---------------------------------------------------------------
;
PLOTQ:	entry
	mov	ax,pid			;save pid in qdata area
	mov	qpid,ax
	mov	abflag,0		;clear abort flag
	RSCMSG	rdlptr			;display resolution dialog
	CONIN				;get keypress
	mov	rkey,al
	cmp	al,3			;ctrl-C?
	jnz	noabt1
	mov	abflag,-1		;set abort flag
	exit
noabt1:	CONOUT				;echo it
	mov	al,8			;assume thinkjet
	cmp	minpr,8			;no answer needed if thinkjet
	jz	usetj
	mov	ax,13
	CONOUT
	mov	al,rkey	
	sub	al,'1'			;change ascii to hex
	cmp	byte ptr PRNUM,0	;if paintjet
	jnz	notpj			; then bump
	add	al,4			;  offset to 4..7 
	jmp	short notxl
notpj:	cmp	byte ptr PRNUM,4	;if XL
	jnz	notxl			; then bump
	add	al,9			;  offset to 9..16
notxl:	cmp	al,minpr		;range minpr thru maxpr
	jl	usedfv
	cmp	al,maxpr
	jbe	usersl
usedfv:	mov	al,minpr 		;default is minimum (low res)
usersl:	sub	ah,ah
usetj:	sub	ah,ah
	mov	Qmode,ax		;save choice 0..8, 9..16
	mov	bx,ax
	shl	bx,1
;
	mov	ax,xmtbl[bx]		;set parameters for plot size
	dec	ax
	mov	dsxmax,ax
	mov	ax,xmtbl[bx]
	shr	ax,1
	shr	ax,1
	mov	dsxar,ax
	mov	ax,ymtbl[bx]
	dec	ax
	mov	dsymax,ax
	mov	ax,ymtbl[bx]
	shr	ax,1
	shr	ax,1
	mov	dsyar,ax
	mov	ax,titbl[bx]
	mov	pldpti,ax
	mov	ax,ctbl[bx]
	mov	cflag,al
;
;	transparency printing?
	cmp	byte ptr PRNUM,0	;only on paintjet
	jz	dotrsp
	cmp	byte ptr PRNUM,4	;or on XL
	jz	dotrsp
	jmp	nocswp
dotrsp:	RSCMSG	13			;ask if transparency desired
	CONIN
	cmp	al,3			;ctrl-C?
	jnz	xbart
	jmp	abort1
xbart:	mov	Qtrns,0			;assume no transparency
	push	ax
	CONOUT				;echo choice
	mov	ax,13
	CONOUT
	pop	ax
	cmp	al,'Y'			;determine answer
	jz	dotrm
	cmp	al,'y'
	jnz	notrm
dotrm:	mov	Qtrns,1			;set to use transp mode
;	color swaping desired?
notrm:	test	byte ptr cflag,1	;color plot?
	jnz	askcs
	exit
askcs:	RSCMSG	14			;ask if black or white background
	CONIN				;get key
	cmp	al,3			;ctrl-C?
	jz	abort1
	push	ax
	CONOUT				;echo it
	mov	ax,13
	CONOUT
	pop	ax
	mov	Qswap,0			;assume no color swap
	cmp	al,'N'
	jz	nocswp
	cmp	al,'n'
	jnz	docswp
nocswp:	exit				;yes
docswp:	mov	Qswap,1			;set for color 0 & 15 swap
	exit
abort1:	mov	abflag,-1		;set abort flag
	exit
;
;	---------------------------------------------------------------
;	PLSTART - Plotter-Specific start new plot dialog
;
;	CX = desired # of copies
;	---------------------------------------------------------------
;
PLSTART: entry
	mov	ax,PID
	cmp	ax,qpid			;device # must be = PID
	jnz	badpid
	jmp	short pidok
badpid:	mov	abflag,-1		;no - abort plot
	exit
pidok:	mov	abflag,0		;clear abort flag
	mov	bx,Qmode		;make word select index
	shl	bx,1
	mov	ax,nbtbl[bx]		;set parameters for plot size
	mov	nrbytes,ax
	mov	ax,nltbl[bx]
	mov	nrlines,ax
	mul	nrbytes
	mov	cbump,ax
	mov	ax,bndtbl[bx]
	mov	nrbands,ax		;init band count
	mov	bcount,ax		;= nrbands per page
	mov	bandxo,0
	mov	ax,xmtbl[bx]		;set parameters for plot size
	dec	ax
	mov	dsxmax,ax
	mov	ax,xmtbl[bx]
	shr	ax,1
	shr	ax,1
	mov	dsxar,ax
	mov	ax,ymtbl[bx]
	dec	ax
	mov	dsymax,ax
	mov	ax,ymtbl[bx]
	shr	ax,1
	shr	ax,1
	mov	dsyar,ax
	mov	ax,titbl[bx]
	mov	pldpti,ax
	mov	ax,xftbl[bx]
	mov	xflag,al
	mov	ax,ctbl[bx]
	mov	cflag,al
	mov	ax,pstbl[bx]
	mov	pscale,ax
	mov	ax,fmtbl[bx]
	mov	fmflag,al
;
	mov	si,istbl[bx]		;offset of init string
	mov	cx,[si]
	inc	si
	inc	si
	call	SENDDS
;
	mov	es,dwseg		;clear raster buffer
	cld				;upscan
	sub	di,di
	mov	cx,UserMP		;buffer word count
	shl	cx,1
	shl	cx,1
	shl	cx,1
	sub	ax,ax
	rep	stosw			;do clear buffer
;
	mov	trstg+3,'1'		;NOT transp mode
	test	word ptr Qtrns,1
	jz	notrx	
	mov	trstg+3,'3'		;IS transp mode
notrx:	mov	cx,trlen		;setup transpar mode command
	mov	si,offset trstg
	call	SENDDS
;
	mov	smap,15			;need to swap colors 15 & 0?
	mov	smap15,0
	test	word ptr Qswap,1
	jz	noswp
	mov	smap,0			;swap colors 15 & 0
	mov	smap15,15
noswp:	
	exit
;
;	PLCOMP - Plot vectors complete - finish plot
;
;	return AX=0 if ok, =-1 if another pass is needed
;
PLCOMP:	entry
	cmp	abflag,0		;plot aborted?
	jz	pcgol
	jmp	pcxt
pcgol:	mov	ax,nrbands		;calc pass number
	sub	ax,bcount		
	inc	ax			;(nrbands-bcount)+1
	mov	passnr,ax
	PSTATL				;position to status line
	RSCMSG	6,pnvar			;sending data pass # msg
	mov	ax,bcount		;first band?
	cmp	ax,nrbands
	jnz	midbnd
	mov	si,offset sstg		;2nd half of init command
	mov	cx,sslen		; to start raster mode
	call	SENDDS
;
midbnd:	mov	sndptr,0		;start data scan
	mov	cx,nrlines		;for all lines in this band
nxline:	push	cx
	mov	cofst,0
	test	byte ptr cflag,1	;print in color?
	jz	notclr
	mov	rsval+3,'V'		;needed for early color planes
	call	SRLN			;print color bit 0
	mov	ax,cbump		;print color bit 1
	add	cofst,ax
	call	SRLN
	mov	ax,cbump		;print color bit 2
	add	cofst,ax
	cmp	Qmode,7			;hires color (3 planes)?
	jz	notclr			;yes - last plane
	cmp	Qmode,12		;hires color (3 planes)?
	jz	notclr			;yes - last plane
	cmp	Qmode,16		;hires color (3 planes)?
	jz	notclr			;yes - last plane
do8cl:	call	SRLN
	mov	ax,cbump		;print color bit 3
	add	cofst,ax
notclr:	mov	rsval+3,'W'		;needed for last or only plane
	call	SRLN			;send raster line
	mov	ax,nrbytes		;advance scan ptr for next line
	add	sndptr,ax
	pop	cx			;raster line count
	loop	nxline			;do all lines in this Band
	cmp	bcount,1		;last Band?  then
	jz	lstbnd			;  fall out of multi-band loop
	PSTATL				;position to status line
	RSCMSG	7,pnvar			;rasterizing data pass # msg
	dec	bcount			;no - setup for next band
	mov	ax,nrlines
	add	bandxo,ax 
	mov	es,dwseg		;clear raster buffer
	cld				;upscan
	sub	di,di
	mov	cx,UserMP		;buffer word count
	shl	cx,1
	shl	cx,1
	shl	cx,1
	sub	ax,ax
	rep	stosw			;do clear buffer
	mov	ax,-1
	exit
lstbnd:	mov	cx,eslen		
	mov	si,offset estg
	call	SENDDS			;send end graphics string
pcxt:	mov	ax,0			;flag no further passes needed
	exit
;
SRLN	proc	near			;send raster line
	mov	si,sndptr		;point to data
	add	si,cofst		;add color block offset
	push	si
	mov	ES,dwseg		;remove empty bytes from right edge
	mov	di,si			;ES:di points to last byte of raster
	add	di,nrbytes
	dec	di
rpack:	cmp	byte ptr ES:[di],0	;byte empty of dots?
	jnz	eolfnd
	dec	di			;yes - look at prior byte
	cmp	si,di			;at start of line?
	jnz	rpack			;no keep packing line
eolfnd:	sub	di,si			;make AX = # of bytes to send
	inc	di
	mov	ax,di
	mov	scount,ax		;raster cmd needs # dot columns
	sub	dx,dx
	div	kw100
	add	al,'0'
	mov	rsval,al
	mov	al,dl
	div	kb10
	add	al,'0'
	mov	rsval+1,al
	add	ah,'0'
	mov	rsval+2,ah
prinBW:	mov	cx,rslen		;send raster line command
	mov	si,offset rstg
	call	SENDDS
	pop	si			;get next raster data
	push	es
	mov	cx,scount
	mov	es,dwseg
	call	SENDES			;send the whole line 
	pop	es
	ret
srln	endp
;
;
;	PLSTAT - Check & return AX = 0=ok/-1 to cancel status
;
PLSTAT:	entry
	or	ax,abflag		;return local abort status
	exit
;
;
;	DSCOLOR - specify current drawing color
;
DSCOLOR: entry
	and	ax,0FH			;valid colors 0..15
	mov	bx,ax			;allow B&W swap if needed
	mov	al,smap[bx]

	cmp	Qmode,16		;hires color (3 planes)?
	jz	sl8cl			;yes - last plane
	cmp	Qmode,12		;hires color (3 planes)?
	jz	sl8cl			;yes - last plane
	cmp	Qmode,7			;hires color?
	jz	sl8cl
	jmp	short dscxt
sl8cl:	mov	bx,ax			;yes - map to colors 0..7
	mov	al,cmap[bx]
dscxt:	mov	CurClr,ax		;set new current color
	mov	ctest,al		;4 LSBs map 4 color planes	
	exit
;
;	-------------- SDSUBS Macros ------------------------------
;
;	SDSUBS.CPY provides DSPOINT, DSLINE,DSREC, & DSFREC routines
;	(and DSFPAT, DSVTXT, and DSVFNT as well)
;	The following macros are used by SDSUBS.CPY:
;
;	DH = and mask, DL = or mask, AH = xor mask
;	SI = x, DI = Y
;	SI,DI,BP must be preserved.
;
;
SDGPM	macro				;get pixel modification masks
	call	gpm
	endm
;
GPM	proc	near
	test	byte ptr xflag,1	;does +X go down the page?
	jnz	xgpm			;yes
	mov	bx,si			;+X goes across the paper
	jmp	short gpcom
xgpm:	mov	bx,di			;+X goes down the paper
gpcom:	and	bx,7			;ptbl(x and 7) = pixel or mask
	mov	dl,ptbl[bx]
	mov	dh,dl
	not	dh
	ret
gpm	endp			
;
;
SDCBO	macro				;calculate byte offset to change
	call	cbo
	endm
;
CBO	proc	near
	test	byte ptr xflag,1	;does +X go down the page?
	jnz	xcbo			;yes
	mov	ax,dsymax
	sub	ax,di
	mov	Xscan,ax
	mov	Yscan,si
	jmp	short cbocom	
xcbo:	mov	Yscan,di		;save for SDUPL, SDDNL use
	mov	Xscan,si
cbocom:	mov	bflag,0			;1=inside this band
	push	dx			;save masks DH,DL,AH
	push	ax
	mov	ax,Xscan		;get X
	sub	ax,bandxo		;subtract band x-offset
	jl	notbnd
	cmp	ax,nrlines		;inside band?
	jge	notbnd
	mov	bflag,1			;yes - flag inside this band
	mul	nrbytes			;+X * nrbytes from SndPtr 
	mov	bx,Yscan		;+Y/8
	shr	bx,1	
	shr	bx,1
	shr	bx,1
	add	bx,ax			;ES:BX = byte to change
notbnd:	pop	ax			;restore masks
	pop	dx
	ret
cbo	endp
;
;
SDCSP	macro				;change selected pixel
	call	csp
	endm
;
CSP	proc	near			;change pixel
	test	byte ptr bflag,1	;inside this band?
	jz	nocsp
	test	byte ptr cflag,1	;print in color?
	jz	bwcsp
	push	bx			;scan for color bit sets
	mov	al,ctest
	shr	al,1			;red bit to carry
	jnc	notylw
	or	ES:[bx],dl		;set red bit
	jmp	short trycyn
notylw:	and	ES:[bx],dh		;clear red bit
trycyn:	add	bx,cbump
	shr	al,1			;green bit to carry
	jnc	notcyn
	or	ES:[bx],dl		;set green bit
	jmp	short trymag
notcyn:	and	ES:[bx],dh		;clear green bit
trymag:	add	bx,cbump
	shr	al,1			;blue bit to carry
	jnc	notmag
	or	ES:[bx],dl		;set blue bit
	jmp	short tryblk
notmag:	and	ES:[bx],dh		;clear blue bit
tryblk:	add	bx,cbump
	shr	al,1			;hi-lite bit to carry
	jnc	notblk
	or	ES:[bx],dl		;set hi-lite bit
	jmp	short clrxt
notblk:	and	ES:[bx],dh		;clear hi-lite bit
clrxt:	pop	bx			;restore original bx
	ret
bwcsp:	or	ES:[bx],dl		;set pixel for B&W
nocsp:	ret
csp	endp
;
;
SDUPL	macro				
	call	upl
	endm
;
UPL	proc	near			
	test	byte ptr xflag,1	;does +X go down the page?
	jnz	xupl			;yes
	dec	xscan			;move up one pixel
	push	si
	push	di
	mov	di,dsymax
	sub	di,xscan 
	mov	si,yscan
	sdcbo
	pop	di
	pop	si
	ret
xupl:	inc	yscan			;move up one across paper
	ror	dl,1			;advance or mask
	ror	dh,1
	test	yscan,7			;if new byte
	jnz	upz
	inc	bx			;then bump the offset
upz:	ret
upl	endp
;
;
SDDNL	macro				;move offset down one line
	call	dnl
	endm
;
DNL	proc	near
	test	byte ptr xflag,1	;does +X go down the page?
	jnz	xdnl			;yes
	inc	xscan			;move down one pixel
	push	si
	push	di
	mov	di,dsymax
	sub	di,xscan
	mov	si,yscan
	sdcbo
	pop	di
	pop	si
	ret
xdnl:	rol	dh,1			;move down one pixel (across paper)
	rol	dl,1			;advance or mask
	test	yscan,7			;if new byte
	jnz	dnz
	dec	bx			;then bump the offset
dnz:	dec	yscan	
	ret
dnl	endp
;
;
SDUPC	macro				;move right one pixel
	call	upc
	endm
;
UPC	proc	near
	test	byte ptr xflag,1	;does +X go down the page?
	jnz	xupc			;yes
	inc	yscan			;move right one pixel (across paper)
	ror	dl,1			;
	ror	dh,1			;
	test	yscan,7			;if new byte
	jnz	ucz
	inc	bx			;then bump the offset
ucz:	ret
xupc:	inc	xscan			;move right one pixel (down paper)
	push	si
	push	di
	mov	si,xscan
	mov	di,yscan
	sdcbo
	pop	di
	pop	si
	ret
upc	endp
;
SDDNC	macro				;move left one pixel
	call	dnc
	endm
;
DNC	proc	near
	test	byte ptr xflag,1	;does +X go down the page?
	jnz	xdnc			;yes
	rol	dl,1			;move right one pixel (across paper)
	rol	dh,1
	test	yscan,7			;if new byte
	jnz	dnzc
	dec	bx			;then bump the offset
dnzc:	dec	yscan
	ret
xdnc:	dec	xscan			;move left one pixel (up paper)
	push	si
	push	di
	mov	si,xscan
	mov	di,yscan
	sdcbo
	pop	di
	pop	si
	ret
dnc	endp
;
;
;	SDFHL - fast horizontal line
;
;	ES:[bx] = leftmost byte offset
;	BP = X1 scanner, if needed
;	CX = pixel count
;
sdfhl	macro
	call	BWFHL
	endm
;
BWFHL	proc	near
	mov	si,scanyl		;select current line pattern
	mov	fpctrl,0
	test	byte ptr fmflag,1	;magnify pattern?
	jz	nomag1
	mov	al,byte ptr PSNX	;yes - init toggle
	and	al,1
	mov	fpctrl,al
	shr	si,1			;and compress Y index
	and	si,7			;get fill pattern for Y index
	mov	ah,FilPat[si]
	push	cx			;horiz pattern sync
	mov	cx,PSNX
	shr	cx,1			;magnified
	and	cx,7
	rol	ah,cl
	pop	cx
	jmp	short fhl
nomag1:	and	si,7			;get fill pattern for Y index
	mov	ah,FilPat[si]
	push	cx			;horiz pattern sync
	mov	cx,PSNX
	and	cx,7
	rol	ah,cl
	pop	cx
fhl:	mov	al,fmflag		;magnify pattern if needed
	xor	fpctrl,al
	jz	nomag2
	ror	ah,1
nomag2:	rol	ah,1			;this pattern bit set?
	jnc	nfhl
	sdcsp				;yes
nfhl:	sdupc
	loop	fhl			;loop for entire line width
	ret
bwfhl	endp
;
	include	SDSUBS4.CPY
;
;	----------------- local use procedures ----------------------
;
;	SENDDS - send CX bytes to printer from DS:SI via ES:DI
;	SENDES - send CX bytes to printer from ES:SI via ES:DI
;
SENDDS	proc	near
	mov	ax,DS			;send ES:DI for CX bytes
	mov	ES,ax
SENDES:	mov	di,si
	mov	dx,14			;using Driver Services
	call	dword ptr DVRSVC
	ret				;characters sent
sendds	endp
;
;	----------------- local data items -------------------------
	align	4
DVRSVC	dd	0			;driver services routine pointer
SHdl	dd	0			;raster RAM bank handle
;
xscan	dw	0			;x scanner
yscan	dw	0			;y scanner for SDUPL, SDDNL
scount	dw	0			;send bytes count
sndptr	dw	0			;send data pointer
nrbytes	dw	90			;bytes per raster line
nrlines	dw	450			;raster lines per band
nrbands	dw	2			;bands/page
passnr	dw	0			;current banding pass #
bandxo	dw	0			;band starting x offset
bcount	dw	2			;current band countdown
kw100	dw	100			;constant
abflag	dw	0			;abort plot flag
cofst	dw	0			;color offset
cbump	dw	0			;# of bytes per color plane,
CurPat	dw	0FFFFH			;current line pattern
CurClr	dw	1			;current color #
Pscale	dw	4			;pixels per pattern bit
AlocSeg	dw	0			;raster	 buffer segment address
dwseg	dw	0			;drawing display segment
UserMP	dw	4050			;raster memory bfr size in paragraphs
;
;	parameter tables for plot selections
;prmode =      0    1    2    3    4    5    6    7    8
; XL uses -->  9   10   11   12   13   14   15   16 
;
;Byte/band-> 46k  62k  52k  63k  41k  65k  41k  65k  64k
;            41k  65k  41k  65k  58k  58k  58k  58k
;
nbtbl	dw    96, 192, 156, 312,  90, 180,  90, 180,  80 ;nrbytes/raster line
	dw    90, 180,  90, 180, 120, 240, 120, 240
;
nltbl	dw   480, 320, 332, 200, 450, 360, 112,  90, 800 ;nrlines per band
	dw   450, 360, 112,  90, 480, 240, 120,  60
;
bndtbl	dw     2,   6,   3,  10,   2,   5,   8,  20,   1 ;nrbands per page
	dw     2,   5,   8,  20,   3,  12,  12,  48
;
xmtbl	dw   960,1920,1248,2496, 900,1800, 896,1800, 800 ;dsxmax
	dw   900,1800, 896,1800,1440,2880,1440,2880
;
ymtbl	dw   768,1536, 996,2000, 720,1440, 720,1440, 640 ;dsymax
	dw   720,1440, 720,1440, 960,1920, 960,1920
;
restbl	dw    96, 192,  96, 192,  90, 180,  90, 180,  96 ;res. dots per inch
	dw    90, 180,  90, 180,  90, 180,  90, 180
;
titbl	dw   964,1926, 964,1926, 900,1800, 900,1800, 964 ;pldpti
	dw   900,1800, 900,1800, 900,1800, 900,1800
;
xftbl	dw     1,   1,   0,   0,   1,   1,   1,   1,   1 ;1=X along perf holes
	dw     1,   1,   1,   1,   1,   1,   1,   1
;
ctbl	dw     0,   0,   0,   0,   0,   0,   1,   1,   0 ;color available
	dw     0,   0,   1,   1,   0,   0,   1,   1
;
pstbl	dw     4,   8,   4,   8,   4,   8,   4,   8,   4 ;pscale (line styles)
	dw     4,   8,   4,   8,   4,   8,   4,   8
;
fmtbl	dw     0,   1,   0,   1,   0,   1,   0,   1,   0 ;fill patt mag flag
	dw     0,   1,   0,   1,   0,   1,   0,   1
;
istbl	dw   offset istg1, offset istg2, offset istg1, offset istg2
	dw   offset istg5, offset istg6, offset istg7, offset istg8
	dw   offset istg9, offset istg5, offset istg6, offset istg7
	dw   offset istg8, offset istgA, offset istgB, offset istgC
	dw   offset istgD
;
istg1	dw	6
	db	  27,'*t96R'
istg2	dw	7
	db	  27,'*t192R'
;
istg5	dw	18
	db	  27,'*t90R', 27,'*r720S', 27,'*r1U' 
istg6	dw	20
	db	  27,'*t180R', 27,'*r1440S', 27,'*r1U'
;
istg7	dw	379
	db	27,'*t90R',27,'*r720S', 27,'*r4U'
	db	27,'*v90A',27,'*v88B',27,'*v85C',27,'*v0I'
	db	27,'*v3A', 27,'*v26B',27,'*v22C',27,'*v1I'
	db	27,'*v53A',27,'*v8B', 27,'*v14C',27,'*v2I'
	db	27,'*v4A', 27,'*v4B', 27,'*v29C',27,'*v3I'
	db	27,'*v89A',27,'*v83B',27,'*v13C',27,'*v4I'
	db	27,'*v2A', 27,'*v22B',27,'*v64C',27,'*v5I'
	db	27,'*v53A',27,'*v5B', 27,'*v25C',27,'*v6I'
	db	27,'*v12A',27,'*v6B', 27,'*v24C',27,'*v7I'
	db	27,'*v72A',27,'*v41B',27,'*v13C',27,'*v8I'
	db	27,'*v3A', 27,'*v10B',27,'*v46C',27,'*v9I'
	db	27,'*v31A',27,'*v18B',27,'*v13C',27,'*v10I'
	db	27,'*v12A',27,'*v8B', 27,'*v10C',27,'*v11I'
	db	27,'*v29A',27,'*v56B',27,'*v20C',27,'*v12I'
	db	27,'*v6A', 27,'*v19B',27,'*v14C',27,'*v13I'
	db	27,'*v25A',27,'*v25B',27,'*v33C',27,'*v14I'
	db	27,'*v4A', 27,'*v4B', 27,'*v6C', 27,'*v15I'
;
istg8	dw	63
	db	27,'*t180R', 27,'*r1440S', 27,'*r3U'
	db	27,'*v90A',27,'*v88B',27,'*v85C',27,'*v0I'
	db	27,'*v4A', 27,'*v4B', 27,'*v6C', 27,'*v7I'
;
istg9	dw	7 
	db	27,'*r640S' 		;Unique init code for ThinkJet
;
istgA	dw	25
	db	27,'E',27,'&l6A'	;reset, ledger-size for XL
	db	27,'*t90R', 27,'*r960S', 27,'*r1U' 
;
istgB	dw	27
	db	27,'E',27,'&l6A'
	db	27,'*t180R', 27,'*r1920S', 27,'*r1U'
;
istgC	dw	386
	db	27,'E',27,'&l6A'
	db	27,'*t90R',27,'*r960S', 27,'*r4U'
	db	27,'*v90A',27,'*v88B',27,'*v85C',27,'*v0I'
	db	27,'*v3A', 27,'*v26B',27,'*v22C',27,'*v1I'
	db	27,'*v53A',27,'*v8B', 27,'*v14C',27,'*v2I'
	db	27,'*v4A', 27,'*v4B', 27,'*v29C',27,'*v3I'
	db	27,'*v89A',27,'*v83B',27,'*v13C',27,'*v4I'
	db	27,'*v2A', 27,'*v22B',27,'*v64C',27,'*v5I'
	db	27,'*v53A',27,'*v5B', 27,'*v25C',27,'*v6I'
	db	27,'*v12A',27,'*v6B', 27,'*v24C',27,'*v7I'
	db	27,'*v72A',27,'*v41B',27,'*v13C',27,'*v8I'
	db	27,'*v3A', 27,'*v10B',27,'*v46C',27,'*v9I'
	db	27,'*v31A',27,'*v18B',27,'*v13C',27,'*v10I'
	db	27,'*v12A',27,'*v8B', 27,'*v10C',27,'*v11I'
	db	27,'*v29A',27,'*v56B',27,'*v20C',27,'*v12I'
	db	27,'*v6A', 27,'*v19B',27,'*v14C',27,'*v13I'
	db	27,'*v25A',27,'*v25B',27,'*v33C',27,'*v14I'
	db	27,'*v4A', 27,'*v4B', 27,'*v6C', 27,'*v15I'
;
istgD	dw	70
	db	27,'E',27,'&l6A'
	db	27,'*t180R', 27,'*r1920S', 27,'*r3U'
	db	27,'*v90A',27,'*v88B',27,'*v85C',27,'*v0I'
	db	27,'*v4A', 27,'*v4B', 27,'*v6C', 27,'*v7I'
;
sslen	dw	5
sstg	db	27,'*r0A'
;
rslen	dw	7
rstg	db	27,'*b'
rsval	db	'000W'			;use 'V' for color planes
;
trlen	dw	5
trstg	db	27,'&k3W'		;transparency printing
;
eslen	dw	6
estg	db	27,'*rB',27,'E'
;
cmap	db	0,2,1,4,3,6,5,6,1,4,4,1,2,2,5,7 ;hires color remap
ctest	db	8			;8=black, 4=blu, 2=grn, 1=red
;
smap	db	0,1,2,3,4,5,6,7,8,9,10,11,12,13,14	;swap colors map
smap15	db	15
;
ptbl	db	80H,40H,20H,10H,8,4,2,1
;
kb10	db	10			;constant
fpctrl	db	0			;fill pattern magnify toggle
fmflag	db	1			;fill pattern magnify flag
bflag	db	0			;band flag 1=inside band, 0=outside
cflag	db	0			;color flag
xflag	db	1			;xflip flag 1=narrow, 0=wide paper
rkey	db	0			;key returned from res dialog
plottp	db	1			;
;
;	---------------- global data items -------------------------
;
	align	4
plidrn	dw	1			;plotter ID text resource #
dsxmax	dw	899			;# X dots -1
dsymax	dw	719			;# Y dots -1
dsyar	dw	8			;aspect ratio Y/X
dsxar	dw	10	
pldpti	dw	964			;# of dots per 10 inches
plnpens	dw	15			;# of pens -1
plpwid	dw	1			;width of pen in horiz raster lines
plflags	dw	1003H			;ptf/dscir/dsarc available
ptft1	db	'PLT'			;plot to full file type
ptft2	db	'PLT'			;plot to image file type
port	dw	0			;destination port # 0..N
dest	dw	3			;config destination # 0..N (DOS PRN)
idata	dw	00E7h			;init 9600 baud, no par, 2 stop,8 dta
	dw	0,0,0,0,0		;reserved
;
PLQDTA	dw	8			;# bytes of PLOTQ data
qpid	dw	0			;PLOTQ stored pid value
qtrns	dw	0			;transparency mode req'd
qswap	dw	0			;flag to swap colors 0 & 15
qmode	dw	0			;print mode desired 0..8
;
;	---------------- Plot Driver Text Resources -----------------
;
pnvar	dw	offset passnr		;pass # message var list
	dw	offset nrbands
;
PLRSC	dw	17			;# of resources provided
	dw	offset plid		;1 - generic plotter ID
	dw	offset ResPJ		;2 - PJ resolution choices
	dw	offset ResQJP		;3 - QJ+ resolution choices
	dw	offset ResQJ		;4 - QJ resolution choices
	dw	offset ResTJ		;5 - TJ resolution choice
	dw	offset pasmsg		;6 - sending data...
	dw	offset rasmsg		;7 - rasterizing next...
	dw	offset prid1		;8 - PaintJet
	dw	offset prid2		;9 - QuietJet Plus
	dw	offset prid3		;10 - QuietJet
	dw	offset prid4		;11 - ThinkJet
prsl	dw	offset prntsl		;12 - printer selection
	dw	offset trmodq		;13 - transparency quiz
	dw	offset cswpm		;14 - swap 0 & 15 colors?
	dw	offset ResXL		;15 - XL resolution choices
	dw	offset prid5		;16 - XL id
	dw	offset ptp		;17 - id quiz no.

;
plid	db	'HP "Ink-Jet" family printers.',0
prid1	db	'HP PaintJet:',0
prid2	db	'HP QuietJet Plus:',0
prid3	db	'HP QuietJet:',0
prid4	db	'HP ThinkJet:',0
prid5	db	'HP PaintJet XL:',0
;
ResPJ	db    13
	db    '  1 -   10.0"x 8.0"   B&W    90 dpi   2 passes',13
	db    '  2 -   10.0"x 8.0"   B&W   180 dpi   5 passes',13
	db    '  3 -   10.0"x 8.0"  color   90 dpi   8 passes',13
	db    '  4 -   10.0"x 8.0"  color  180 dpi  20 passes',13
	db	13,'Select desired plot 1..4 [1]: ',0
;
ResQJP	db    13
	db    '  1 -   10.0"x 8.0"    B&W   96 dpi   2 passes',13
	db    '  2 -   10.0"x 8.0"    B&W  192 dpi   6 passes',13
	db    '  3 -   13.0"x10.4"    B&W   96 dpi   3 passes',13
	db    '  4 -   13.0"x10.4"    B&W  192 dpi  10 passes',13
	db	13,'Select desired plot 1..4 [1]: ',0
;
ResQJ	db    13
	db    '  1 -   10.0"x 8.0"    B&W   96 dpi   2 passes',13
	db    '  2 -   10.0"x 8.0"    B&W  192 dpi   6 passes',13
	db	13,'Select desired plot 1..2 [1]: ',0
;
ResTJ	db    13
	db    '  8.33"x 6.67"    B&W   96 dpi   1 pass',13
	db    13,'Press RETURN to continue: ',0
;
ResXL	db    13
	db    '  1 -   10.0"x 8.0"   B&W    90 dpi   2 passes',13
	db    '  2 -   10.0"x 8.0"   B&W   180 dpi   5 passes',13
	db    '  3 -   10.0"x 8.0"  color   90 dpi   8 passes',13
	db    '  4 -   10.0"x 8.0"  color  180 dpi  20 passes',13
	db    '  5 -   16.0"x10.6"   B&W    90 dpi   3 passes',13
	db    '  6 -   16.0"x10.6"   B&W   180 dpi  12 passes',13
	db    '  7 -   16.0"x10.6"  color   90 dpi  12 passes',13
	db    '  8 -   16.0"x10.6"  color  180 dpi  48 passes',13
	db    13,'Select desired plot 1..8 [1]: ',0
;
pasmsg	db	'Rasterization pass !2 of !2 completed.'
	db	' Sending data to printer...',0
rasmsg	db	'Rasterization pass !2 of !2 completed.'
	db	' Rasterizing next pass...  ',0
;
prntsl	db	13,10,'Supported printers:',13,10,13,10
	db	'  1 - PaintJet ',13,10
	db	'  2 - QuietJet Plus (switch 5 down)',13,10
	db	'  3 - QuietJet (switch 5 down)',13,10
	db	'  4 - ThinkJet (switch 5 down)',13,10
	db	'  5 - PaintJet XL',13,10
	db	13,10,'Select your printer 1..5 ['
ptp	db	'1]: $'
;
trmodq	db	13,'Print on transparency Y[N] ? ',0
cswpm	db	'Switch black & white for plot N[Y] ? ',0
;
;	-------------------------------------------------------
;
	include PLLAST.CPY
