;	---------------------------------------------------------------
;	PLSUBS.CPY - Generic Drawing Routines using MOVETO,DRAWTO
;	---------------------------------------------------------------
;
;	(c) Copyright 1986 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle  5/25/86
;	cloned from SDSUBS.CPY
;
	include	ITRIG.CPY
	include	PLPOLY.CPY
	include	BPLSUBS.CPY
;
;	This module provides the DSPAT, DSFPAT,DSVTXT, DSVFNT,
;	DSREC, DSFREC, and DSPOLY routines through the SDOT model
;	of vector generation for pen plotters.
;
;	use of this module requires:
;
;	Local MOVETO(si,di) and DRAWTO(si,di) near procedures, and
;	PSCALE DW n, where n is number of pixels per pattern bit.
;
;	DSLINE - draw a line of current color and pattern
;
;	SI = X1, DI = Y1
;	DX = X2, AX = Y2
;
DSLINE:	entry
	call	drwline
	exit
;
DSFPAT:	entry			;fill pattern #
	push	si		;save vector form
	mov	si,di		;copy fill pattern
	lea	di,FilPat
	mov	ax,ES
	mov	bx,DS
	mov	DS,ax
	mov	ES,bx
	cld			;upscan
	mov	cx,4		;8 bytes
	rep	movsw
	pop	si		;copy vector form data
	lea	di,FilSP1
	mov	cx,20		;20 words
	rep	movsw
	exit
;
FilPat	db	8 dup (0FFH)	;current fill pattern
;
FilSP1	dw	1		;set 1 spacing in pen widths
FilPL1	dw	16		;set 1 pattern length in pen widths
FilA1	dw	0		;set 1 angle
FilS1	dw	0FFFFH		;set 1 style
FilO1	dw	0		;set 1 line space offset
FilSP2	dw	1		;set 2 spacing in pen widths
FilPL2	dw	16		;set 2 pattern length in pen widths
FilA2	dw	0		;set 2 angle
FilS2	dw	0		;set 2 style
FilO2	dw	0		;set 2 line space offset
FilSP3	dw	1		;set 3 spacing in pen widths
FilPL3	dw	16		;set 3 pattern length in pen widths
FilA3	dw	0		;set 3 angle
FilS3	dw	0		;set 3 style
FilO3	dw	0		;set 3 line space offset
FilSP4	dw	1		;set 4 spacing in pen widths
FilPL4	dw	16		;set 4 pattern length in pen widths
FilA4	dw	0		;set 4 angle
FilS4	dw	0		;set 4 style
FilO4	dw	0		;set 4 line space offset
;
