;	---------------------------------------------------------------
;	SDSUBS4.CPY - Generic Drawing Routines using SDOT
;	---------------------------------------------------------------
;
;	(c) Copyright 1986..1990 Evolution Computing
;	All rights reserved.
;	Modified from SDSUBS3.CPY by Mike Riddle 5/19/90
;
pbump	macro
	local	pcok,pcskp
	dec	pcount
	jnz	pcok
	ifdef	LSScl
	mov	pcount,LSScl
	else
	push	PScale
	pop	PCount
	endif
	ror	upatrn,1
pcok:	test	byte ptr upatrn,1
	jz	pcskp
	sdcsp
pcskp:
	endm
;
unpbmp	macro
	inc	pcount
	endm
;
;	DSPAT - set current line pattern from AX
;
DSPAT:	entry
	mov	CurPat,ax
	mov	bp,curpat	;initialize line pattern
	mov	upatrn,bp
	ifdef	LSScl
	mov	pcount,LSScl
	else
	push	PScale
	pop	PCount
	endif
	exit
;
DSFPAT:	entry			;fill pattern #
	mov	si,di		;copy fill pattern
	lea	di,FilPat
	mov	ax,ES
	mov	bx,DS
	mov	DS,ax
	mov	ES,bx
	cld			;upscan
	mov	cx,4		;8 bytes
	rep	movsw
	exit
;
FilPat	db	8 dup (0FFH)	;current fill pattern
;
;	DSPOINT - draw a single point
;
;	SI = X coordinate
;	DI = Y coordinate
;
DSPOINT: entry
	mov	ES,dwseg	;select display segment
	sdgpm			;get pixel masks
	sdcbo			;calc byte offset
	sdcsp			;change selected pixel
	exit
;
;	DSLINE - draw a line of current color and pattern
;
;	SI = X1, DI = Y1
;	DX = X2, AX = Y2
;
DSLINE:	entry
	call	DOLINE		;draw line
	exit
;
;	DSREC - draw a rectangle of current color and pattern
;
;	SI = X1, DI = Y1
;	DX = X2, AX = Y2
;
DSREC:	entry
	mov	ES,dwseg		;select display segment
	mov	x1,si			;save parameters
	mov	y1,di
	mov	x2,dx
	mov	y2,ax
	mov	dx,si			;left side
	call	DOLINE
	mov	si,x1			;top side
	inc	si
	mov	di,y2
	mov	dx,x2
	dec	dx
	mov	ax,y2
	call	DOLINE
	mov	si,x2			;right side
	mov	di,y2
	mov	dx,x2
	mov	ax,y1
	call	DOLINE
	mov	si,x2			;bottom
	dec	si
	mov	di,y1
	mov	dx,x1
	inc	dx
	mov	ax,y1
	call	DOLINE
	exit
;
;	DSFREC - draw a rectangle filled with the current color and mode
;
;	SI = X1, DI = Y1
;	DX = X2, AX = Y2
;
DSFREC:	entry
	mov	ES,dwseg	;select display segment
	cmp	si,dx		;order X values
	jbe	fxok
	xchg	si,dx
fxok:	cmp	di,ax		;order Y values
	jbe	fyok
	xchg	di,ax
fyok:	mov	x1,si		;save parameters
	mov	y1,di
	mov	scanyl,di	;(for SDFHL use)
	mov	x2,dx
	mov	y2,ax
	mov	cx,ax		;CX = line count
	sub	cx,di
	inc	cx
	push	cx
	sub	dx,si		;CX = pixel count
	mov	cx,dx
	inc	cx
	mov	pixct,cx
	sdgpm			;get pixel masks
	sdcbo			;calculate byte offset
	pop	cx		;cx = line count
frec:	push	cx		;cx = line count
	push	bx		;bx = line start offset
	push	dx		;dx = pixel starting masks
	mov	bp,X1		;X scanner for SDUPC
	mov	cx,pixct	;line pixel count
	SDFHL			;draw fast horiz line
	pop	dx		;restore start of line
	pop	bx
	sdupl			;up one line
	inc	scanyl		;(for sdfhl use)
	pop	cx
	loop	frec		;loop for all lines
	exit
;
	align	2
pixct	dw	0		;line pixel count for FREC
upatrn	dw	0		;line pattern currently in use
pcount	dw	0		;pscale countdown
x1	dw	0
y1	dw	0
x2	dw	0
y2	dw	0
;
	include	SDLINE.CPY
	include	ITRIG.CPY
	include	SDCIR.CPY
	include	SDPOLY.CPY
;
