;	----------------------------------------------------------------
;	VTEXT.CPY - generic raster prompt text routines
;	            for variable sized prompt text
;	----------------------------------------------------------------
;
;	(c) Copyright 1986 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle  1/5/1986
;	modified for 8/16 raster independence 3/5/86
;	modified for CGEN in resource segment 3/6/88
;
;	DSTEXT - display prompt text
;	DSITXT - display inverted prompt text
;
;	ES:DI = text string address
;	        (string ended by a 0 byte)
;	DX    = desired text line number (0 top)
;	AX    = desired text column number (0 right)
;
DSTEXT:	entry
	mov	tiflag,0		;no text inversion
	jmp	short dscom
DSITXT:	entry
	mov	tiflag,-1		;invert text
dscom:	cchro				;calc character offset to BX
	cld				;upscan
txlup:	mov	al,ES:[di]		;get next character
	inc	di
	cmp	al,8			;backspace?
	jz	isbksp
	cmp	al,0			;end of string?
	jnz	dochr
	call	spccm			;restore draw color/mode
	exit
isbksp:	sub	bx,tccw			;back up chr cell
	jmp	short txlup		;loop for next chr
dochr:	sub	ah,ah			;si=ASCII8 value of chr
	mov	si,ax
	push	bx
	push	es			;ES=drawing segment
	mov	ES,dwseg
	mov	bp,tiflag		;BP=inversion flag
	mov	cx,nrast		;CX=# raster loops for GCHR
	mov	dx,tccw			;DX=text chr cell width in bytes
	push	DS
	mov	DS,CGSeg		;DS = char gen rsc segment
	shl	si,1			;word index to CGEN data for chr
	mov	si,[si]	
	gchr				;generate character
	pop	DS
	pop	es
	pop	bx
	add	bx,tccw			;move chr cell right
	jmp	txlup			;loop for all characters
;
;	DSTINV - invert text cells
;
;	DX = desired line number (0 top)
;	AX = desired column number (0 left)
;	CX = number of char. positions
;
DSTINV:	entry
	cchro				;calc char offset to BX
	mov	di,nrast		;raster counter
	mov	bp,dwseg		;drawing segment
	mov	es,bp
tilup:	push	cx
	push	bx
	invcr				;invert raster line
	pop	bx
	pop	cx
	sddnl				;move down to next raster line
	dec	di			;loop for all rasters
	jnz	tilup
	call	spccm			;restore draw color/mode
	exit
;
;	DSTCLR - clear text cells
;
;	DX = desired line number (0 top)
;	AX = desired column number (0 left)
;	CX = number of char. positions
;
DSTCLR:	entry
	cchro				;calc char offset to BX
	mov	di,nrast		;raster counter
	mov	bp,dwseg		;drawing segment
	mov	es,bp
tclup:	push	cx
	push	bx
	clrcr				;invert raster line
	pop	bx
	pop	cx
	sddnl				;move down to next raster line
	dec	di			;loop for all rasters
	jnz	tclup
	call	spccm			;restore draw color/mode
	exit
;
tiflag	dw	0			;text invert flag
CGSeg	dw	0			;character gen resource segment
;
