;	FMAKER.ASM - FastCAD(R) External Procedure Module
;	This XP module builds Vector Fonts
;
;	(c) Copyright 1988 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle 3/8/88
;	modified 8/25/88 MR for Plotter SmartFonts
;
	name	FMAKER
;
version	equ	'0.06'
;
	include	XPSTART.CPY
;
;	---------------------------------------------------------------
;	XCMD - External Process Command - command # BX
;
;	commands 0..10 are preassigned signals
;	user commands start with command #11
;	---------------------------------------------------------------
;
XCMD:	ENTRY
	shl	bx,1			;make word index
	add	bx,offset cmdtbl
	mov	bx,[bx]			;get command offset
	jmp	bx			;go to command handler
cmdtbl	dw	offset nulcmd		;0 = Startup ExtProc
	dw	offset nulcmd		;1 = Ending use of ExtProc
	dw	offset nulcmd		;2 = Drawing renamed
	dw	offset justld		;3 = Drawing Just Loaded
	dw	offset nulcmd		;4 = Drawing about to be saved
	dw	offset nulcmd		;5 = Drawing REVERTed to prior save
	dw	offset nulcmd		;6 = before getting next command
	dw	offset nulcmd		;7 = regen completed - repath
	dw	offset nulcmd		;8 = unused
	dw	offset nulcmd		;9 = unused
	dw	offset nulcmd		;10 = unused
	dw	offset Font		;11 = FONT command
	dw	offset Font2		;12 = FONT command, part 2
	dw	offset FARC		;13 = FONT ARC command
	dw	offset FCHR		;14 = FONT Character Select
	dw	offset FONTV		;15 = FMAKER Version Box
	dw	offset FONTC		;16 = Font Compile
	dw	offset FONTI		;17 = Font Import
	dw	offset FONTI2		;18 = Font Import, part 2
	dw	offset FSPEC		;19 = Font Specifications
;	other commands offsets go here
nulcmd:	EXIT
;
;	---------------------------------------------------------------
;	XENTITY - External Process Entity Support
;	---------------------------------------------------------------
;
XENT:	ENTRY
	mov	bx,ax			;desired op # in AX
	shl	bx,1			;make word index
	add	bx,offset eftbl
	mov	bx,[bx]			;get entity function offset
	jmp	bx			;go to function  handler
eftbl	dw	offset xdraw		;0 = draw entity
	dw	offset xpick		;1 = pick test entity
	dw	offset xmove		;2 = move entity
	dw	offset xstrch		;3 = stretch entity
	dw	offset xlist		;4 = list entity
	dw	offset xxchk		;5 = check entity extents
	dw	offset xatch		;6 = attach to entity
	dw	offset xact		;7 = actuate entity
nullop:	finit
	clc
	EXIT
;
;	---------------------------------------------------------------
;	XCSTG - Command Name String
;
;	Each command word is UPPERCASE, space delimited.
;	---------------------------------------------------------------
;
XPEXID	equ	01001H			;EXID for this module
;
XCSTG	db	'FONT FONT2 FARC FCHR FONTV FONTC FONTI FONTI2 FSPEC '
	db	0			;end of command word table
;
;	---------------------------------------------------------------
;	DOS Identification Message
;	---------------------------------------------------------------
;
ident	db	'FMAKER - Vector Font Maker.',13,10
	db	'FastCAD(R) External Procedure Module - version '
	db	version,13,10
	db	'(C) Copyright 1988 Evolution Computing',13,10,'$'
;
;	---------------------------------------------------------------
;	FONTV - FontMaker Version Box
;	---------------------------------------------------------------
;
verdlg	dw	offset verdtx
	dw	29,5,0
;
verdtx	db	'   FontMaker version ',version,'    ',0
	db	' (c)1988 Evolution Computing ',0
	db	'   437 S. 48th Street #106   ',0
	db	'       Tempe, AZ 85281       ',0
	db	'     Phone (602)967-8633     ',0
;
FONTV:	mov	ax,DS			;show the box
	mov	ES,ax
	lea	di,verdlg
	SVC	SDLOG
	SVC	QDLOG
	SVC	EDLOG
	EXIT
;
;	---------------------------------------------------------------
;	FSPEC - Font Specifications
;	---------------------------------------------------------------
;
spdlg	dw	offset spdtx
	dw	36,13,9
	dw	13,1,4,1,0,  31,1,4,1,0,  13,3,4,1,0,  31,3,4,1,0
	dw	13,5,4,1,0,  31,5,4,1,0,  1,9,34,1,0, 21,11,5,1,0
	dw	30,11,2,1,'O'
;
spdtx	db	'                                    ',0
	db	' Max Y pos:  .... Font height: .... ',0
	db	'                                    ',0
	db	' Base Y pos: .... Low Y pos:   .... ',0
	db	'                                    ',0
	db	' Chr space:  .... Line space:  .... ',0
	db	'                                    ',0
	db	' Plotter font name:                 ',0
	db	'                                    ',0
	db	' .................................. ',0
	db	'                                    ',0
	db	' Plot height n/1000: .....    OK    ',0
	db	'                                    ',0
;
spvar	db	0,0,0,0			;var list
	dw	1,2,ftmax
	dw	2,2,fhgt
	dw	3,2,fbase
	dw	4,2,ftmin
	dw	5,2,fcsp
	dw	6,2,flsp
	dw	7,5,SmartFN
	dw	8,2,SmartFS
	dw	0			;end of list
;
FSPEC:	test	fflags,4000h		;given name space?
	jnz	short sfns
	mov	SmartFS,0		;no - init values
	mov	SmartFN,0
sfns:	mov	ax,DS			;show the box
	mov	ES,ax
	lea	di,spdlg
	SVC	SDLOG
nxspec:	mov	ax,DS			;edit variables
	mov	ES,ax
	lea	di,spvar
	SVC	VDLOG
	cmp	al,0			;cancel?
	jle	fsdone
	cmp	al,9			;ok?
	jl	nxspec
fsdone:	SVC	EDLOG			;done
	or	fflags,4000h		;flag has name space
	call	PUTHDR			;update in database
	call	showit			;redisplay revised grid
	EXIT
;
;	---------------------------------------------------------------
;	Font header entity structure & routines
;	---------------------------------------------------------------
;
;	Each font drawing contains 1 & 1 only font header entity:
;
fnthdr	STRUC		;entity length = 66 bytes
fntcom	db	9 dup (0);common stuff
tshgt	dw	0	;# vectors in txt body height.
tsmax	dw	0	;Maximum vector value (normally, top of text body).
tsbase	dw	0	;Text Baseline Y Vector value.
tsmin	dw	0	;Minimum vector value (normally, lowest descender).
tscsp	dw	0	;# vectors intercharacter spacing (horizontal).
tslsp	dw	0	;# vectors interline spacing (vertical).
tsflgs	dw	0	;Special handling flags (normally 0).
SFS	dw	0	;smart plot file size n/1000 of text hgt
SFN	db	41 dup (0) ;smart plot file font name
fnthdr	ends
;
FWTBL	db	2			;font format ID #2
	db	255 dup (0FFh)		;font width table
FOTBL	dw	512+256			;offset of FHGT specs
	dw	255 dup (0)		;vector offset table
fhgt	dw	48			;current font's header values
ftmax	dw	63
fbase	dw	15
ftmin	dw	0
fcsp	dw	12
flsp	dw	16
fflags	dw	0
SmartFS	dw	0			;smart font size factor
SmartFN	db	41 dup (0)		;smart font file name
FVDTA	db	16384 dup (0)		;font vector data
;
;	FIND - Find the current Drawings Font Header Entity
;	JC set if found, clear if not.  Header is in ENTREC at ES:DI
;	if it was found and may be modified with SVC MODIFY now.
;
FIND	proc	near
	SVC	SELALL			;scan entire drawing
	sub	dx,dx			;starting with record 0:0
	sub	ax,ax
	SVC	STSCAN
aloop:	jc	awasf			;at end of file?
	ret				;yes - not found (JNC)
awasf:	cmp	ES:etype[di],16		;ext entity?
	jnz	anext
	cmp	ES:xetype[di],1		;font header subentity?
	jnz	anext
	mov	ax,XPEXID		;this XP modules' entity?
	cmp	ES:exid[di],ax
	jnz	anext
	stc				;yes - found it (JC)
	ret
anext:	SVC	NXSCAN			;not it - try next entity
	jmp	aloop
find	endp
;
;	GETHDR - get current header information from database
;	JC set if found, clear if not.  Header is in ENTREC at ES:DI
;	if it was found and may be modified with SVC MODIFY now.
;
GETHDR	proc	near
	call	FIND			;first, find it
	jc	gwasf
	ret				;JNC not found
gwasf:	mov	ax,ES:tshgt[di]		;copy information from entity
	mov	fhgt,ax
	mov	ax,ES:tsmax[di]
	mov	ftmax,ax
	mov	ax,ES:tsbase[di]
	mov	fbase,ax
	mov	ax,ES:tsmin[di]
	mov	ftmin,ax
	mov	ax,ES:tscsp[di]
	mov	fcsp,ax
	mov	ax,ES:tslsp[di]
	mov	flsp,ax
	mov	ax,ES:tsflgs[di]
	mov	fflags,ax
	mov	ax,ES:SFS[di]
	mov	SmartFS,ax
	lea	di,SFN[di]
	lea	si,SmartFN
	mov	cx,41
gflup:	mov	ax,ES:[di]
	mov	[si],ax
	inc	si
	inc	di
	loop	gflup
	stc				;was copied
	ret
gethdr	endp
;
;	PUTHDR - write current header information to database
;	JC set if found, clear if not.  Header is in ENTREC at ES:DI
;	if it was found and may be modified with SVC MODIFY now.
;
PUTHDR	proc	near
	call	FIND			;first, find it
	jnc	pnotf
	jmp	pwasf
pnotf:	les	di,ENTRP		;not found - build one
	mov	ES:etype[di],16		;external entity
	mov	ES:erlen[di],66		;66 bytes long
	mov	ES:elayer[di],0		;on layer 0
	mov	ES:ecolor[di],14	;color 14 (grey)
	mov	ES:estyle[di],0		;no style
	mov	ax,xpexid		;module id
	mov	ES:exid[di],ax
	mov	ES:xetype[di],1		;subentity type 1 = header
	mov	ax,fhgt			;copy information to entity
	mov	ES:tshgt[di],ax
	mov	ax,ftmax
	mov	ES:tsmax[di],ax
	mov	ax,fbase
	mov	ES:tsbase[di],ax
	mov	ax,ftmin
	mov	ES:tsmin[di],ax
	mov	ax,fcsp
	mov	ES:tscsp[di],ax
	mov	ax,flsp
	mov	ES:tslsp[di],ax
	mov	ax,fflags
	mov	ES:tsflgs[di],ax
	lea	di,SFS[di]		;SFS & SFN
	lea	si,SmartFS
	cld
	mov	cx,41
	rep	movsw
	SVC	APND			;append entity	
	call	SHOWIT			;redisplay screen
	ret				;JNC not found
pwasf:	mov	ax,fhgt			;copy information to entity
	mov	ES:tshgt[di],ax
	mov	ax,ftmax
	mov	ES:tsmax[di],ax
	mov	ax,fbase
	mov	ES:tsbase[di],ax
	mov	ax,ftmin
	mov	ES:tsmin[di],ax
	mov	ax,fcsp
	mov	ES:tscsp[di],ax
	mov	ax,flsp
	mov	ES:tslsp[di],ax
	mov	ax,fflags
	mov	ES:tsflgs[di],ax
	SVC	MODIFY			;modify entity in place
	call	SHOWIT			;redisplay screen
	ret
puthdr	endp
;
;	SHOWIT - Zoom to a window that shows our workfield
;
SHOWIT	proc	near
	les	di,HDRP			;key = current layer
	mov	al,ES:clayer[di]
	mov	key,al
	lea	di,VisLyrs[di]		;point to vislayers
	mov	cx,16			;16 words
	sub	ax,ax			;hide them all
	cld
	rep	stosw
	mov	al,key			;show key layer
	sub	ah,ah
	SVC	SHOW
	mov	ax,0			;show layer 0
	SVC	SHOW
	mov	ax,0			;but freeze it
	SVC	FREEZE
	fild	ftmin			;lower-left corner
	fld1
	fsubp	st(1),st
	fld	st(0)
	fild	ftmax			;upper-right corner
	fld1
	faddp	st(1),st
	fld	st(0)
	SVC	ZWIN			;zoom to it
	ret
showit	endp
;
;	---------------------------------------------------------------
;	JUSTLD - File Just Loaded Signal Processing
;	---------------------------------------------------------------
;
jdis	db	0			;justld disable flag
;
JUSTLD:	test	jdis,1			;disabled (doing FONT command)?
	jz	dojld
	EXIT
dojld:	call	gethdr			;get text header if any
	jc	isfont
	EXIT
isfont:	les	di,HDRP			;key = current layer
	mov	al,ES:clayer[di]
	mov	key,al
	mov	ax,DS			;EXEC setup commands
	mov	ES,ax
	lea	di,jlcmds
	SVC	EXECST
	EXIT				;go let it happen
;
jlcmds	db	'ECOFF;RDOFF;MENU;FMAKER;RDON;ECON;REDRAW;',0
;
;	---------------------------------------------------------------
;	FONT - Load & Initialize Font Drawing
;	---------------------------------------------------------------
;
FONT:	mov	jdis,1			;disable load signal processing
	mov	ax,DS			;EXEC setup commands
	mov	ES,ax
	lea	di,nfcmds
	SVC	EXECST
	EXIT				;go let it happen
;
FONT2:	mov	jdis,0			;re-enable load signal processing
	call	gethdr			;get text header
	call	puthdr			;write header data to database
	mov	key,32			;key being defined = layer #
	jmp	FSPEC			;get/revise specs
;
nfcmds	db	'ECOFF;RDOFF;LOAD ^D;N;MENU;FMAKER;'
	db	'LAYER 32;SNAPV 1;GRIDV 1;;GRIDOFF;'
	db	'DFMT;N;HIDEA;RDON;ECON;FONT2;',0
;
;	---------------------------------------------------------------
;	FCHR - Switch to Font Character
;	---------------------------------------------------------------
;
chrp	db	'Key to define:',0
;
FCHR:	mov	dx,dslin		;clear prompt line
	dec	dx
	mov	ax,0
	mov	cx,dscol
	CALLDP	DSTCLR
	mov	ax,DS			;prompt for key
	mov	ES,ax
	mov	dx,dslin
	dec	dx
	mov	ax,0
	lea	di,chrp
	CALLDP	DSTEXT
	SVC	GMKEY			;get keypress
	cmp	al,32			;<space?
	jbe	short nokey
	les	di,HDRP			;key = current layer
	mov	ES:clayer[di],al
	call	showit			;show the desired layer
nokey:	EXIT
;
;	---------------------------------------------------------------
;	FARC - Acquire FONT ARC
;	---------------------------------------------------------------
;
actrp	db	'Arc center:',0
aradp	db	'Arc radius:',0
asap	db	'Arc start:',0
aeap	db	'Arc end:',0
k128	dw	128			;constant
;
FARC:	SVC	SUNADD			;undo = unadd
	SVC	CINFO			;get current information
	les	di,ENTRP		;create arc entity
	mov	ES:etype[di],5		;arc
	mov	ES:erlen[di],26		;26 bytes long
	mov	ES:elayer[di],dl	;on key layer
	mov	ES:ecolor[di],al	;color
	mov	ES:estyle[di],0		;no style
	mov	ax,DS			;get arc center
	mov	ES,ax
	lea	si,actrp
	mov	ax,0			;snap enabled
	SVC	GPOINT
	cmp	dl,0			;ok?
	jz	farc1
	EXIT				;no
farc1:	les	di,ENTRP
	fst	ES:aceny[di]		;save center
	fxch	st(1)
	fst	ES:acenx[di]
	fxch	st(1)
	mov	ax,DS			;get arc radius
	mov	ES,ax
	lea	si,aradp
	SVC	GLENDP
	cmp	dl,0			;ok?
	jz	farc2
	EXIT				;no
farc2:	les	di,ENTRP
	fld	ES:acenx[di]		;calc distance
	fld	ES:aceny[di]
	SVC	DIST
	frndint				;make whole units
	fstp	ES:arad[di]
	fld	ES:acenx[di]		;starting angle
	fld	ES:aceny[di]
	mov	ax,DS
	mov	ES,ax
	lea	si,asap
	SVC	GLENDP
	cmp	dl,0			;ok?
	jz	farc3
	EXIT				;no
farc3:	les	di,ENTRP		;convert to starting angle
	fld	ES:acenx[di]
	fxch	st(2)
	fld	ES:aceny[di]
	fxch	st(2)
	SVC	ANGLE
	fldpi				;angle/(pi/128)
	fidiv	k128
	fxch	st(1)
	fdiv	st,st(1)
	frndint				;round to integer
	fmulp	st(1),st		;back to bearing angle
	fstp	ES:asang[di]
	fld	ES:acenx[di]		;ending angle
	fld	ES:aceny[di]
	mov	ax,DS
	mov	ES,ax
	lea	si,aeap
	SVC	GLENDP
	cmp	dl,0			;ok?
	jz	farc4
	EXIT				;no
farc4:	les	di,ENTRP		;convert to ending angle
	fld	ES:acenx[di]
	fxch	st(2)
	fld	ES:aceny[di]
	fxch	st(2)
	SVC	ANGLE
	fldpi				;angle/(pi/128)
	fidiv	k128
	fxch	st(1)
	fdiv	st,st(1)
	frndint				;round to integer
	fmulp	st(1),st		;back to bearing angle
	fsub	ES:asang[di]		;width=start-ending
	ftst				;if <=0.0
	fjg	awok
	fldpi				;then add 2pi
	fadd	st(0),st
	faddp	st(1),st
awok:	fstp	ES:aangw[di]		;store arc width
	SVC	APND			;append arc
	SVC	DRAW			;and draw it
	EXIT
;
;	---------------------------------------------------------------
;	XDRAW - draw our entities
;	---------------------------------------------------------------
;
markl	dd	1.0			;mark length
lvalue	dw	0			;loop value
xvalue	dw	0
yvalue	dw	0
kfmt	db	'Key:'			;current key being defined
key	db	0,' !3  ',0
kvar	dw	key
dscol	dw	0			;# columns prompt text
dslin	dw	0			;# lines prompt text
ptcol	dw	0			;our prompt text start column
ptlin	dw	0			;our prompt text start line
ptlen	dw	11			;our prompt text length
;
XDRAW:
;	get display driver information
	les	di,DSP			;point to display parms
	mov	ax,ES:dstcol[di]	;dstcol
	mov	dscol,ax
	mov	dx,ES:dstlin[di]	;dstlin
	mov	dslin,dx
	sub	ax,12			;our prompt column
	mov	ptcol,ax
;	draw grid in solid line format
	mov	ax,0FFFFh		;solid line
	CALLDP	DSLPAT
;	draw the horizontal grid
	mov	ax,ftmin			;init loop
	mov	lvalue,ax
drwnxh:	fild	ftmin			;draw horizontal line
	fild	lvalue
	fild	ftmax
	fild	lvalue
	SVC	DLINE
	add	lvalue,4		;bump to next line
	mov	ax,ftmax			;loop until done
	cmp	ax,lvalue
	jae	drwnxh
;	draw the vertical grid
	mov	ax,ftmin			;init loop
	mov	lvalue,ax
drwnxv:	fild	lvalue			;draw vertical line
	fild	ftmin
	fild	lvalue
	fild	ftmax
	SVC	DLINE
	add	lvalue,4		;bump to next line
	mov	ax,ftmax			;loop until done
	cmp	ax,lvalue
	jae	drwnxv
;	draw the dot grid
	mov	ax,ftmin			;init X loop
	mov	xvalue,ax
drwnxd:	mov	ax,ftmin			;init Y loop
	mov	yvalue,ax
drwnyd:	fild	xvalue			;draw dot
	fild	yvalue
	SVC	DPOINT
	inc	yvalue			;loop for next Y
	mov	ax,ftmax
	cmp	ax,yvalue
	jae	drwnyd
	inc	xvalue			;loop for next X
	mov	ax,ftmax
	cmp	ax,xvalue
	jae	drwnxd
;	draw the wider key horizontal lines
	fild	ftmin			;draw baseline
	fsub	markl
	fild	fbase
	fild	ftmax
	fadd	markl
	fild	fbase
	SVC	DLINE
	fild	ftmin			;draw minline
	fsub	markl
	fild	ftmin
	fild	ftmax
	fadd	markl
	fild	ftmin
	SVC	DLINE
	mov	ax,fbase		;calc text top line
	add	ax,fhgt
	mov	lvalue,ax
	fild	ftmin			;draw topline
	fsub	markl
	fild	lvalue
	fild	ftmax
	fadd	markl
	fild	lvalue
	SVC	DLINE
	fild	ftmin			;draw maxline
	fsub	markl
	fild	ftmax
	fild	ftmax
	fadd	markl
	fild	ftmax
	SVC	DLINE
	fild	ftmax			;draw rightline
	fild	ftmin
	fild	ftmax
	fild	ftmax
	SVC	DLINE
;	display text information box
	les	di,HDRP			;key = current layer
	mov	al,ES:clayer[di]
	mov	key,al
	mov	si,ptcol		;position our prompt text
	mov	di,ptlin
	SVC	POSGC
	mov	ax,DS			;format key # information
	mov	ES,ax
	lea	si,kfmt
	lea	dx,kvar
	SVC	FORMDS
	sub	si,ptcol		;calc text length
	mov	ptlen,si
	mov	ax,ptcol		;invert our prompt text
	mov	dx,ptlin
	mov	cx,ptlen
	CALLDP	DSTINV
	EXIT
;
;	---------------------------------------------------------------
;	XPICK - Pick test our entities
;	---------------------------------------------------------------
;
XPICK:
	clc				;nothing picked
	EXIT
;
;	---------------------------------------------------------------
;	XMOVE - translate our entities
;	---------------------------------------------------------------
;
XMOVE:
	EXIT
;
;	---------------------------------------------------------------
;	XSTRCH - stretch our entities
;	---------------------------------------------------------------
;
XSTRCH:
	clc				;nothing stretched
	EXIT
;
;	---------------------------------------------------------------
;	XLIST - list our entities
;	---------------------------------------------------------------
;
XLIST:	mov	ax,DS			;display header information
	mov	ES,ax
	lea	si,hfmt
	lea	dx,hvar
	SVC	FORMDS
	EXIT
;
hfmt	db	'Vector Font Header:',13
	db	'  body height........!2',13
	db	'  max height.........!2',13
	db	'  baseline...........!2',13
	db	'  min height.........!2',13
	db	'  character spacing..!2',13
	db	'  line spacing.......!2',13
	db	'  flags..............!6',13,13,0
;
hvar	dw	fhgt,ftmax,fbase,ftmin,fcsp,flsp,fflags
;
;	---------------------------------------------------------------
;	XXCHK - check our entities' extents
;	---------------------------------------------------------------
;
XXCHK:	fild	ftmin			;lower-left corner
	fld1
	fsubp	st(1),st
	fld	st(0)
	fild	ftmax			;upper-right corner
	fld1
	faddp	st(1),st
	fld	st(0)
	SVC	XCHKLN			;extents of diagonal line
	EXIT
;
;	---------------------------------------------------------------
;	XATCH - Attach to our entities	
;	---------------------------------------------------------------
;
XATCH:
	clc				;not attached
	EXIT
;
;	---------------------------------------------------------------
;	XACT - Actuate our entities - 8087 holds X,Y pick point	
;	---------------------------------------------------------------
;
XACT:
	finit				;clear 8087 stack
	EXIT
;
;	===============================================================
;	FONTC - .FNT file Compile
;	---------------------------------------------------------------
;
fname	db	65 dup (0)		;font file name
NowC	dw	32			;now compiling character
Fvptr	dw	0			;vector offset
maxwd	db	0			;max width of chr
anyvf	db	0			;any vector found flag
nowatx	dw	0			;current position
nowaty	dw	0
newx1	dw	0			;new position
newy1	dw	0
newx2	dw	0
newy2	dw	0
;
FONTC:	mov	ax,DS			;initialize fwtbl to all 0FFh
	mov	ES,ax
	cld
	lea	di,FWTBL+1
	mov	cx,255
	mov	ax,0FFh
	rep	stosb
;
;	scan through the drawing once for each character
;
	mov	NowC,31			;start with space
	mov	FVPtr,825		;next vector to store
NextC:	inc	NowC			;advance to next character
	cmp	NowC,256		;done?
	jb	ScanC
	jmp	CComp			;yes
ScanC:	mov	nowatx,0		;set initial position
	mov	ax,fbase
	mov	nowaty,ax
	call	comkey			;display key being compiled
	mov	maxwd,0			;maximum width for table
	mov	anyvf,0			;any vector found flag
	SVC	SELALL			;scan entire drawing
	sub	dx,dx			;starting with record 0:0
	sub	ax,ax
	SVC	STSCAN
cloop:	jc	cwasf			;at end of file?
	test	anyvf,1			;yes - were there any vectors?
	jnz	wasvec
	jmp	NextC			;go for next character
wasvec:	mov	bx,NowC			;store max width
	mov	al,maxwd
	mov	FWTBL[bx],al
	mov	bx,FvPtr		;append end vector
	mov	FWTBL[bx],0FFh
	inc	FvPtr	
	jmp	NextC			;go for next character	
cwasf:	mov	ax,NowC			;on character layer?
	cmp	ES:elayer[di],al
	jnz	cnext
	cmp	ES:etype[di],2		;line entity?
	jnz	ctrya
	call	CVLINE			;yes - convert line to vector
	jmp	short cnext
ctrya:	cmp	ES:etype[di],5		;arc entity?
	jnz	ctryp
	call	CVARC			;yes - convert arc to vector
	jmp	short cnext
ctryp:	cmp	ES:etype[di],1		;point entity?
	jnz	cnext
	call	CVPNT			;yes - convert point to move
cnext:	SVC	NXSCAN			;not it - try next entity
	jmp	cloop
;
;	Compilation Complete
;
CComp:
;	point all undefined vectors to space (ASCII 32)
	mov	dx,FOTBL+32+32		;offset to space
	mov	bl,FWTBL+32		;width of space
	lea	si,FWTBL+1		;point all undefined to space
	lea	di,FOTBL+2
	mov	cx,255
udflp:	cmp	byte ptr [si],0FFh	;undefined?
	jnz	nxudf
	mov	[di],dx			;yes
	mov	[si],bl
nxudf:	inc	si			;advance
	add	di,2
	loop	udflp			;loop for all
;	font file has same name as drawing file, type =.FNT
	mov	ax,DS			;get drawing path & name
	mov	ES,ax
	lea	di,fname
	SVC	CURFN
	mov	ax,DS			;scan for eos
	mov	ES,ax
	lea	di,fname
	sub	al,al
	cld
	mov	cx,65
	repnz	scasb
	sub	di,3			;change .FCD to .FNT
	mov	word ptr [di],'TN'
;	create font file
	mov	ah,3Ch			;create
	sub	cx,cx			;normal attributes
	lea	dx,fname		;file
	int	21H
	jnc	crfok			;create error?
	lea	di,cerdlg		;error alert
	jmp	alert
crfok:	mov	bx,ax			;file handle
	mov	ah,40h			;write
	lea	dx,FWTBL		;from table start
	mov	cx,FvPtr		;length to write
	int	21H
	jnc	wrfok			;write error?
	mov	ah,3Eh			;error - close file
	int	21H
	lea	di,werdlg		;error alert
	jmp	alert
wrfok:	mov	ah,3Eh			;ok - close file
	int	21H
	lea	di,cokdlg
alert:	mov	ax,ES			;show [di] dialog box
	mov	DS,ax
	SVC	SDLOG
	SVC	QDLOG
	SVC	EDLOG
	call	showit			;repost current key
	EXIT				;compilation complete
;
cokdlg	dw	offset cokdtx
	dw	24,1,0
cokdtx	db	' Compilation Successful ',0
;
werdlg	dw	offset werdtx
	dw	25,1,0
werdtx	db	' Error writing font file ',0
;
cerdlg	dw	offset cerdtx
	dw	26,1,0
cerdtx	db	' Error creating font file ',0
;
ckfmt	db	'Key:'			;current key being compiled
ckey	db	0,' !3  ',0
ckvar	dw	ckey
;
;	COMKEY - Display key being compiled
;
comkey	proc	near
;	get display driver information
	les	di,DSP			;point to display parms
	mov	ax,ES:dstcol[di]	;dstcol
	mov	dscol,ax
	mov	dx,ES:dstlin[di]	;dstlin
	mov	dslin,dx
	sub	ax,12			;our prompt column
	mov	ptcol,ax
	mov	ax,NowC			;key to display
	mov	ckey,al
	mov	si,ptcol		;position our prompt text
	mov	di,ptlin
	SVC	POSGC
	mov	ax,DS			;format key # information
	mov	ES,ax
	lea	si,ckfmt
	lea	dx,ckvar
	SVC	FORMDS
	sub	si,ptcol		;calc text length
	mov	ptlen,si
	mov	ax,ptcol		;invert our prompt text
	mov	dx,ptlin
	mov	cx,ptlen
	CALLDP	DSTINV
	ret
comkey	endp
;
;	VSTORE - Vector AL store to table (ES:DI unchanged)
;
VSTORE	proc	near
	mov	bx,FvPtr		;store vector byte
	mov	FWTBL[bx],al
	test	anyvf,1			;any vector defined yet?
	jnz	vsxt
	mov	anyvf,1			;no - set initial offset
	mov	si,NowC
	shl	si,1
	mov	FOTBL[si],bx		;store offset from FWTBL
vsxt:	inc	FvPtr			;bump vector pointer
	ret
vstore	endp
;
;	---------------------------------------------------------------
;	CVPNT - Current entity is a point - convert to move vector
;	---------------------------------------------------------------
;
CVPNT	proc	near
	mov	al,ES:ecolor[di]	;only color 1 is draw
	cmp	al,1			;color 1 = draw
	jz	pdraw
	ret				;other points ignored
pdraw:	fld	ES:px[di]		;x1,y1
	frndint
	fistp	newx1
	fld	ES:py[di]
	frndint
	fistp	newy1
	mov	ax,newx1		;move to X
	cmp	al,maxwd		;update max width
	jle	pmwok
	mov	maxwd,al
pmwok:	mov	nowatx,ax		;update current position
	call	VSTORE
	mov	ax,newy1		;move to Y
	mov	nowaty,ax		;update current position
	call	VSTORE
	ret
cvpnt	endp
;
;	---------------------------------------------------------------
;	CVLINE - Current entity is a line - convert to font vector
;	---------------------------------------------------------------
;
CVLINE	proc	near
	mov	al,ES:ecolor[di]	;only color 1 is draw
	cmp	al,1			;color 1 = draw
	jz	ldraw
	ret				;other lines ignored
ldraw:	fld	ES:lx1[di]		;x1,y1
	frndint
	fistp	newx1
	fld	ES:ly1[di]
	frndint
	fistp	newy1
	fld	ES:lx2[di]		;x2,y2
	frndint
	fistp	newx2
	fld	ES:ly2[di]
	frndint
	fistp	newy2
	fld	ES:lx1[di]		;dist nowat to x1,y1
	fld	ES:ly1[di]
	fild	nowatx
	fild	nowaty
	SVC	DIST
	les	di,ENTRP		;dist nowat to x2,y2
	fld	ES:lx2[di]
	fld	ES:ly2[di]
	fild	nowatx
	fild	nowaty
	SVC	DIST
	fcompp				;d2:d1
	fjge	ordok
	mov	ax,newx2		;reverse order
	xchg	ax,newx1
	mov	newx2,ax
	mov	ax,newy2
	xchg	ax,newy1
	mov	newy2,ax
ordok:	mov	ax,newx1		;need move vector?
	cmp	ax,nowatx
	jnz	needmv
	mov	dx,newy1
	cmp	dx,nowaty
	jz	nomove
needmv:	mov	ax,newx1		;update max width
	cmp	al,maxwd
	jle	mwok1
	mov	maxwd,al
mwok1:	call	VSTORE			;store move X
	mov	ax,newy1
	call	VSTORE			;store move Y	
nomove:	mov	ax,newx2		;draw to X
	cmp	al,maxwd		;update max width
	jle	mwok2
	mov	maxwd,al
mwok2:	mov	nowatx,ax		;update current position
	or	al,80h			;set draw bit
	call	VSTORE
	mov	ax,newy2		;draw to Y
	mov	nowaty,ax		;update current position
	call	VSTORE
	ret
cvline	endp
;
;	---------------------------------------------------------------
;	CVARC - Current entity is an arc - convert to font vector
;	---------------------------------------------------------------
;
newrd	dw	0			;arc parameters
newsa	dw	0
newea	dw	0
;	table of COS(a)*256 for a=0..360 by 360/256 degree steps
costbl	dw	256,255,255,255,254,254,253,252 
	dw	251,249,248,246,244,243,241,238 
	dw	236,234,231,228,225,222,219,216 
	dw	212,209,205,201,197,193,189,185 
	dw	181,176,171,167,162,157,152,147 
	dw	142,136,131,126,120,115,109,103 
	dw	97,92,86,80,74,68,62,56 
	dw	49,43,37,31,25,18,12,6 
	dw	0,-6,-12,-18,-25,-31,-37,-43 
	dw	-49,-56,-62,-68,-74,-80,-86,-92 
	dw	-97,-103,-109,-115,-120,-126,-131,-136 
	dw	-142,-147,-152,-157,-162,-167,-171,-176 
	dw	-181,-185,-189,-193,-197,-201,-205,-209 
	dw	-212,-216,-219,-222,-225,-228,-231,-234 
	dw	-236,-238,-241,-243,-244,-246,-248,-249 
	dw	-251,-252,-253,-254,-254,-255,-255,-255 
	dw	-256,-255,-255,-255,-254,-254,-253,-252 
	dw	-251,-249,-248,-246,-244,-243,-241,-238 
	dw	-236,-234,-231,-228,-225,-222,-219,-216 
	dw	-212,-209,-205,-201,-197,-193,-189,-185 
	dw	-181,-176,-171,-167,-162,-157,-152,-147 
	dw	-142,-136,-131,-126,-120,-115,-109,-103 
	dw	-97,-92,-86,-80,-74,-68,-62,-56 
	dw	-49,-43,-37,-31,-25,-18,-12,-6 
	dw	0,6,12,18,25,31,37,43 
	dw	49,56,62,68,74,80,86,92 
	dw	97,103,109,115,120,126,131,136 
	dw	142,147,152,157,162,167,171,176 
	dw	181,185,189,193,197,201,205,209 
	dw	212,216,219,222,225,228,231,234 
	dw	236,238,241,243,244,246,248,249
	dw	251,252,253,254,254,255,255,255 
;
CVARC	proc	near
	or	fflags,8000h		;font has arcs
	mov	al,ES:ecolor[di]	;only color 1 is draw
	cmp	al,1			;color 1 = draw
	jz	adraw
	ret				;other lines ignored
adraw:	fld	ES:acenx[di]		;arc center
	frndint
	fistp	newx1
	fld	ES:aceny[di]
	frndint
	fistp	newy1
	mov	ax,newx1		;arc center x
	or	al,80h			;set arc flag bit
	call	VSTORE
	fwait				;arc center y
	mov	ax,newy1
	or	al,80h			;set arc flag bit
	call	VSTORE
	fld	ES:arad[di]		;arc radius
	frndint
	fistp	newrd
	fwait
	mov	ax,newrd
	call	VSTORE
	fld	ES:asang[di]		;arc start, end angles
	fldpi
	fidiv	k128
	fxch	st(1)
	fdiv	st,st(1)
	frndint
	fistp	newsa
	fld	ES:asang[di]
	fadd	ES:aangw[di]
	fdivrp	st(1),st
	frndint
	fistp	newea
	fwait
	mov	ax,newsa
	call	VSTORE
	mov	ax,newea
	call	VSTORE
;	chekc arc vector max width
	mov	ax,newea		;make end angle >= start angle
	cmp	ax,newsa
	jg	awchk
	add	newea,256
awchk:	mov	bx,newsa		;get angle/radius width
	cmp	bx,newea
	jg	awdone
	and	bx,255
	shl	bx,1
	mov	ax,costbl[bx]		;cos(angle)*256
	imul	newrd
	mov	al,ah			;/256
	mov	dl,ah
	add	ax,newx1		;add arc center
	cmp	al,maxwd
	jle	awcnx
	mov	maxwd,al
awcnx:	inc	newsa			;check next bearing
	jmp	short awchk
awdone:	ret
cvarc	endp
;
;	---------------------------------------------------------------
;	FONTI - .FNT file Import
;	---------------------------------------------------------------
;
ftype	db	'.FNT',0
askfnp	db	'Font to load:',0
spptr	dw	0			;vector pointer for space
;
olddlg	dw	olddtx,31,4,2
	dw	11,2,3,1,'Y', 18,2,2,1,'N'
;
olddtx	db	'Ok to discard current drawing? ',0
	db	'                               ',0
	db	'           Yes    No           ',0
	db	'                               ',0
;
rerdlg	dw	offset rerdtx
	dw	25,1,0
rerdtx	db	' Error reading font file ',0
;
oerdlg	dw	offset oerdtx
	dw	25,1,0
oerdtx	db	' Error opening font file ',0
;
f2edlg	dw	offset f2edtx
	dw	31,1,0
f2edtx	db	' .FNT file not current format! ',0
;
ficmds	db	'ECOFF;RDOFF;NEW;N;'
	db	'MENU;FMAKER;LAYER 32;SNAPV 1;GRIDV 1;;GRIDOFF;'
	db	'DFMT;N;HIDEA;RDON;ECON;RENAME;^D;FONTI2;',0
;
FONTI:	mov	ax,DS			;get .FNT file name
	mov	ES,ax
	lea	si,askfnp
	lea	dx,ftype
	lea	di,fname
	SVC	GFNAME
	jc	goodfn
	EXIT				;no name selected
;	open font file
goodfn:	mov	ax,3D00h		;open R/O
	lea	dx,fname		;file
	int	21H
	jnc	ofok			;open error?
	lea	di,oerdlg		;error alert
	jmp	alert
ofok:	mov	bx,ax			;file handle
	mov	ah,3Fh			;read
	lea	dx,FWTBL		;to table start
	mov	cx,16384		;length to read
	int	21H
	jnc	rdfok			;read error?
;	now close file
	mov	ah,3Eh			;error - close file
	int	21H
	lea	di,rerdlg		;error alert
	jmp	alert
rdfok:	mov	ah,3Eh			;ok - close file
	int	21H
	cmp	FWTBL,02h		;FORMAT 2 font file?
	jz	rdfmt2
	lea	di,f2edlg		;no - error alert
	jmp	alert
;	ok to discard old file dialog
rdfmt2:	mov	ax,DS			;ok to discard old drawing?
	mov	ES,ax
	lea	di,olddlg
	SVC	SDLOG
	SVC	QDLOG
	push	ax
	SVC	EDLOG
	pop	ax
	cmp	ax,1			;must be yes to continue
	jz	isok
	EXIT				;else ignore command
;	font file loaded ok - do setup commands
isok:	mov	ax,DS			;EXEC setup commands
	mov	ES,ax
	lea	di,ficmds
	SVC	EXECST
	EXIT				;go let it happen
;
FONTI2:	call	puthdr			;put header record for font
;
;	scan and build each character
;
	mov	NowC,31			;start with space
	mov	spptr,0			;space chr offset
INextC:	inc	NowC			;advance to next character
	cmp	NowC,256		;done?
	jb	IScanC
	jmp	IComp			;yes
IScanC:	mov	nowatx,0		;set initial position
	mov	ax,fbase
	mov	nowaty,ax
	call	comkey			;display key being imported
	mov	bx,NowC			;get vector list pointer
	shl	bx,1
	mov	bx,FOTBL[bx]		;bx=offset from FWTBL
	mov	FvPtr,bx		;save it
	cmp	bx,spptr		;same as space?
	jz	INextC			;yes - undefined chr
	cmp	NowC,32			;if now is space
	jnz	INextV
	mov	spptr,bx		;then save its offset
INextV:	mov	bx,FvPtr		;get next vector
	mov	ax,word ptr FWTBL[bx]	;al=x, ah=y
	add	FvPtr,2			;and bump it
	cmp	al,0FFh			;end of character?
	jnz	noteoc
	jmp	INextC			;yes - go get next chr
noteoc:	test	ah,80h			;arc vector?
	jz	tryil
	call	IARC			;yes
	jmp	short INextV
tryil:	test	al,80h			;line vector?
	jz	tryip
	call	ILINE			;yes
	jmp	short INextV
tryip:	call	IPOINT			;must be move to (point)
	jmp	short INextV
IComp:
;
;	Import complete - redraw and initialize
;
	SVC	REGEN			;redraw
	jmp	FSPEC			;go display specs data
;
;	---------------------------------------------------------------
;	ILINE - Import Draw-To Vector as a Line
;	---------------------------------------------------------------
;
ILINE	proc	near
	and	ax,7F7Fh		;clear flag bits
	mov	byte ptr newx2,al	;and store draw-to point
	mov	byte ptr newy2,ah
	les	di,ENTRP		;build entity line record
	mov	ES:erlen[di],22		;record length
	mov	ES:etype[di],2		;type=line
	mov	ES:ecolor[di],1		;color # 1
	mov	ES:estyle[di],0		;solid line
	mov	ax,NowC			;layer = character #
	mov	ES:elayer[di],al
	fild	nowatx			;starting point
	fstp	ES:lx1[di]
	fild	nowaty
	fstp	ES:ly1[di]
	fild	newx2			;ending point
	fstp	ES:lx2[di]
	fild	newy2
	fstp	ES:ly2[di]
	fwait
	SVC	APND			;add to database
	mov	ax,newx2		;update current position
	mov	nowatx,ax
	mov	ax,newy2
	mov	nowaty,ax
	ret				;done
iline	endp
;
;	---------------------------------------------------------------
;	IPOINT - Import Move-To Vector as a Point
;	---------------------------------------------------------------
;
IPOINT	proc	near
	and	ax,7F7Fh		;clear flag bits
	mov	byte ptr newx2,al	;and store move-to point
	mov	byte ptr newy2,ah
	les	di,ENTRP		;build entity line record
	mov	ES:erlen[di],13		;record length
	mov	ES:etype[di],1		;type=point
	mov	ES:ecolor[di],1		;color # 1
	mov	ES:estyle[di],0		;style
	mov	ax,NowC			;layer = character #
	mov	ES:elayer[di],al
	fild	newx2			;ending point
	fstp	ES:px[di]
	fild	newy2
	fstp	ES:py[di]
	fwait
	SVC	APND			;add to database
	mov	ax,newx2		;update current position
	mov	nowatx,ax
	mov	ax,newy2
	mov	nowaty,ax
	ret
ipoint	endp
;
;	---------------------------------------------------------------
;	IARC - Import Arc Vector as an Arc
;	---------------------------------------------------------------
;
IARC	proc	near
	and	ax,7F7Fh		;clear flag bits
	mov	byte ptr newx2,al	;and store center point
	mov	byte ptr newy2,ah
	les	di,ENTRP		;build entity line record
	mov	ES:erlen[di],26		;record length
	mov	ES:etype[di],5		;type=arc
	mov	ES:ecolor[di],1		;color # 1
	mov	ES:estyle[di],0		;solid line
	mov	ax,NowC			;layer = character #
	mov	ES:elayer[di],al
	fild	newx2			;center point
	fstp	ES:acenx[di]
	fild	newy2
	fstp	ES:aceny[di]
	mov	bx,FvPtr		;get radius
	mov	al,FWTBL[bx]
	inc	FvPtr
	and	ax,007Fh
	mov	newx1,ax
	fild	newx1
	fstp	ES:arad[di]
	mov	bx,FvPtr		;get start, end angles
	mov	ax,word ptr FWTBL[bx]
	add	FvPtr,2
	mov	bl,ah
	sub	ah,ah
	sub	bh,bh
	mov	newx1,ax
	sub	bx,ax			;width=end-start
	jg	iawok			;if <=0 then add 360 degrees
	add	bx,256
iawok:	mov	newy1,bx
	fldpi				;calc pi/128
	fidiv	k128
	fild	newx1			;get start angle
	fmul	st,st(1)
	fstp	ES:asang[di]
	fimul	newy1			;get end angle
	fstp	ES:aangw[di]
	fwait
	SVC	APND			;add to database
	ret
iarc	endp
;
;	---------------------------------------------------------------
;
	include	XPEND.CPY
