;	CONFIG.CPY - Configuration Record Data Structure
;
;	Copyright 1987,88 Evolution Computing
;	All Rights Reserved.
;	Written by Mike Riddle
;
;
CONFIG	STRUC
;
CFGID	db	'FastCAD'		;text may vary
	db	' config file, version '
	db	'2.51.',13,10,26	;# will vary
cfgver	dw	251			;config file version #
;
;	display color preferences
;
clrfbi	dw	0			;function bar icon color
clrfbb	dw	15			;function bar background color
clrpdf	dw	8			;pull down menu frame color
clrpdf2	dw	0			;pull down menu frame outer color
clrdbf	dw	8			;dialog box frame color
clrdbf2	dw	0			;dialog box frame outer color
clrdbi	dw	9			;dialog box item frame color
clrmark	dw	2			;dialog box item mark frame color
clrdwn	dw	11			;drawing window frame color
clrawn	dw	8			;active window frame color
blpclr	dw	14			;blip mark color
clrfpb	dw	9			;fill pattern background
clrfpf	dw	0			;fill pattern foreground
monatr	db	0			;force mono text attributes flag
DbgFlag	db	0			;debug active flag
DynCI	db	0			;inhibit dynamic cursors = 1
SelHI	db	0			;inhibit select. hilighting = 1
	db	8 dup (0)		;filler
;
;	global configuration values
;
mingd	dw	8			;minimum pixels per grid interval
pkpix	dw	3			;each pick aperture in pixels
	dw	50 dup (0)		;filler
;
;	font file name to number index
;
FntName	db	'STDTEXT.FNT',0,0,0,0,0		;font #1
	db	'FANCY.FNT',0,0,0,0,0,0,0	;font #2
	db	'SMOOTH.FNT',0,0,0,0,0,0	;font #3
	db	16 dup (0)			;font #4
	db	16 dup (0)			;font #5
	db	16 dup (0)			;font #6
	db	16 dup (0)			;font #7
	db	16 dup (0)			;font #8
	db	16 dup (0)			;font #9
	db	16 dup (0)			;font #10
	db	16 dup (0)			;font #11
	db	16 dup (0)			;font #12
	db	16 dup (0)			;font #13
	db	16 dup (0)			;font #14
	db	16 dup (0)			;font #15
	db	16 dup (0)			;font #16
	db	0FFH				;delimiter
;
;	XP module file name table
;
XPName	db	'XPDEMO.COM',0,0,0,0,0,0	;module #1
	db	16 dup (0)			;module #2
	db	16 dup (0)			;module #3
	db	16 dup (0)			;module #4
	db	16 dup (0)			;module #5
	db	16 dup (0)			;module #6
	db	16 dup (0)			;module #7
	db	16 dup (0)			;module #8
	db	16 dup (0)			;module #9
	db	16 dup (0)			;module #10
	db	16 dup (0)			;module #11
	db	16 dup (0)			;module #12
	db	16 dup (0)			;module #13
	db	16 dup (0)			;module #14
	db	16 dup (0)			;module #15
	db	16 dup (0)			;module #16
;
;	poly fill definitions: 8x8 raster
;
FilPM	db	0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH	;0=solid
	db	0AAH,055H,0AAH,055H,0AAH,055H,0AAH,055H	;1=halftone
	db	099H,066H,066H,099H,099H,066H,066H,099H	;2=narrow x hatch
	db	081H,042H,024H,018H,018H,024H,042H,081H	;3=wide x hatch
	db	088H,044H,022H,011H,088H,044H,022H,011H	;4=narrow rt. hatch
	db	011H,022H,044H,088H,011H,022H,044H,088H	;5=narrow lt. hatch
	db	080H,040H,020H,010H,008H,004H,002H,001H	;6=wide rt. hatch
	db	001H,002H,004H,008H,010H,020H,040H,080H	;7=wide lt. hatch
	db	081H,042H,024H,018H,081H,042H,024H,018H	;8=waves
	db	002H,002H,0FFH,020H,020H,020H,0FFH,002H	;9=brick
	db	011H,022H,044H,088H,088H,044H,022H,011H	;10=zigzag
	db	000H,000H,03CH,024H,024H,03CH,000H,000H	;11=boxes
	db	008H,008H,008H,008H,0FFH,008H,008H,008H	;12=net
	db	085H,000H,010H,000H,000H,058H,000H,000H	;13=random
	db	044H,044H,044H,044H,044H,044H,044H,044H	;14=vertical
	db	000H,0FFH,000H,000H,000H,0FFH,000H,000H	;15=horizontal
	db	000H,000H,008H,014H,022H,014H,008H,000H	;16=diamonds
	db	0A0H,050H,028H,014H,00AH,005H,082H,041H	;17=steel
	db	090H,009H,022H,044H,090H,009H,044H,022H	;18=earth
	db	0FFH,088H,088H,088H,0FFH,088H,088H,088H	;19=mesh
	db	000H,060H,099H,006H,060H,006H,0FAH,00CH	;20=wood
	db	008H,004H,002H,001H,081H,041H,021H,01FH	;21=angbrkt
	db	0FFH,0C2H,0A4H,098H,098H,0A4H,0C2H,081H	;22=lattice
	db	012H,024H,008H,008H,024H,012H,008H,008H	;23=wallpaper
	db	000h,000h,000h,000h,000h,000h,000h,000h	;24=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;25=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;26=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;27=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;28=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;29=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;30=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;31=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;32=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;33=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;34=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;35=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;36=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;37=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;38=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;39=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;40=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;41=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;42=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;43=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;44=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;45=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;46=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;47=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;48=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;49=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;50=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;51=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;52=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;53=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;54=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;55=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;56=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;57=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;58=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;59=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;60=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;61=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;62=empty
	db	000h,000h,000h,000h,000h,000h,000h,000h	;63=empty
;
;	poly fill by  pen crosshatch table
;
;	each entry is 20 words (4 sets of line specs), each is:
;
;		line spacing in pen widths
;		pattern length in pen widths
;		angle 0..511 (0 to 179+ degrees)
;		line style (0=no line drawn)
;		line space offset in pen widths
;
FilVD	dw	 1,16,  0,0FFFFH, 0	;0=solid
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	 3,16,128,0FFFFH, 0	;1=halftone
	dw	 3,16,384,0FFFFH, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	 4,16,128,0FFFFH, 0	;2=narrow x hatch
	dw	 4,16,384,0FFFFH, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	 8,16,128,0FFFFH, 0	;3=wide x hatch
	dw	 8,16,384,0FFFFH, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	 4,16,128,0FFFFH, 0	;4=narrow rt hatch
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	 4,16,384,0FFFFH, 0	;5=narrow lt hatch
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	 8,16,128,0FFFFH, 0	;6=wide rt hatch
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	 8,16,384,0FFFFH, 0	;7=wide lt hatch
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	 8, 8,128,0FF00H, 0	;8=waves
	dw	 8, 8,384,000FFH, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	 8,16,  0,0FFFFH, 0	;9=brick
	dw	16,16,256,0FF00H, 0
	dw	16,16,256,000FFH, 8
	dw	16,16,  0,     0, 0
	dw	 8, 8,128,0FF00H, 0	;10=zigzag
	dw	 8, 8,384,0FF00H, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	 6,12,  0,0FF00H, 0	;11=boxes
	dw	 6,12,256,0FF80H, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	10,16,  0,0FFFFH, 0	;12=net
	dw	10,16,256,0FFFFH, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,08005H, 0	;13=random
	dw	16,16,  0,00100H, 5
	dw	16,16,  0,04380H, 10
	dw	16,16,  0,     0, 0
	dw	 8,16,256,0FFFFH, 0	;14=vertical
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	 8,16,  0,0FFFFH, 0	;15=horizontal
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,128,00F00H, 0	;16=diamonds
	dw	16,16,128,0F000H, 8
	dw	16,16,384,00F00H, 0
	dw	16,16,384,0F000H, 8
	dw	 8,16,128,0FFFFH, 0	;17=steel
	dw	 8,16,128,0FFFFH, 2
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,128,0FF00H, 0	;18=earth (partial)
	dw	16,16,128,0FC03H, 4
	dw	16,16,384,000FFH,22
	dw	16,16,384,003FCH,26
	dw	 5,16,  0,0FFFFH, 0	;19=mesh
	dw	 5,16,256,0FFFFH, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	 4,16,  0,0F07FH, 0	;20=wood
	dw	 4,16,  0,01DC0H, 1
	dw	 4,16,  0,0700FH, 2
	dw	16,16,  0,     0, 0
	dw	16,16,128,0FFFFH, 8	;21=angbrkt
	dw	16,16,  0,000FFH,15
	dw	16,16,256,000FFH,15
	dw	16,16,  0,     0, 0
	dw	16,16,  0,0FFFFH, 0	;22=lattice
	dw	16,16,256,0FFFFH, 0
	dw	16,16,128,0FFFFH, 0
	dw	16,16,384,0FFFFH, 0
	dw	16,16,128,00F00H, 0	;23=wallpaper
	dw	16,16,128,0F000H, 8
	dw	16,16,384,0F000H, 0
	dw	16,16,384,00F00H, 8
	dw	16,16,  0,00000H, 0	;24=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;25=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;26=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;27=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;28=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;29=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;30=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;31=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;32=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;33=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;34=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;35=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;36=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;37=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;38=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;39=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;40=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;41=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;42=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;43=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;44=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;45=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;46=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;47=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;48=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;49=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;50=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;51=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;52=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;53=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;54=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;55=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;56=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;57=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;58=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;59=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;60=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;61=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;62=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,00000H, 0	;63=empty
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
	dw	16,16,  0,     0, 0
;
lastcfb	db	0FFH			;last configuration file byte
;
CONFIG	ENDS
;
