;	EDGE.CPY - Edge data for PROFILE, SREV, TCYL use
;
;	Copyright (C) 1989 Evolution Computing
;	All rights reserved
;
;
;	EDGSIZ starts with the EDGFLG byte
;
edghdr	STRUC
EdgTyp	db	0			;edge type code
EdgSiz	dw	0			;edge data size
EdgFlg	db	0			;edge flags
edghdr	ends
;
;	----------------------------------------------------------------
;	Edge type 1: PATH node list (must incl. closing node for POLY)
;	Edge type 2: SPLINE node list
;	Edge type 3: SPOLY node list
;	----------------------------------------------------------------
;
EdgNL	STRUC
	db	1			;1,2 or 3
	dw	3			;3+#nodes*12
	db	0			;no flag data
EdgNN	dw	0			;# of nodes
EdgND	dd	0.0			;3d node list for EDGNN nodes
EdgNL	ends
;
;	----------------------------------------------------------------
;	Edge type 4: 3d ARC (Circle = 360 arc)
;	----------------------------------------------------------------
;
EdgARC	STRUC
	db	4			;edge type
	dw	33			;1+arc geometry
	db	0			;no flag data
;
;	following is standard 3d arc geometry
;
EgAcx	dd	0.0			;center
EgAcy	dd	0.0
EgAcz	dd	0.0
EgArd	dd	0.0			;radius
EgArxy	dd	0.0			;arc orientation angles
EgAryz	dd	0.0
EgArzx	dd	0.0
EgAaw	dd	0.0			;arc width
EdgArc	ends
;
