;	GEOMETRY.CPY - Geometry definitions
;
;	----------------- old 2d geometry -------------------------
;
;	line segment
;
GEOLS	STRUC
glx1	dd	0.0	;first point
gly1	dd	0.0
glx2	dd	0.0	;second point
gly2	dd	0.0
geols	ends
;
;	arc/circle
;
GEOA	STRUC
gacx	dd	0.0	;center
gacy	dd	0.0
gard	dd	0.0	;radius
gasa	dd	0.0	;start angle, radians
gaaw	dd	0.0	;arc width
geoa	ends
;
;	ellipse/elliptical arc
;
GEOE	STRUC
gecx	dd	0.0	;center
gecy	dd	0.0
gerd	dd	0.0	;major radius
geec	dd	0.0	;eccentricity minor/major (0..1)
gein	dd	0.0	;major axis inclination angle 0..pi
gesa	dd	0.0	;start angle 0..2pi
geaw	dd	0.0	;arc width 0..2pi
geoe	ends
;
;	------------------ new 2d/3d geometry ----------------------
;
;	2D point
;
G2PT	STRUC
g2px	dd	0.0
g2py	dd	0.0
g2pt	ends
;
;	3D point
;
G3PT	STRUC
g3px	dd	0.0
g3py	dd	0.0
g3pz	dd	0.0
g3pt	ends
;
;	2D line
;
G2LN	STRUC
g2lx1	dd	0.0	;first point
g2ly1	dd	0.0
g2lx2	dd	0.0	;second point
g2ly2	dd	0.0
g2ln	ends
;
;	3D line
;
G3LN	STRUC
g3lx1	dd	0.0	;first point
g3ly1	dd	0.0
g3lz1	dd	0.0
g3lx2	dd	0.0	;second point
g3ly2	dd	0.0
g3lz2	dd	0.0
g3ln	ends
;
;	2D arc
;
G2ARC	STRUC
g2acx	dd	0.0	;center
g2acy	dd	0.0
g2ard	dd	0.0	;radius
g2asa	dd	0.0	;start angle, radians
g2aaw	dd	0.0	;arc width
g2arc	ends
;
;	2D circle
;
G2CIR	STRUC
g2ccx	dd	0.0	;center
g2ccy	dd	0.0
g2crd	dd	0.0	;radius
g2cir	ends
;
;	3D arc/circle
;
G3ARC	STRUC
g3acx	dd	0.0	;center
g3acy	dd	0.0
g3acz	dd	0.0
g3ard	dd	0.0	;radius
g3arxy	dd	0.0	;arc orientation angles
g3aryz	dd	0.0
g3arzx	dd	0.0
g3aaw	dd	0.0	;arc width
g3arc	ends
;
;	2d ellipse/elliptical arc
;
G2ELP	STRUC
g2ecx	dd	0.0	;center
g2ecy	dd	0.0
g2erd	dd	0.0	;major radius
g2eec	dd	0.0	;eccentricity minor/major (0..1)
g2ein	dd	0.0	;major axis inclination angle 0..pi
g2esa	dd	0.0	;start angle 0..2pi
g2eaw	dd	0.0	;arc width 0..2pi
g2elp	ends
;
;	3d ellipse/elliptical arc
;
G3ELP	STRUC
g3ecx	dd	0.0	;center
g3ecy	dd	0.0
g3ecz	dd	0.0
g3erd	dd	0.0	;major radius
g3erxy	dd	0.0	;arc orientation angles
g3eryz	dd	0.0
g3erzx	dd	0.0
g3eec	dd	0.0	;eccentricity minor/major (0..1)
g3ein	dd	0.0	;major axis inclination angle 0..pi
g3eaw	dd	0.0	;arc width 0..2pi
g3elp	ends
;
;	2D node list (first 4 nodes)
;
G2NLST	STRUC
g2nx1	dd	0.0	;1st node
g2ny1	dd	0.0
g2nx2	dd	0.0	;2nd node
g2ny2	dd	0.0
g2nx3	dd	0.0	;3rd node
g2ny3	dd	0.0
g2nx4	dd	0.0	;4th node
g2ny4	dd	0.0
g2nlst	ends
;
;	3D node list (first 4 nodes)
;
G3NLST	STRUC
g3nx1	dd	0.0	;1st node
g3ny1	dd	0.0
g3nz1	dd	0.0
g3nx2	dd	0.0	;2nd node
g3ny2	dd	0.0
g3nz2	dd	0.0
g3nx3	dd	0.0	;3rd node
g3ny3	dd	0.0
g3nz3	dd	0.0
g3nx4	dd	0.0	;4th node
g3ny4	dd	0.0
g3nz4	dd	0.0
g3nlst	ends
;
;	2D Text Specifications
;
G2TXS	STRUC
g2tj	db	0	;justification
g2tf	db	0	;font #
g2tx	dd	0.0	;location
g2ty	dd	0.0
g2th	dd	1.0	;text height
g2tar	dd	1.0	;aspect ratio
g2ta	dd	0.0	;text angle
g2txt	db	0	;ASCIIZ text string
g2txs	ends
;
;	3D Text Specifications
;
G3TXS	STRUC
g3tj	db	0	;justification
g3tf	db	0	;font #
g3tx	dd	0.0	;location
g3ty	dd	0.0
g3tz	dd	0.0
g3th	dd	1.0	;text height
g3tar	dd	1.0	;aspect ratio
g3trxy	dd	0.0	;X-orientation
g3tryz	dd	0.0
g3trzx	dd	0.0
g3txt	db	0	;ASCIIZ text string
g3txs	ends
;
