;	HEADER.CPY  - Drawing File Header Definition
;
;	Copyright 1987 Evolution Computing
;	All rights reserved
;	Written 9/24/87 MR
;	revised for 2.0 header 3/7/88 MR (dbver 9, 10)
;	revised for 2.06 header 6/30/88 MR (dbver 11, deltas added)
;
;	----------------------------------------------------------------
;	Bit Position Equates for OPFLAGS bits
;	----------------------------------------------------------------
;
;name				;set/not set
GridOn	equ	0		;grid displayed/not displayed
GridOs	equ	1		;grid on screen/to small or large
CGrid	equ	2		;circular grid/rectangular grid
SnapOn	equ	3		;snap to grid/no snap
OrthOn	equ	4		;ortho lock/no ortho lock
FrameOn	equ	5		;spline frame shows/not showing
LockOn	equ	6		;group lock on/lock off
TrackOn	equ	7		;display tracking coordinates/no tracking
AtchOn	equ	8		;attach on/not on
BlipOn	equ	9		;dig blip on/no blip on dig
SFVis	equ	10		;spline frame visibility
XhReq	equ	11		;cross-hairs reqd. on rubber-band csr
FDimLk	equ	12		;Dim Text Horiz Lock
DWValid	equ	61		;drawing windows valid
IS3D	equ	62		;drawing is 3D/is 2D
XTValid	equ	63		;extents valid/not valid
;
OPSET	macro	flag
	les	di,HDRP		;point to header
	or	ES:OpFlags+(flag/8)[di],80H shr (flag mod 8)
	endm
;
OPCLR	macro	flag
	les	di,HDRP		;point to header
	and	ES:OpFlags+(flag/8)[di],NOT (80H shr (flag mod 8))
	endm
;
OPTST	macro	flag
	les	di,HDRP		;point to header
	test	ES:OpFlags+(flag/8)[di],80H shr (flag mod 8)
	endm
;
OPFLP	macro	flag
	les	di,HDRP		;point to header
	xor	ES:OpFlags+(flag/8)[di],80H shr (flag mod 8)
	endm
;
;	----------------------------------------------------------------
;	Partial Header Record Area Structure
;	----------------------------------------------------------------
;
HEADER	STRUC
;
FCID	db	'FCAD v'	;FCAD drawing ID message
vtext	db	'2.08 '		;version # text
dorps	db	'drawing file:  '
dwglbl	db	'Unlabeled drawing.                      ' ;max 40 chrs.
	db	13,10,26	;(DOS TYPE to display version & dwglbl)
dbver	db	11		;database version #
RecCnt	dd	0		;record count (0=empty)
	db	8 dup (0)	;filler
;
;	current operations parameters
;
UnitV	dd	1.0		;units*unitv=inches | inches/unitv=units
CDfmt	db	1		;current dimension dwglbling format
CLayer	db	1		;current work layer
CColor	db	1		;current work color
CStyle	db	0		;current work style
SNSeg	dw	10		;spline # segments
Bkgnd	dw	0		;window background color
TkTyp	db	0		;tracking type 0=abs,1=rel,2=polar
DimDP	db	3		;dimension # decimal places
CurFS	db	0		;current fill style
Cnct2	db	0		;1=2nd connect point defined
hidctl	db	0		;0=map color hide, 1=bkgnd fill hide
	db	27 dup (0)	;filler
NxWPID	dw	0		;# of workplane definitions
NARes	db	0		;new entity ang res (3d - dynamic)
NLRes	db	0		;new entity linear res (3d - dynamic)
NrPAD	dw	0		;# of plot assembly definitions
;
;	current operations flags
;
OpFlags	db	002H,040H,000H,000H	;operations flags (0:31)
	db	000H,000H,000H,000H	;operations flags (32:63)
;
;	current default values
;
CurDhgt	dd	0.20		;current dimension height
CurTH	dd	0.20		;current text height
CurTA	dd	0.0		;current text angle
CurTF	db	0		;current text font
CurTJ	db	0		;current text justification
CurWV	dd	0.20		;current width value
CurFP	db	0		;current fill pattern (0=unfilled)
CurDF	db	0		;current dimension font
CurTS	dw	150		;text line spacing % of height
LWidth	dd	0.20		;wide line width
CurAHA	dd	2.93215		;RAD(180-(arrowhead angle/2)) [24 deg]
CurAHS	db	4		;current arrowhead style
CurAHL	dd	1.25		;arrowhead length, % of dim tx hgt /100
CurDTP	db	0		;current dim text pos 0..3=I/O/L/R
CyRes	dw	12		;current cylinder panel resolution
AnimNF	dw	40		;animation steps
DeltaD	dd	1.0		;distance delta
DeltaA	dd	10.0		;angle delta
DeltaZ	dd	2.5		;zoom in/out delta
;
;	Connect2 uses 0,0,0 origin and 2nd point
;
CnctX	dd	0.0		;2nd connect point
CnctY	dd	0.0
CnctZ	dd	0.0
;
;	Drawing extents
;
Xtxlo	dd	0.0		;low x extent
Xtylo	dd	0.0		;low y extent
Xtzlo	dd	0.0		;low z extent
Xtxhi	dd	0.0		;high x extent
Xtyhi	dd	0.0		;high y extent
Xtzhi	dd	0.0		;high z extent
;
;	layer and line style information
;
FrzLyrs	db	32 dup (0)	;frozen layer flags
VisLyrs	db	07FH		;visible layers flags(0:31)
	db	31 dup (0FFH)	;extra layers (32:255)
LStyles	dw	0FFFFH		;current line patterns(0:15)
	dw	3333H,5555H,5F5FH,0FC9FH,9F9FH,0F0FH,0303H
	dw	-1,-1,-1,-1,-1,-1,-1,-1
;
;	grid/snap system specifications
;
GridCX	dd	0.0		;grid center X
GridCY	dd	0.0		;grid center Y
GridCZ	dd	0.0		;grid center Z
GridDX	dd	1.0		;grid delta X, or Delta Radius
GridDY	dd	1.0		;grid delta Y, or Delta Angle
GridDZ	dd	1.0		;grid delta Z
GridSXY	dd	0.0		;grid shear angle XY
GridSYZ	dd	0.0		;grid shear angle YZ
GridOXY	dd	0.0		;grid offset angle XY
GridOYZ	dd	0.0		;grid offset angle YZ
SnapM	db	4		;snap fraction of grid deltas (1/snapm)
	db	7 dup (0)
;
HEADER	ENDS
;
