;	MANDEL - FastCAD(R) External Procedure Demo Program
;
;	(c) Copyright 1988 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle 2/17/88
;
	name	MANDEL
;
WeitekV	equ	0			;1=gen for weitek, 0=for 8087
;
	if	WeitekV
make386	equ	1			;force 386 segment16,code
	include	XPSTART.CPY
	include	WEITEK.CPY		;use weitek coprocessor
	else
	include	XPSTART.CPY
	endif
;
;	---------------------------------------------------------------
;	XCMD - External Process Command - command # BX
;
;	commands 0..10 are preassigned signals
;	user commands start with command #11
;	---------------------------------------------------------------
;
XCMD:	ENTRY
	shl	bx,1			;make word index
	add	bx,offset cmdtbl
	mov	bx,[bx]			;get command offset
	jmp	bx			;go to command handler
cmdtbl	dw	offset nulcmd		;0 = Startup ExtProc
	dw	offset nulcmd		;1 = Ending use of ExtProc
	dw	offset nulcmd		;2 = Drawing renamed
	dw	offset nulcmd		;3 = Drawing Just Loaded
	dw	offset nulcmd		;4 = Drawing about to be saved
	dw	offset nulcmd		;5 = Drawing REVERTed to prior save
	dw	offset nulcmd		;6 = before getting next command
	dw	offset nulcmd		;7 = regen completed - repath
	dw	offset nulcmd		;8 = unused
	dw	offset nulcmd		;9 = unused
	dw	offset nulcmd		;10 = unused
	dw	offset mandel		;11 = MANDEL command
	dw	offset limits		;12 = LIMITS command
	dw	offset display		;13 = DISPLAY command
;	other commands offsets go here
nulcmd:	EXIT
;
;	---------------------------------------------------------------
;	XENTITY - External Process Entity Support
;	---------------------------------------------------------------
;
XENT:	ENTRY
	mov	bx,ax			;desired op # in AX
	shl	bx,1			;make word index
	add	bx,offset eftbl
	mov	bx,[bx]			;get entity function offset
	jmp	bx			;go to function  handler
eftbl	dw	offset nullop		;0 = draw entity
	dw	offset nullop		;1 = pick test entity
	dw	offset nullop		;2 = transform entity
	dw	offset nullop		;3 = stretch entity
	dw	offset nullop		;4 = list entity
	dw	offset nullop		;5 = check entity extents
	dw	offset nullop		;6 = attach to entity
	dw	offset nullop		;7 = actuate entity
nullop:	finit				;clear 8087
	clc				;no pick/attach
	EXIT
;
;	---------------------------------------------------------------
;	XCSTG - Command Name String
;
;	Each command word is UPPERCASE, space delimited.
;	---------------------------------------------------------------
;
XPEXID	dw	0			;no EXT entities in this module
;
XCSTG	db	'MANDEL LIMITS DISPLAY '
	db	0			;end of command word table
;
;	---------------------------------------------------------------
;	DOS Identification Message
;	---------------------------------------------------------------
;
ident	db	'MANDEL - Mandelbrot Set Display Program.',13,10
	db	'FastCAD(R) External Procedure Module - version '
	db	dvrlvl,'.04',13,10
	if	WeitekV
	db	'Version for Compaq/Weitek Coprocessor',13,10
	else
	db	'Version for 8087 math support',13,10
	endif
	db	'(C) Copyright 1988 Evolution Computing',13,10,'$'
;
;	---------------------------------------------------------------
;	MANDEL - Display view of Mandelbrot Set
;	---------------------------------------------------------------
;
	align	4
views	dq	-3.0,		-1.5,		4.0
	dq	-2.00,		-0.07,		0.155
	dq	-0.852117,	-0.2487325,	0.1471048
	dq	-0.7487518,	-0.1733164,	0.0213062
	dq	-0.8452107,	-0.2383566,	0.0184169
	dq	0.2941000,	-0.0167000,	0.0010000
	dq	-0.5575000,	0.6220000,	0.0052000
	dq	-0.2911000,	0.8582800,	0.0000400
	dq	0.2908000,	-0.0200000,	0.0050000
	dq	-0.8332786,	-0.2307438,	0.0047267
	dq	-0.8319767,	-0.2296583,	0.0011170
	dq	-1.9446949,	-0.0026238,	0.0075196
;
xmin	dq	-0.2911			;init set view specs
xrange	dq	0.00004
ymin	dq	0.85828
yrange	dq	0.00003
limidx	dw	3			;limit index in use
reslim	dw	63			;resolution limit in use
rlim	dw	63,15,31,63,127,255,511,1023
;
	align	4
deltax	dq	0.0			;step delta values
deltay	dq	0.0
x	dq	0.0			;current scan position
y	dq	0.0
F4	dq	4.0			;constant
;
dxmin	dd	0.0			;dword forms of view specs
dxrng	dd	0.0			;for FORMDS
dymin	dd	0.0
;
k4	dw	4			;constant
dsxm	dw	0			;display max coordinates
dsym	dw	0
xpos	dw	0			;x,y step
ypos	dw	0
dgx	dw	0			;dig coordinate
dgy	dw	0
pdgx	dw	0			;prior dig coordinate
pdgy	dw	0
ctype	db	0			;cursor type flag
;
rbox	dw	rboxt,33,4,7
	dw	1,2,2,1,0
	dw	5,2,2,1,0
	dw	9,2,2,1,0
	dw	13,2,3,1,0
	dw	18,2,3,1,0
	dw	23,2,3,1,0
	dw	28,2,4,1,0
;
rboxt	db	'Iteration limit:                 ',0
	db	'                                 ',0
	db	' 16  32  64  128  256  512  1024 ',0
	db	'                                 ',0
;
dbox	dw	dboxt,31,12,16
	dw	1,2,9,1,'1'
	dw	11,2,9,1,'2'
	dw	21,2,9,1,'3'
	dw	1,4,9,1,'4'
	dw	11,4,9,1,'5'
	dw	21,4,9,1,'6'
	dw	1,6,9,1,'7'
	dw	11,6,9,1,'8'
	dw	21,6,9,1,'9'
	dw	1,8,9,1,'C'
	dw	11,8,9,1,'R'
	dw	21,8,9,1,'F'
	dw	1,10,5,1,'P'
	dw	8,10,5,1,'E'
	dw	15,10,6,1,'L'
	dw	23,10,7,1,'D'
;
dboxt	db	'Display view of Mandelbrot Set:',0
	db	'                               ',0
	db	' 1|All     2|Point   3|Tower   ',0
	db	'                               ',0
	db	' 4|Bay     5|Chaos   6|Spiral  ',0
	db	'                               ',0
	db	' 7|Hires   8|Canyon  9|Bigfoot ',0
	db	'                               ',0
	db	' Carnival  Rivers    Fireant   ',0
	db	'                               ',0
	db	' Prior  Enter  Limits  Display ',0
	db	'                               ',0
;
promp1	db	'Low X:',0
promp2	db	'Low Y:',0
promp3	db	'Width:',0
;
vfmt	db	'X=!1 Y=!1 W=!1',0
vlst	dw	dxmin,dymin,dxrng
;
cmap	db	0,15,6,7,5,14,3,9,12,13,1,4,10,11,8,2
	db	6,7,5,14,3,9,12,13,1,4,10,11,8,2
	db	6,7,5,14,3,9,12,13,1,4,10,11,8,2
	db	6,7,5,14,3,9,12,13,1,4,10,11,8,2
	db	6,7,5,14,3,9
;
usemap	dw	offset cmap
;
mmap	db	0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1
	db	0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1
	db	0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1
	db	0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1
;
FSName	db	'A.MND',0		;file save name
playt	db	'.MND',0		;play file type
playp	db	'Mandelbrot Set file:',0;prompt
playn	db	66 dup (0)		;play file name
;
LIMITS:
;	pick calculation detail limit
	mov	ax,DS			;start the dialog
	mov	ES,ax
	lea	di,rbox
	SVC	SDLOG
	mov	ax,LimIdx		;mark current limit
	SVC	INVITM
	SVC	QDLOG			;pick a choice
	push	ax
	SVC	EDLOG			;clear the dialog
	pop	ax
	cmp	ax,0			;cancel?
	jnz	sres
	jmp	short mandel		;yes
sres:	mov	limidx,ax		;save limit index
	mov	bx,ax			;word index
	shl	bx,1
	mov	ax,rlim[bx]
	mov	reslim,ax		;set new value
;
MANDEL:
	if	WeitekV
	WINIT				;init Weitek Coprocessor
	endif
;	pick view to display
	mov	ax,DS			;start the dialog
	mov	ES,ax
	lea	di,dbox
	SVC	SDLOG
	SVC	QDLOG			;pick a choice
	push	ax
	SVC	EDLOG			;clear the dialog
	pop	ax
	cmp	ax,0			;cancel?
	jnz	notcan
canit:	EXIT				;yes
notcan:	cmp	ax,13			;preset view?
	jb	ispsv
	cmp	ax,14
	jz	eview
	jb	isprv
	cmp	ax,15
	ja	isdis
	jmp	limits
ispsv:	jmp	vok
isprv:	jmp	mkdis
isdis:	jmp	display
eview:	mov	ax,DS			;enter specs: xmin
	mov	ES,ax
	lea	si,promp1
	SVC	GRVAL
	cmp	dl,0
	jnz	canit
	fstp	xmin
	mov	ax,DS			;enter specs: ymin
	mov	ES,ax
	lea	si,promp2
	SVC	GRVAL
	cmp	dl,0
	jnz	canit
	fstp	ymin
	mov	ax,DS			;enter specs: xrange
	mov	ES,ax
	lea	si,promp3
	SVC	GRVAL
	cmp	dl,0
	jnz	canit
	fabs
	fstp	xrange
	jmp	short mkdis
;	use preset view
vok:	mov	bx,ax			;table index
	dec	bx
	mov	ax,24			;each set is 24 bytes
	mul	bx
	mov	bx,ax
	fld	views[bx]		;copy selected view
	fstp	xmin
	fld	views+8[bx]
	fstp	ymin
	fld	views+16[bx]
	fstp	xrange
;	make display of current Set view
mkdis:	les	bx,DSP			;get display size
	mov	si,ES:dsxmax[bx]	;dsxmax
	mov	di,ES:dsymax[bx]	;dsymax
	mov	dsxm,si
	mov	dsym,di
	cmp	ES:dstnclr[bx],1	;monochrome display?
	ja	nmono
	mov	usemap,offset MMAP
nmono:	sub	si,si			;save entire screen
	sub	di,di
	mov	dx,dsxm
	mov	ax,dsym
	CALLDP	DSSAVE			;save graphics screen
nxview:	CALLDP	DSCLEAR			;clear screen
	CALLDP	DSDRAW			;display in draw mode
	les	bx,DSP			;get display size
	fild	ES:dsyar[bx]		;yrange based on aspect ratio & xrange
	fidiv	ES:dsxar[bx]
	fmul	xrange
	fstp	yrange
	fld	xrange			;calc step deltas
	fidiv	dsxm
	fstp	deltax
	fld	yrange
	fidiv	dsym
	fstp	deltay
	fld	ymin			;init Y loop
	fstp	y
	mov	ypos,0
	mov	cx,dsym
	inc	cx
	mov	bp,-1			;prior color
ylup:	push	cx			;save y loop counter
	fld	xmin			;init X loop
	fstp	x
	mov	xpos,0
	mov	cx,dsxm
	inc	cx
xlup:	push	cx			;save x loop counter
	fwait
	call	VCalc			;calculate present value
	cmp	bp,cx			;color changed?
	jz	csame
	mov	bp,cx
	mov	bx,cx			;set color
	push	bp
	add	bx,usemap
	mov	al,[bx]
	sub	ah,ah
	CALLDP	DSCOLOR
	pop	bp
csame:	mov	si,xpos			;set dot to color
	mov	di,ypos
	push	bp
	CALLDP	DSPOINT
	SVC	NWKEY			;keypress quit?
	pop	bp
	cmp	al,0
	jz	kpok
	jmp	quit
kpok:	fld	X			;bump X value
	fadd	deltax
	fstp	X
	inc	xpos
	pop	cx			;loop for all X
	loop	xlup
	fld	Y			;bump Y value
	fadd	deltay
	fstp	Y
	inc	ypos
	pop	cx			;loop for all Y
	loop	ylup
;	put display coordinates on top line
	SVC	GKEY			;wait for keypress
	cmp	al,'A'			;file save?
	jb	disc
	cmp	al,'Z'
	jbe	isfs
	cmp	al,'a'
	jb	disc
	cmp	al,'z'
	ja	disc
isfs:	call	FDSAVE			;yes save it
disc:	fld	xmin			;change qwords to dwords
	fstp	dxmin
	fld	ymin
	fstp	dymin
	fld	xrange
	fstp	dxrng
	mov	al,8			;set # decimal places
	SVC	NDECP
	mov	si,0			;position
	mov	di,0
	SVC	POSGC
	mov	ax,DS			;display
	mov	ES,ax
	lea	si,vfmt
	lea	dx,vlst
	SVC	FORMDS
;	get next view window spec
	CALLDP	DSINV			;xor draw
	mov	ctype,0			;crosshairs
	call	DIGPT			;first corner
	jc	bye
	mov	ctype,1			;window
	call	DIGPT			;2nd corner
	jc	bye
	fcom	st(2)			;order y
	fjge	fyok
	fxch	st(2)
fyok:	fxch	st(1)			;order x
	fcom	st(3)
	fjge	fxok
	fxch	st(3)
fxok:	fxch	st(1)
	fsub	st,st(2)		;delta Y
	fabs
	fxch	st(1)
	fsub	st,st(3)		;delta X
	fabs
	fcom	st(1)			;pick largest
	fjle	dylg
	fst	st(1)
dylg:	fpop				;discard smaller delta
	fstp	xrange
	fstp	ymin			;store corner
	fstp	xmin
	jmp	nxview			;go make zoom view
bye:	finit				;clear 8087
	CALLDP	DSDRAW			;normal draw mode
	CALLDP	DSREST			;restore screen
	EXIT				;done
;	quit from inside loop
quit:	pop	ax			;discard 2 loop vars
	pop	ax
	CALLDP	DSREST			;restore screen
	EXIT				;done
;
	if	WeitekV
;
VCalc	proc	near
	mov	cx,reslim		;loop maximum value
	mov	eax,dword ptr F4	;load test constant
	mov	edx,dword ptr F4+4
	WDLD	R2
	mov	eax,dword ptr X		;load point coordinate
	mov	edx,dword ptr X+4
	WDLD	R6
	mov	eax,dword ptr Y
	mov	edx,dword ptr Y+4
	WDLD	R8
	WDLD	R10,R6			;copy to zr,zi
	WDLD	R12,R8
vlup:	WDLD	R14,R10			;r14=zr*zr
	WDMUL	R14,R14
	WDLD	R16,R12			;r16=zi*zi
	WDMUL	R16,R16
	WDLD	R4,R14			;if zr*zr+zi*zi>4.0
	WDADD	R4,R16
	WDCMPR	R2,R4
	ja	vdone			;then exit loop
	WDSUBR	R16,R14			;R16=zr*zr-zi*zi
	WDADD	R16,R6			;R16=zr*zr-zi*zi+x
	WDADD	R10,R10			;R10=2*zr
	WDMUL	R12,R10			;R12=2*zr*zi
	WDADD	R12,R8			;R12=2*zr*zi+y
	WDLD	R10,R16			;R10=zr*zr-zi*zi+x
	loop	vlup			;until N=0
vdone:	and	cx,63			;cmap range
	ret
vcalc	endp
;
	else
;
VCalc	proc	near
	mov	cx,reslim		;loop maximum value
	fld	x
	fld	y
	fld	x
	fld	y
vlup:	fld	st(1)			;x*x
	fmul	st,st(0)
	fld	st(1)			;y*y
	fmul	st,st(0)
	fld	st(1)			;if (x*x+y*y)>4
	fadd	st,st(1)
	ficomp	k4
	fjg	vdone			;then done
	fld	st(5)			;new x=x*x-y*y+origX
	fadd	st,st(2)
	fsub	st,st(1)
	fld	st(4)			;new y=2x*y+origY
	fadd	st,st(0)
	fmul	st,st(4)
	fadd	st,st(6)
	fstp	st(4)			;update new values
	fstp	st(4)
	fpop				;clear old y*y
	fpop				;clear old x*x
	loop	vlup			;until N=0
vdone:	and	cx,63			;cmap range
	finit				;clear stack
	ret
vcalc	endp
;
	endif
;
DIGPT	proc	near
	mov	ax,dgx			;save prior point
	mov	pdgx,ax
	mov	ax,dgy
	mov	pdgy,ax
	mov	dgx,0			;init cursor
	mov	dgy,0
tklup:	call	dcrsr			;draw at position
tksame:	mov	ah,06h			;keypress?
	mov	dl,0FFh
	int	21H
	jnz	dgcan
	CALLDP	DGREAD			;read new position
	cmp	ax,2			;any button down?
	jae	dotrk
	cmp	dgx,si			;changed position?
	jnz	dotrk
	cmp	dgy,di
	jz	tksame			;no
dotrk:	push	si
	push	di
	push	ax
	call	dcrsr			;undraw old cursor
	pop	ax
	pop	di
	pop	si
	cmp	ax,3			;cancel?
	jnz	try2
dgcan:	stc				;JC = no point available
	ret
try2:	cmp	ax,2			;use point?
	jz	useit
	mov	dgx,si			;no - track
	mov	dgy,di
	jmp	short tklup
useit:	mov	dgx,si			;store dig
	mov	dgy,di
buwait:	CALLDP	DGREAD			;wait for button up
	cmp	al,2
	jae	buwait
	fild	dgx			;x=dgx/dsxm*xrange+xlow
	fidiv	dsxm
	fmul	xrange
	fadd	xmin
	fild	dgy			;y=dgy/dsym*yrange+ylow
	fidiv	dsym
	fmul	yrange
	fadd	ymin
	clc				;JNC = point ok
	ret
digpt	endp
;
DCRSR	proc	near			;draw cursor
	cmp	ctype,1			;window?
	jz	wcsr
;	crosshairs cursor
	mov	si,0			;horizontal
	mov	di,dgy
	mov	dx,dsxm
	mov	ax,di
	CALLDP	DSLINE
	mov	si,dgx			;vertical
	mov	di,0
	mov	dx,si
	mov	ax,dsym
	CALLDP	DSLINE
	ret				;done
;	screen window cursor
wcsr:	mov	si,pdgx			;setup rectangle
	mov	di,pdgy
	mov	dx,dgx
	mov	ax,dgy
	cmp	dx,si			;order x
	jae	xok
	xchg	dx,si
xok:	cmp	ax,di			;order y
	jae	yok
	xchg	ax,di
yok:	CALLDP	DSREC			;draw rectangle
	ret
dcrsr	endp
;
;	---------------------------------------------------------------
;	FDSAVE - Save file to [AL].PIC file
;	JC set if errors
;	---------------------------------------------------------------
;
FDSave	proc	near
	mov	FSName,al		;save name key
	mov	ah,3Ch			;create file
	lea	dx,FSName
	mov	cx,0			;normal attributes
	int	21h
	mov	bx,ax			;save handle
	jc	fsoe			;open error?
	mov	ah,40h			;write view parms
	lea	dx,xmin
	mov	cx,36
	int	21h
	CALLDP	DSDSKS			;no - save file
	pushf				;save result flag
	mov	ah,3Eh			;close file BX
	int	21H
	jc	fsce			;close error?
	popf				;restore result flag
fsoe:	ret				;done
fsce:	pop	ax			;discard DSDSKS result status
	ret
fdsave	endp
;
;	---------------------------------------------------------------
;	FREST - Save file to [AL].MND file
;	JC set if errors
;	---------------------------------------------------------------
;
FREST	proc	near
	mov	FSName,al		;save name key
	mov	ax,3D00h		;open file
	lea	dx,PlayN
	int	21h
	mov	bx,ax			;save handle
	jc	froe			;open error?
	mov	si,limidx		;save in-use limits
	mov	di,reslim
	mov	ah,3Fh			;read view parms
	lea	dx,xmin
	mov	cx,36
	int	21h
	cmp	limidx,si		;saved at higher res?
	jae	uhlim
	mov	limidx,si		;no - use in-use settings
	mov	reslim,di
uhlim:	CALLDP	DSDSKR			;no - restore file
	pushf				;save result flag
	mov	ah,3Eh			;close file BX
	int	21H
	jc	frce			;close error?
	popf				;restore result flag
froe:	ret				;done
frce:	pop	ax			;discard DSDSKS result status
	ret
frest	endp
;
;	---------------------------------------------------------------
;	DISPLAY - Display saved pictures
;	---------------------------------------------------------------
;
DISPLAY:
	les	bx,DSP			;get display size
	mov	si,ES:dsxmax[bx]	;dsxmax
	mov	di,ES:dsymax[bx]	;dsymax
	mov	dsxm,si
	mov	dsym,di
	cmp	ES:dstnclr[bx],1	;monochrome display?
	ja	nxplay
	mov	usemap,offset MMAP
nxplay:	mov	ax,DS			;get file name
	mov	ES,ax
	lea	si,playp		;prompt
	lea	dx,playt		;desired type
	lea	di,playn		;result name
	SVC	GFNAME			;get file name
	jc	isfr
isfr:	CALLDP	DSSAVE
	CALLDP	DSCLEAR
	call	FREST			;yes restore it
	jc	notrst
	SVC	GKEY			;wait for keypress
notrst:	jmp	disc			;go display coord, get next vw
;
;	---------------------------------------------------------------
;
	include	XPEND.CPY
