;	WEITEK.CPY - Weitek Coprocessor Board Macros
;
;	Copyright 1988 Evolution Computing
;	All rights reserved
;	Written 2/20/1988 by Mike Riddle
;
;	Source Register Equates
;
R1	equ	1
R2	equ	2
R3	equ	3
R4	equ	4
R5	equ	5
R6	equ	6
R7	equ	7
R8	equ	8
R9	equ	9
R10	equ	10
R11	equ	11
R12	equ	12
R13	equ	13
R14	equ	14
R15	equ	15
R16	equ	16
R17	equ	17
R18	equ	18
R19	equ	19
R20	equ	20
R21	equ	21
R22	equ	22
R23	equ	23
R24	equ	24
R25	equ	25
R26	equ	26
R27	equ	27
R28	equ	28
R29	equ	29
R30	equ	30
R31	equ	31
;
WFLDCTX	macro	Src
	mov	dword ptr FS:[10h+0C000h],src
	endm
;
WFSTCTX	macro	dest
	mov	dest,dword ptr FS:[10h+0C400h]
	endm
;
WINIT	macro
	local	j1,i1
	mov	ax,0FFFFh		;use FS to address WEITEK
	mov	FS,ax
	WFLDCTX	0B8000000h		;set PCR bit 15 if 1163A
	WFSTCTX	eax
	and	ax,8000h
	jnz	short j1		;<>0 if 1163A
	WFLDCTX	016000000h		;init mult & alu timers
	jmp	short i1
j1:	WFLDCTX	056000000h		;init mult timer
	WFLDCTX	098000000h		;init alu timer
i1:	WFLDCTX	064000000h		;init acc timer #1
	WFLDCTX	0A0000000h		;init acc timer #2
	WFLDCTX	030000000h		;reserved mode bits to 0
	WFLDCTX	003FF0000h		;rounding (03) exmask (FF)
	endm
;
WFST	macro	dest,src
	mov	dest,dword ptr FS:[10h+00C00h+(src shl 2)]
	endm
;
weitek	macro	dest,src,bsrc
wtkr	=	1
	ifidni	<src>,<EAX>
wtkr	=	0
	endif
	ifidni	<src>,<EBX>
wtkr	=	0
	endif
	ifidni	<src>,<ECX>
wtkr	=	0
	endif
	ifidni	<src>,<EDX>
wtkr	=	0
	endif
	ifidni	<src>,<ESI>
wtkr	=	0
	endif
	ifidni	<src>,<EDI>
wtkr	=	0
	endif
	ifidni	<src>,<EBP>
wtkr	=	0
	endif
	ifnb	<bsrc>
wtkr	=	0
	endif
	if	wtkr
wtkv	=	10h+wtko+(Dest shl 2)+(src and 3)+((src and 1ch) shl 5)
	mov	FS:[wtkv],al
	else
wtkv	=	10h+wtko+(Dest shl 2)
	mov	dword ptr FS:[wtkv],src
	endif
	endm
;
WFLD	macro	dest,src,bsrc
wtko	=	00400h
	weitek	dest,src,bsrc
	endm
;
WFADD	macro	dest,src,bsrc
wtko	=	00000h
	weitek	dest,src,bsrc
	endm
;
WFMUL	macro	dest,src,bsrc
wtko	=	00800h
	weitek	dest,src,bsrc
	endm
;
WFMULN	macro	dest,src,bsrc
wtko	=	01800h
	weitek	dest,src,bsrc
	endm
;
WFAMUL	macro	dest,src,bsrc
wtko	=	03800h
	weitek	dest,src,bsrc
	endm
;
WFSUBR	macro	dest,src,bsrc
wtko	=	01000h
	weitek	dest,src,bsrc
	endm
;
WFDIVR	macro	dest,src,bsrc
wtko	=	01400h
	weitek	dest,src,bsrc
	endm
;
WFNEG	macro	dest,src,bsrc
wtko	=	02800h
	weitek	dest,src,bsrc
	endm
;
WFABS	macro	dest,src,bsrc
wtko	=	02C00h
	weitek	dest,src,bsrc
	endm
;
WFIX	macro	dest,src,bsrc
wtko	=	03C00h
	weitek	dest,src,bsrc
	endm
;
WFLOAT	macro	dest,src,bsrc
wtko	=	01C00h
	weitek	dest,src,bsrc
	endm
;
WFMAC	macro	dest,src,bsrc
wtko	=	04800h
	weitek	dest,src,bsrc
	endm
;
WFCMPR	macro	dest,src,bsrc
wtko	=	03000h
	weitek	dest,src,bsrc
	WFSTCTX	eax			;set JB/JZ/JA flags
	SAHF
	endm
;
WFTST	macro	src,bsrc
wtko	=	03400h
	weitek	0,src,bsrc
	WFSTCTX	eax			;set JB/JZ/JA flags
	SAHF
	endm
;
;	---------------------------------------------------------
;
WDST	macro	src
	mov	edx,dword ptr FS:[10h+00C00h+(src shl 2)]
	mov	eax,dword ptr FS:[10h+00C00h+((src+1) shl 2)]
	endm
;
WDLD	macro	dest,src
	ifb	<src>
wtkd	=	dest+1
	WFLD	wtkd,EAX
	WFLD	dest,EDX
	else
wtkd	=	dest+1
wtks	=	src+1
wtko	=	08400h
	weitek	wtkd,wtks
	weitek	dest,src
	endif
	endm
;
WDADD	macro	dest,src,bsrc
wtko	=	08000h
	weitek	dest,src,bsrc
	endm
;
WDMUL	macro	dest,src,bsrc
wtko	=	08800h
	weitek	dest,src,bsrc
	endm
;
WDMULN	macro	dest,src,bsrc
wtko	=	09800h
	weitek	dest,src,bsrc
	endm
;
WDAMUL	macro	dest,src,bsrc
wtko	=	0B800h
	weitek	dest,src,bsrc
	endm
;
WDSUBR	macro	dest,src,bsrc
wtko	=	09000h
	weitek	dest,src,bsrc
	endm
;
WDDIVR	macro	dest,src,bsrc
wtko	=	09400h
	weitek	dest,src,bsrc
	endm
;
WDNEG	macro	dest,src,bsrc
wtko	=	0A800h
	weitek	dest,src,bsrc
	endm
;
WDABS	macro	dest,src,bsrc
wtko	=	0AC00h
	weitek	dest,src,bsrc
	endm
;
WDFIX	macro	dest,src,bsrc
wtko	=	0BC00h
	weitek	dest,src,bsrc
	endm
;
WDCVT	macro	dest,src,bsrc
wtko	=	04400h		;single to double
	weitek	dest,src,bsrc
	endm
;
WFCVT	macro	dest,src,bsrc
wtko	=	04000h		;double to single
	weitek	dest,src,bsrc
	endm
;
WDFLOAT	macro	dest,src,bsrc
wtko	=	09C00h
	weitek	dest,src,bsrc
	endm
;
WDMAC	macro	dest,src,bsrc
wtko	=	0C800h
	weitek	dest,src,bsrc
	endm
;
WDCMPR	macro	dest,src,bsrc
wtko	=	0B000h
	weitek	dest,src,bsrc
	WFSTCTX	eax			;set JB/JZ/JA flags
	SAHF
	endm
;
WDTST	macro	src,bsrc
wtko	=	0B400h
	weitek	0,src,bsrc
	WFSTCTX	eax			;set JB/JZ/JA flags
	SAHF
	endm
;
