;	XP8087.CPY - common 8087 macros for EPM routines
;
;	(c) Copyright 1987 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle  9/25/87
;	Comments by Susan Montooth 8/8/91
;
fstat	macro				;used by jump macros below
	fstsw	CS:s87			;no multi-segment code!
;					;seg(S87) must be CS because
;					;people may use this with
;					;DS & ES <> SEG(S87).
;					;(FCOMP/FJGE on ENTREC sorts...)
	fwait
	mov	ah,byte ptr CS:s87+1
	sahf
	endm
;
;	in comments below <var> means real number in memory,
;	8087 tos means 8087 top-of-stack. Sequence to compare A and B:
;		fld	A
;		fcomp	B
;		fjl	AisLess
;
fjl	macro	jto			;use after FCOMP <var>
	fstat				;jumps if 8087 tos < <var> 
	jb	jto
	endm
;
fjle	macro	jto			;use after FCOMP <var>
	fstat				;jumps if 8087 tos  <var>
	jbe	jto
	endm
;
fje	macro	jto			;use after FCOMP <var>
	fstat				;jumps if 8087 tos = <var>
	je	jto
	endm
;
fjne	macro	jto			;use after FCOMP <var>
	fstat				;jumps if 8087 tos not equal to <var>
	jne	jto
	endm
;
fjg	macro	jto			;use after FCOMP <var>
	fstat				;jumps if 8087 tos > <var>
	ja	jto
	endm
;
fjge	macro	jto			;use after FCOMP <var>
	fstat				;jumps if 8087 tos  <var>
	jae	jto
	endm
;
fj3	macro	jtol,jtoe,jtog
	fstat		
	jb	jtol
	je	jtoe
	jmp	short jtog
	endm
;
fdup	macro				;duplicates top of 8087 stack
	fld	st(0)
	endm
;
fpop	macro				;removes top of 8087 stack
	fstp	st(0)
	endm
;
fmove	macro	dest,src		;copies real in memory to another,
	fwait				;waiting for previous 8087 store
	mov	ax,word ptr src		;to memory to finish.
	mov	word ptr dest,ax	;(does not use 8087)
	mov	ax,word ptr src+2
	mov	word ptr dest+2,ax
	endm
;
fnmove	macro	dest,src		;copies real in memory to another,
	mov	ax,word ptr src		;without waiting for 8087 store
	mov	word ptr dest,ax
	mov	ax,word ptr src+2
	mov	word ptr dest+2,ax
	endm
;
fswap	macro	A,B			;exchanges 2 reals in memory
	fwait
	mov	ax,word ptr A
	mov	dx,word ptr B
	mov	word ptr A,dx
	mov	word ptr B,ax
	mov	ax,word ptr A+2
	mov	dx,word ptr B+2
	mov	word ptr A+2,dx
	mov	word ptr B+2,ax
	endm
;
fzero	macro	A			;sets real in memory equal to 0.0
	mov	word ptr A,0
	mov	word ptr A+2,0
	endm
;
fone	macro	A			;sets real in memory equal to 1.0
	mov	word ptr A,0
	mov	word ptr A+2,3F80h
	endm
;
FMAX	macro	A
	local	ismax
	fcom	A			;ST=MAX(ST,A)
	fjge	ismax
	fpop
	fld	A
ismax:
	endm
;
FMIN	macro	A
	local	ismin
	fcom	A			;ST=MIN(ST,A)
	fjle	ismin
	fpop
	fld	A
ismin:
	endm
;
