;	XPDEMO - FastCAD(R) External Procedure Demo Program
;
;	(c) Copyright 1987,88,89 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle 9/22/87
;	Improved COUNT/COUNTA, add CHANGER command by Susan Montooth 5/30/88
;		Count commands updated for all 3d entities S.M. 4/89
;		Layer Status added S.M. 4/89
;	Remove CHGRAD command, add more entities to COUNT(A) 5/28/90 MR
;
	name	XPDEMO
;
	include	XPSTART.CPY
;
;	---------------------------------------------------------------
;	XCMD - External Process Command - command # BX
;
;	commands 0..10 are preassigned signals
;	user commands start with command #11
;	---------------------------------------------------------------
;
XCMD:	ENTRY
	shl	bx,1			;make word index
	add	bx,offset cmdtbl
	mov	bx,[bx]			;get command offset
	jmp	bx			;go to command handler
cmdtbl	dw	offset nulcmd		;0 = Startup ExtProc
	dw	offset nulcmd		;1 = Ending use of ExtProc
	dw	offset nulcmd		;2 = Drawing renamed
	dw	offset nulcmd		;3 = Drawing Just Loaded
	dw	offset nulcmd		;4 = Drawing about to be saved
	dw	offset nulcmd		;5 = Drawing REVERTed to prior save
	dw	offset nulcmd		;6 = before getting next command
	dw	offset nulcmd		;7 = regen completed - repath
	dw	offset nulcmd		;8 = About to write part
	dw	offset nulcmd		;9 = Part inserted
	dw	offset nulcmd		;10 = unused
	dw	offset cntcmd		;11 = COUNT command
	dw	offset cntall		;12 = COUNTA command
	dw	offset layst		;13 = LSTATUS command
;	other commands offsets go here
nulcmd:	EXIT
;
;	---------------------------------------------------------------
;	XENTITY - External Process Entity Support
;	---------------------------------------------------------------
;
XENT:	ENTRY
	mov	bx,ax			;desired op # in AX
	shl	bx,1			;make word index
	add	bx,offset eftbl
	mov	bx,[bx]			;get entity function offset
	jmp	bx			;go to function  handler
eftbl	dw	offset nullop		;0 = draw entity
	dw	offset nullop		;1 = pick test entity
	dw	offset nullop		;2 = transform entity
	dw	offset nullop		;3 = stretch entity
	dw	offset nullop		;4 = list entity
	dw	offset nullop		;5 = check entity extents
	dw	offset nullop		;6 = attach to entity
	dw	offset nullop		;7 = actuate entity
nullop:	finit				;clear 8087
	clc				;no pick/attach
	EXIT
;
;	---------------------------------------------------------------
;	XCSTG - Command Name String
;
;	Each command word is UPPERCASE, space delimited.
;	---------------------------------------------------------------
;
XPEXID	dw	0			;no EXT entities in this module
;
XCSTG	db	'COUNT COUNTA LSTATUS '
	db	0			;end of command word table
;
;	---------------------------------------------------------------
;	DOS Identification Message
;	---------------------------------------------------------------
;
ident	db	'XPDEMO - Test & Sample Program.',13,10
	db	'FastCAD(R) External Procedure Module - version '
	db	'2.30',13,10
	db	'(C) Copyright 1987,88,89 Evolution Computing',13,10,13,10
	db	'COUNT',9,'Counts selected entities.',13,10
	db	'COUNTA',9,'Counts all entities.',13,10
	db	'LSTATUS',9,'Shows which layers contain entities',13,10
	db	9,'and which are frozen or hidden.',13,10,'$'
;
;	---------------------------------------------------------------
;	CNTCMD - Count selected entities in the database
;	CNTALL - Count all entities in the database
;	---------------------------------------------------------------
;
CNTCMD: mov	SelFlag,1
	jmp	short GetFN
CNTALL:	mov	SelFlag,0
;
GetFN:	mov	ax,DS			;get current drawing path&name
	mov	ES,ax
	lea	di,dfname
	SVC	CURFN
;
;	initialize the counters
;
	mov	ax,DS			;zero out the counts
	mov	ES,ax
	cld				;upscan
	lea	di,ecounts
	mov	cx,47			;etypes 0 through 46
	mov	ax,0			;clear to zero
	rep	stosw			;do it
	mov	total,0			;clear entity total
	mov	word ptr bcount,0	;clear RAM total (1st word)
	mov	word ptr bcount+2,0	;clear RAM total (2nd word)
;
;	select entities to be counted
;
	cmp	SelFlag,1		;Is this a selective count?
	je	SelOnly
	SVC	SELALL			;select all entities 
	jmp	short ScnBgn
SelOnly:SVC	SELECT			;let user select entities
;
;	scan and count selected entities
;
ScnBgn:	mov	ax,0			;start scan
	mov	dx,0
	SVC	STSCAN
CLoop:	cmp	ax,-1			;at end of file?
	jz	CntRpt			;if so go to report
	mov	al,ES:etype[di]		;get entity type
	cmp	al,46			;erased or unknown?
	ja	gnxt
	mov	bl,al			;get index
	sub	bh,bh
	shl	bx,1			;multiply by 2
	inc	ecounts[bx]		;count it
	inc	total			;and add to entity total
	mov	ax,ES:erlen[di]		;get entity size in bytes
	add	word ptr bcount,ax	;add to RAM total
	adc	word ptr bcount+2,0	;finish adding double
	cmp	SelFlag,1		;Is this a selective count?
	jne	GNxt			;If CntAll skip un-highlight
	SVC	DRAW
GNxt:	SVC	NXSCAN			;get next entity
	jmp	short CLoop		;go test & count it
;
;	Make the count report (display results)
;
CntRpt:	mov	ax,ecounts+22		;combine arrows & darrows
	add	ecounts+20,ax
	mov	ax,word ptr bcount	;convert RAM bytes to K
	mov	dx,word ptr bcount+2
	add	ax,1023
	adc	dx,0
	div	K
	mov	kcount,ax		;store result
	SVC	TSINIT			;change to text screen
	mov	al,017H			;use white on blue screen
	SVC	TSATRB
	SVC	TSCLR			;clear screen and home cursor
	mov	ax,DS			;display report
	mov	ES,ax
	lea	si,crept
	lea	dx,cvarl
	SVC	FORMDS			;make display
	mov	cx,80			;invert top line
	mov	si,0
	mov	di,0
	SVC	TSINV
	mov	si,50			;position last line
	mov	di,24
	SVC	POSTC
	mov	ax,DS			;display "press any key"
	mov	ES,ax
	lea	si,pakmsg
	SVC	FORMDS
	mov	cx,32			;invert last line
	mov	si,48
	mov	di,24
	SVC	TSINV
	SVC	GKEY			;wait for keypress or button
	SVC	TSEND			;restore graphics screen
	SVC	DESELA			;deselect all to suppress undo after
	EXIT				;done
;
SelFlag	db	0			;1 if CNTCMD (selective), 0 if CNTALL
total	dw	0			;total entity count
ecounts	dw	0			;counts for entities 0..46
	dw	46 dup (0)
bcount	dd	0			;total memory in bytes
K	dw	1024			;constant for 1 Kilobyte
kcount	dw	0			;total memory in K
;
crept	db	' Selected entity counts for !5:',13
	db	9,'!6',9,'points',9,9,9
	db		'!6',9,'3D points',13
	db	9,'!6',9,'lines',9,9,9
	db		'!6',9,'3D lines',13
	db	9,'!6',9,'text',9,9,9
	db		'!6',9,'3D text',13
	db	9,'!6',9,'circles',9,9,9
	db		'!6',9,'3D circles',13
	db	9,'!6',9,'arcs',9,9,9
	db		'!6',9,'3D arcs',13
	db	9,'!6',9,'ellipses',9,9
	db		'!6',9,'3D ellipses',13
	db	9,'!6',9,'elliptical arcs',9,9
	db		'!6',9,'3D elliptical arcs',13
	db	9,'!6',9,'paths',9,9,9
	db		'!6',9,'3D paths',13
	db	9,'!6',9,'polygons',9,9
	db		'!6',9,'3D polygons',13
	db	9,'!6',9,'smooth polygons',9,9
	db		'!6',9,'3D smooth polygons',13
	db	9,'!6',9,'splines',9,9,9
	db		'!6',9,'3D splines',13
	db	9,'!6',9,'wide lines',9,9
	db		'!6',9,'3D tabulated profiles',13
	db	9,'!6',9,'arrows',9,9,9
	db		'!6',9,'3D solids',13
	db	9,'!6',9,'linear dimensions',9
	db		'!6',9,'3D spheres and segments',13
	db	9,'!6',9,'angular dimensions',9
	db		'!6',9,'3D surfaces of revolution',13
	db	9,'!6',9,'circular dimensions',9
	db		'!6',9,'3D mesh surfaces',13
	db	9,'!6',9,'ordinate dimensions',9
	db		'!6',9,'3D Coons surfaces',13
	db	9,'!6',9,'group marks',9,9
	db		'!6',9,'3D ruled surfaces',13
	db	9,'!6',9,'XP module entities',9
	db		'!6',9,'3D lights',13
	db	9,'!6',9,'symbol references',9
	db		'!6',9,'3D cylinders',13
	db	9,'!6',9,'plot assemblies',9,9
	db		'!6',9,'3D multi-polys',13
	db	9,'!6',9,'plot assembly windows',9
	db		'!6',9,'actions',13
;
	db	13,'  !6 entities total occupying !6K RAM',0
pakmsg	db	'Press any key to continue...',0
;
dfname	db	65 dup (0)		;drawing file & path name
;
cvarl	dw	dfname			;current file name
	dw	ecounts+1+1		;# points
	dw	ecounts+27+27		;# 3D points
	dw	ecounts+2+2		;# lines
	dw	ecounts+21+21		;# 3D lines
	dw	ecounts+3+3		;# text
	dw	ecounts+30+30		;# 3D text
	dw	ecounts+4+4		;# circles
	dw	ecounts+28+28		;# 3D circles
	dw	ecounts+5+5		;# arcs
	dw	ecounts+29+29		;# 3D arcs
	dw	ecounts+19+19		;# ellipses
	dw	ecounts+31+31		;# 3D ellipses
	dw	ecounts+20+20		;# elliptical arcs
	dw	ecounts+32+32		;# 3D elliptical arcs
	dw	ecounts+6+6		;# paths
	dw	ecounts+22+22		;# 3D paths
	dw	ecounts+7+7		;# polys
	dw	ecounts+23+23		;# 3D polygons
	dw	ecounts+8+8		;# spolys
	dw	ecounts+25+25		;# 3D spolys
	dw	ecounts+9+9		;# splines
	dw	ecounts+26+26		;# 3D splines
	dw	ecounts+13+13		;# wide lines
	dw	ecounts+33+33		;# 3D tab profiles
	dw	ecounts+10+10		;# arrows & darrows
	dw	ecounts+24+24		;# 3D solids
	dw	ecounts+12+12		;# linear dims
	dw	ecounts+34+34		;# 3D sphere sections
	dw	ecounts+15+15		;# angular dims
	dw	ecounts+35+35		;# 3D surfaces of rev
	dw	ecounts+41+41		;# circular dimensions
	dw	ecounts+38+38		;# 3D mesh surfaces
	dw	ecounts+42+42		;# ordinate dimensions
	dw	ecounts+39+39		;# 3D coons surfaces
	dw	ecounts+14+14		;# group markers
	dw	ecounts+40+40		;# 3D ruled surfaces
	dw	ecounts+16+16		;# external proc entitys
	dw	ecounts+44+44		;# 3d lights
	dw	ecounts+18+18		;# symrefs
	dw	ecounts+46+46		;# 3d cylinders
	dw	ecounts+36+36		;# plot assy defs
	dw	ecounts+45+45		;#3d multipolys
	dw	ecounts+37+37		;# plot assy win
	dw	ecounts+43+43		;# actions
	dw	total			;total
	dw	kcount			;memory in K
;
;	---------------------------------------------------------------
;	LSTATUS - Layer Status Chart
;	---------------------------------------------------------------
;
row	dw	0			;screen row position
col	dw	0			;screen column position
layno	db	256 dup (0)		;table of entity existence
layatr	db	3Fh			;normal (hi white on cyan)
	db	39h			;hidden (hi blue on cyan)
	db	3Eh			;frozen (hi yellow on cyan)
	db	3Ah			;both   (hi green on cyan)
	db	08h			;empty-normal (grey on black)
	db	01h			;empty-hidden (blue on black)
	db	06h			;empty-frozen (yellow on black)
	db	02h			;empty-both   (green on black)
Hdrtxt	db	'LAYER STATUS CHART',13,13
	db	'In use:                                  Empty:',13
	db	''
	db	'',0
Lbltxt	db	' NORMAL',0,' HIDDEN',0,' FROZEN',0,'   BOTH',0
Ftrtxt	db	'Press any key to continue...',0
;
CurLyr	dw	0			;current layer # for format
Lyrfmt	db	'   !3',0
Lyrvar	dw	offset CurLyr
;
CurTxt	db	'      ',0			;current layer # text
;
LAYST:	
	SVC	TSINIT			;text screen
;-------Display header and footer
	mov	ax,DS			;1st line "LAYER STATUS etc"
	mov	ES,ax
	lea	si,Hdrtxt
	svc	FORMDS
	mov	si,0			;last line "press any key..."
	mov	di,24
	svc	POSTC
	mov	ax,DS
	mov	ES,ax
	lea	si,Ftrtxt
	svc	FORMDS
;-------Display example attribute labels
	mov	cx,0
Lblp:	mov	ax,cx			;calculate column
	add	ax,1
	shl	ax,1			;3 shifts = *8
	shl	ax,1
	shl	ax,1
	cmp	cx,4			;for 4-7 offset col by 8
	jb	colok
	add	ax,8
colok:	mov	si,ax
	mov	di,2			;send row
	push	cx
	svc	POSTC
	pop	cx
	mov	bx,cx			;look up attribute
	mov	al,layatr[bx]
	push	cx
	svc	TSATRB
	pop	cx
	mov	ax,DS			;display label text
	mov	ES,ax
	mov	ax,cx
	and	ax,3			;reduce 4-7 to 0-3
	shl	ax,1			;multiply by 8
	shl	ax,1
	shl	ax,1
	mov	bx,ax
	lea	si,Lbltxt[bx]
	push	cx
	svc	FORMDS
	pop	cx
	inc	cx
	cmp	cx,7			;are we done yet?
	jbe	Lblp
;-------build entity existence table
	mov	ax,DS			;initialize to 0
	mov	ES,ax
	lea	di,layno
	mov	cx,128			;128 words
	mov	ax,0
	rep	stosw
	svc	SELALL			;scan database
	sub	ax,ax			;init rec # for scan
	sub	dx,dx
	svc	STSCAN
cknxt:	jnc	DoLyr			;if at end of file go next step
	mov	bl,ES:elayer[di]
	sub	bh,bh
	mov	layno[bx],1		;mark layer this entity is on
	svc	NXSCAN
	jmp short cknxt
;-------format and display layer status
DoLyr:	mov	row,5			;start 5 rows from top of screen
	mov	col,0
	mov	CurLyr,0
NxLyr:	mov	si,col			;position cursor on field
	mov	di,row	
	svc	POSTC			
	mov	ax,CurLyr		;layer #
	svc	LSTAT			;get layer status
	shl	ah,1			;convert ah:al to al--now
	or	al,ah			;  al has status 0 through 3
	xor	al,1			;flip hidden bit so 0=visible
	mov	bx,CurLyr		;does layer contain entities?
	test	layno[bx],1
	jnz	SndAtr			;if so send attributes
	add	al,4			;empty layer attributes 4-7
SndAtr:	mov	bl,al			;look up attribute and send	
	sub	bh,bh
	mov	al,layatr[bx]
	svc	TSATRB		
	mov	ax,DS			;format layer # as text
	mov	ES,ax
	lea	si,Lyrfmt
	lea	dx,Lyrvar		;offset to CurLyr
	lea	di,CurTxt		;destination string
	svc	FORMST
	mov	bx,cx			;characters in result
	sub	bx,4			;right-justify offset
	mov	ax,DS			;now display field
	mov	ES,ax
	lea	si,CurTxt[bx]
	svc	FORMDS
	inc	CurLyr			;loop to next layer
	cmp	CurLyr,255
	ja	LSDone			;cca
	add	col,5			;increment screen column 
	cmp	col,75			;still room this column?
	ja	NewRow			;cca
	jmp	NxLyr
NewRow:	inc	row			;start next row
	mov	col,0
	jmp	NxLyr
LSDone:	SVC	GKEY			;wait for keypress
	SVC	TSEND			;return to graphics screen
	EXIT
;
	include	XPEND.CPY
