;	XPSTART.CPY - Common Startup Code for XP Modules
;
;	(c) Copyright 1987 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle 9/22/87
;
	ifdef	make386
	.386
	.287
	option	segment:use16
	else
	.8086
	.8087
	endif
;
	include	estruc.cpy
	include	edge.cpy
	include	header.cpy
	include	xp8087.cpy
	include	xpds.cpy
	include	xpsvc.cpy
	include	geometry.cpy
;
TKVer	equ	260			;toolkit version
;
	ifdef	make386
xproc	segment	use16 public
	else
xproc	segment	public
	endif
	assume	cs:xproc,ds:xproc
;
;	---------------------------------------------------------------
;	Program Startup - DOS command or interactive use?
;	---------------------------------------------------------------
;
	org	100H
BEGIN:	ENTRY				;set DS=CS
	mov	XSeg,bp			;save our DS
	mov	bx,80H			;DS:80H = cmd line parm length
	cmp	byte ptr [bx],0FFH	;0FFH = interactive use
	jz	iau
;	We have been executed as a DOS command
	pop	DS			;cleanup DOS stack from ENTRY
	lea	dx,ident		;else just display identity msg
	mov	ah,9
	int	21H
	mov	ax,4C00H		;exit to DOS
	int	21H
;	We are in the FastCAD interactive environment
iau:	mov	FCVerN,ax		;save service available level
	mov	FCFlags,bp		;flags (bit1=1 if 3d)
	mov	CPUTyp,dl		;cpu type
	mov	MathTyp,dh		;math chip type
	mov	isvcp,di		;save SVC vector
	mov	ax,ES
	mov	isvcp+2,ax
	mov	ES,XSeg			;get com pointers
	lea	di,HDRP
	SVC	GPTRS
	lea	si,XCMD			;point to command handler
	lea	di,XENT			;point to entity handler
	lea	bx,XCSTG		;point to command string
	mov	ax,XPEXID		;serviced EXID (0=none)
	mov	dx,TKVer		;version of toolkit used
	EXIT				;return to FastCAD
;
;	---------------------------------------------------------------
;	Communication Far Pointers (set by SVC 0 in BEGIN code)
;	---------------------------------------------------------------
;
;	data record pointers
HDRP	dd	0			;far ptr to header record
ENTRP	dd	0			;far ptr to entity record
CFGP	dd	0			;far pointer to config data
DSP	dd	0			;far pointer to display parms
;	pointing driver interface
DGREAD	dd	0			;read digitizer in graphics coord.
DGTXP	dd	0			;read digitizer in text screen coord.
;	display driver interface
DSCLEAR	dd	0			;clear graphics screen
DSERA	dd	0			;draw in background color
DSDRAW	dd	0			;draw in current color
DSINV	dd	0			;draw by inversion
DSCOLOR	dd	0			;set current color # to AX
DSLPAT	dd	0			;set line style data to AX
DSFPAT	dd	0			;set fill style # to AX
DSPOINT	dd	0			;draw point SI,DI
DSLINE	dd	0			;draw line SI,DI to DX,AX
DSREC	dd	0			;draw box SI,DI to DX,AX
DSFREC	dd	0			;draw filled box SI,DI to DX,AX
DSPOLY	dd	0			;draw filled polygons
DSTEXT	dd	0			;draw prompt text
DSITXT	dd	0			;draw inverted prompt text
DSTINV	dd	0			;invert prompt text
DSTCLR	dd	0			;clear prompt text
DSSAVE	dd	0			;save graphics screen
DSREST	dd	0			;restore graphics screen
DSDSKS	dd	0			;save screen to disk
DSDSKR	dd	0			;restore screen from disk
;
;	---------------------------------------------------------------
;	Local Data
;	---------------------------------------------------------------
;
;	Processor/Math chip TEST bit masks
;
c86	equ	1	;8088/8086/80188/80186
c286	equ	2	;80286
c386	equ	4	;80386/80486
;
e87	equ	0	;8087 emulator
c87	equ	1	;8087
c287	equ	2	;80287
c387	equ	4	;80387
;
fcf3d	equ	1	;FCflags bit test for 3d
;
xseg	dw	0			;this program DS
isvcp	dw	0,0			;service routine vector
FCVerN	dw	0			;FCAD version # (ie: 260 for 2.60)
FCFlags	dw	0			;flags: bit1=1 if 3d, else 2d
CPUTyp	db	c87			;CPU type code
MathTyp	db	c86			;Math chip type code
S87	dw	0			;8087 status word
;
