;	XPTEACH - FastCAD(R) External Procedure Sample Program
;
;	(c) Copyright 1987-91 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle 1987-91
;	Additions by Susan Montooth
;
	name	XPTEACH
;
	include	XPSTART.CPY
;
;	---------------------------------------------------------------
;	XCMD - External Process Command - command # BX
;
;	commands 0..10 are preassigned signals
;	user commands start with command #11
;	---------------------------------------------------------------
;
XCMD:	ENTRY
	shl	bx,1			;make word index
	add	bx,offset cmdtbl
	mov	bx,[bx]			;get command offset
	jmp	bx			;go to command handler
cmdtbl	dw	offset nulcmd		;0 = Startup ExtProc
	dw	offset nulcmd		;1 = Ending use of ExtProc
	dw	offset nulcmd		;2 = Drawing renamed
	dw	offset nulcmd		;3 = Drawing Just Loaded
	dw	offset nulcmd		;4 = Drawing about to be saved
	dw	offset nulcmd		;5 = Drawing REVERTed to prior save
	dw	offset nulcmd		;6 = before getting next command
	dw	offset nulcmd		;7 = regen completed - repath
	dw	offset nulcmd		;8 = About to write part
	dw	offset nulcmd		;9 = part inserted
	dw	offset nulcmd		;10 = unused
	dw	offset tjig		;11 = TEST test jig
	dw	offset rdimc		;12 = RDIM (radial dimension)
	dw	offset chgrad		;13 = CHGRAD (change radius)
	dw	offset dcdemo		;14 = DCDEMO (dyn cursor demo)
	dw	offset dbox		;15 = DBOX (dialog box)
	dw	offset valbox		;16 = VALBOX (value-query dialog)
	dw	offset swbox		;17 = SWBOX (switch dialog)
	dw	offset pgbox		;18 = PGBOX (paging list dialog)
	dw	offset mtrbox		;19 = MTRBOX (byte meter dialog)
;	other commands offsets go here
nulcmd:	EXIT
;
;	---------------------------------------------------------------
;	XENTITY - External Process Entity Support
;	---------------------------------------------------------------
;
XENT:	ENTRY
	mov	bx,ax			;desired op # in AX
	shl	bx,1			;make word index
	add	bx,offset eftbl
	mov	bx,[bx]			;get entity function offset
	jmp	bx			;go to function  handler
eftbl	dw	offset nullop		;0 = draw entity
	dw	offset nullop		;1 = pick test entity
	dw	offset nullop		;2 = transform entity
	dw	offset nullop		;3 = stretch entity
	dw	offset nullop		;4 = list entity
	dw	offset nullop		;5 = check entity extents
	dw	offset nullop		;6 = attach to entity
	dw	offset nullop		;7 = actuate entity
nullop:	finit				;clear 8087
	clc				;no pick/attach
	EXIT
;
;	---------------------------------------------------------------
;	XCSTG - Command Name String
;
;	Each command word is UPPERCASE, space delimited.
;	---------------------------------------------------------------
;
XPEXID	dw	0			;no EXT entities in this module
;
XCSTG	db	'TEST RDIM CHGRAD DCDEMO '
	DB	'DBOX VALBOX SWBOX PGBOX MTRBOX '
	db	0			;end of command word table
;
;	---------------------------------------------------------------
;	DOS Identification Message
;	---------------------------------------------------------------
;
ident	db	'XPTEACH - Test & Sample Program.',13,10
	db	'FastCAD(R) External Procedure Module - version '
	db	'2.72',13,10
	db	'(C) Copyright 1987-1991 Evolution Computing',13,10
	db	13,10
	db	'TEST',9,'Test jig for XP code',13,10
	db	'RDIM',9,'Radial Dimension (sample draw command)',13,10
	db	'CHGRAD',9,'Change Radius (sample edit command)',13,10
	db	'DCDEMO',9,'Dynamic cursor example',13,10
	db	'DBOX',9,'Basic dialog box example',13,10
	db	'VALBOX',9,'Dialog example with value buttons',13,10
	db	'SWBOX',9,'Dialog example with switch buttons',13,10
	db	'PGBOX',9,'Dialog example with paging list',13,10
	db	'MTRBOX',9,'Dialog example with byte meter',13,10
	db	13,10
	db	'$'
;
;
;	---------------------------------------------------------------
;	TEST	Test jig: Currently tests Execute String service.
;		Replace this code with your own for a quick test.
;	---------------------------------------------------------------
;
exs	db	'COLOR 4;',0		;macro text to execute
;
TJIG:
	mov	ax,DS
	mov	ES,ax
	lea	di,exs
	SVC	EXECST			;queue macro for execution after EXIT
	EXIT
;
;
;	---------------------------------------------------------------
;	RDIMC	Radial Dimension Command (non-associative)
;		Adds Arrow and Text entities
;
;	Demonstrates these and other XP concepts:
;		Input services (GPOINT and GLENDP)
;		Database access (SCAN1/NEXT1)
;		Access to current entity in ENTREC
;		Building and appending entity in ENTREC
;		Header access (through CINFO and direct)
;		Arrow and text entity structure
;		Format text and output to string (FORMST)
;		Extended text justification codes
;		Math chip instructions and macros
;	---------------------------------------------------------------
;
;	Local data for RDIM command
;
cirx	dd	0.0			;circle/arc center
ciry	dd	0.0
cird	dd	0.0			;circle/arc radius
brnga	dd	0.0			;angle center->midpoint
strtx	dd	0.0			;dim start point
strty	dd	0.0
midx	dd	0.0			;dim mid point
midy	dd	0.0
endx	dd	0.0			;dim end point
endy	dd	0.0
;
dtfmt	db	'!7 Radius',0		;text format
dtvar	dw	cird			;dim value
dtstg	db	32 dup (0)		;formatted text
DTLen	dw	0			;dtstg length
;
rdp1	db	'Circle/Arc to dimension: ',0	;prompts
rdp2	db	'Bend arrow at: ',0
rdp3	db	'Text starts at: ',0
;
;	Radial Dimension Code starts here
;
RDIMC:	mov	ax,DS			;get CIRCLE/ARC to dimension
	mov	ES,ax
	lea	si,rdp1
	mov	ax,1			;point is for picking (no snap)
	SVC	GPOINT			;get pick point
	cmp	dl,0			;point available?
	jz	short pkpok
nordm:	EXIT
pkpok:	SVC	SCAN1			;scan for picked entity
pknxt:	cmp	ax,-1			;unavailable?
	jz	short nordm
	cmp	ES:etype[di],4		;circle?
	jz	short etok
	cmp	ES:etype[di],5		;arc?
	jz	short etok
	SVC	NEXT1			;no - keep trying
	jmp	short pknxt
etok:	fmove	cird,ES:crad[di]	;save radius
	fmove	cirx,ES:cenx[di]	;and center
	fmove	ciry,ES:ceny[di]
	SVC	SUNADD			;set undo = unadd
;
;	get dimension bend point
;
	mov	ax,DS			;get dimension bend point
	mov	ES,ax
	lea	si,rdp2
	fld	cirx			;rubber-band origin
	fld	ciry
	SVC	GLENDP			;get real point coordinate
	cmp	dl,0			;point available?
	jz	short midok
	EXIT				;no
midok:	fstp	midy			;yes - save mid point
	fstp	midx
;
;	calculate the arrow starting point
;
	fld	cirx			;get angle from center to mid point
	fld	ciry
	fld	midx
	fld	midy
	SVC	ANGLE
	fstp	brnga			;save it
	fld	cirx			;get point on circle at angle
	fld	ciry
	fld	cird
	fld	brnga
	SVC	PCONV			;polar convert to new point
	fstp	strty			;pop Y then X
	fstp	strtx
;
;	draw "so far" line on screen for to help the user
;
	SVC	CINFO			;draw in marking color
	mov	al,ch			;set desired color in AX (AH+AL)
	mov	ah,0
	CALLDP	DSCOLOR
	fld	strtx			;from circle edge
	fld	strty
	fld	midx			;to bend point
	fld	midy
	SVC	DLINE			;draw it
;
;	get dimension end point
;
	mov	ax,DS			;get dimension end point
	mov	ES,ax
	lea	si,rdp3
	mov	ax,0			;point is for data
	fld	midx			;rubber-band origin
	fld	midy
	SVC	GLENDP			;get real point coordinate
	cmp	dl,0			;point available?
	jz	short endok		;yes
	SVC	CINFO			;no - undraw in background color
	mov	al,ah
	sub	ah,ah
	CALLDP	DSCOLOR
	fld	strtx			;from circle edge
	fld	strty
	fld	midx			;to bend point
	fld	midy
	SVC	DLINE			;undraw it
	EXIT				;no
endok:	fstp	endy			;save end point
	fstp	endx
	fnmove	endy,midy		;ortho lock end point to mid point
;
;	Build arrow entity in ENTREC
;
	SVC	CINFO			;init common info
	les	di,ENTRP		;ES:DI points to ENTREC
	mov	ES:elayer[di],dl	;set layer
	mov	ES:ecolor[di],al	;set color
	mov	ES:estyle[di],bl	;set line style
	mov	ES:erlen[di],31		;record length of 3-node arrow
	mov	ES:etype[di],10		;etype=arrow
	mov	ES:pcount[di],3		;3 nodes
	lea	di,polyx[di]		;point to nodelist
	lea	si,strtx		;nodes to copy begin at strtx
	cld				;upscan
	mov	cx,12			;12 words = 6 reals = 3 nodes
	fwait				;wait on 8087 fstp complete
	rep	movsw			;copy the nodes
	SVC	APND			;append the arrow
	SVC	DRAW			;then draw it
;
;	format the dimension text
;
	mov	ax,DS			;point to format string
	mov	ES,ax
	lea	si,dtfmt
	lea	dx,dtvar		;var list
	lea	di,dtstg		;and result string
	SVC	FORMST			;do it
	inc	cx			;count eos byte
	mov	DTLen,cx		;save string length
;
;	Build text entity in ENTREC
;
	mov	ax,DTLen		;calc record length
	add	ax,27			;overhead for text
	les	di,ENTRP		;ES:DI points to ENTREC
	mov	ES:erlen[di],ax
	mov	ES:etype[di],3		;text is etype 3
					;color,layer,style already set
					;from arrow previously in ENTREC
	mov	ES:tjust[di],9		;assume justify left-mid-margin
	fld	EndX			;if EndX<MidX then
	fcomp	Midx
	fjge	jok
	mov	ES:tjust[di],10		;justify right-mid-margin
jok:	les	di,HDRP			;point ES:DI to header data
	fld	ES:CurDHgt[di]		;get dim text height
	mov	bl,ES:CurDF[di]		;get dim text font
	les	di,ENTRP		;ES:DI points to ENTREC
	mov	ES:tfont[di],bl		;text font
	fstp	ES:thgt[di]		;text height
	fmove	ES:txx[di],EndX		;text origin at end of leader
	fmove	ES:txy[di],Endy
	fone	ES:txar[di]		;text aspect ratio = 1.0
	fzero	ES:tang[di]		;text angle = 0.0
	lea	di,tdata[di]		;copy text into record
	lea	si,dtstg		;from formatted string
	mov	cx,DTLen		;number of bytes to copy
	cld				;upscan
	rep	movsb			;copy it
	fwait				;wait on 8087 fstp complete
	SVC	APND			;append text entity
	SVC	DRAW			;then draw it
;
	EXIT				;all done
;
;
;	---------------------------------------------------------------
;	CHGRAD	Change radius of selected circles/arcs (undoable)
;		Uses erase old, append modified new, undoable logic
;	---------------------------------------------------------------
;
tpos	dd	0			;scan record #
rprmpt	db	'New Radius: ',0
newrad	dd	0.0
;
CHGRAD:	SVC	SELECT			;user selects entities
	jc	short GetRad
	EXIT				;if select cancelled
;
GetRad:	mov	ax,DS			;prompt user for new radius
	mov 	ES,ax
	lea	si,rprmpt
	SVC	GRVAL
	cmp	dl,0			;check for valid radius
	je	short RadOk
	SVC	ABTSEL			;otherwise deselect and redraw
	EXIT
RadOk:	fstp	NewRad			;otherwise save new radius
;
	mov	word ptr tpos,0		;init scan at record # 0
	mov	word ptr tpos+2,0
;
GetNxt:	mov	ax,word ptr tpos	;load record # to restart scan 
	mov	dx,word ptr tpos+2
	SVC	STSCAN			;scan for a selected record
	jc	short NxtRec
	EXIT				;if at end-of-file
;
NxtRec:	cmp	ES:etype[di],4		;is it a circle?
	je	short IsCirc
	cmp	ES:etype[di],5		;is it an arc?
	je	short IsCirc
	SVC	DESEL			;otherwise de-select it
	SVC	DRAW	
	SVC	NXSCAN			;get next entity (no need to restart
	jc	short NxtRec		;  scan because no append)
	EXIT				;if at end-of-file
;
IsCirc:	add	ax,1			;save record number after this one
	adc	dx,0
	mov	word ptr tpos,ax
	mov	word ptr tpos+2,dx
	SVC	ERASE			;erase existing circle/arc
	les	di,ENTRP		;set pointer to ENTREC
	FMOVE	ES:Crad[di],Newrad	;plug new radius into arc/circle
	SVC	APND			;append modified record
	SVC	DRAW			;redraw it
	jmp	short GetNxt		;loop for all selected records
;
;
;	---------------------------------------------------------------
;	DCDEMO	Dynamic Cursor Demonstration (builds circle entity)
;		Displays circular cursor that moves with center point
;		Doesn't support filled circles
;	---------------------------------------------------------------
;
msg1	db	'Radius:',0
msg2	db	'Center:',0
;
DCDEMO:	SVC	SUNADD			;undo = unadd
	mov	ax,DS			;get radius
	mov	ES,ax
	mov	si,offset msg1
	SVC	GRVAL
	cmp	dl,0			;ok?
	jz	short rok
	EXIT				;exit if user cancelled radius
rok:	les	di,ENTRP		;yes - store radius
	fstp	ES:crad[di]
	mov	ES:erlen[di],18		;circle record length
	mov	ES:etype[di],4		;circle is etype 4
	lea	di,dyncd		;use dynamic circle cursor
	mov	ax,CS
	mov	ES,ax
	SVC	DYNCSR
	mov	ax,DS			;get center point
	mov	ES,ax
	mov	si,offset msg2
	SVC	GPOINT
	SVC	EDYNCSR			;end dynamic cursor
	cmp	dl,0			;ok?
	jz	short cok
	EXIT				;exit if user cancelled center
cok:	les	di,ENTRP		;yes - store center
	fstp	ES:ceny[di]
	fstp	ES:cenx[di]
	SVC	CINFO			;get current color etc.
	les	di,ENTRP
	mov	ES:elayer[di],dl
	mov	ES:ecolor[di],al
	mov	ES:estyle[di],bl	;line style only
	SVC	APND			;append circle to database
	SVC	DRAW			;draw the circle
	EXIT
;
;	DYNCD - Draw Dynamic CIRD/CIRR Cursor - Pt on cir is on 8087
;
DynCD:	ENTRY
	les	di,ENTRP
	jc	short dyncdd		;cursor draw?
	fstp	ES:ceny[di]		;store center
	fstp	ES:cenx[di]
dyncdd:	fld	ES:cenx[di]		;draw circle
	fld	ES:ceny[di]
	fld	ES:crad[di]
	SVC	DCIR
	EXIT
;
;
;	---------------------------------------------------------------
;	DBOX	Basic dialog box: Selects new color, moving
;		checkmark in color bar.
;	---------------------------------------------------------------
;
DBoxT	db	'New Entity Color:           ',0	;text image
	db	'                            ',0
	db	'  Green  Red  Blue  Yellow  ',0
	db	'                            ',0
;
DBoxD	dw	offset DBoxT		;dialog box data structure
	dw	28,4,4			;width, height, number of items
	dw	2,2,5,1,'G'		;item 1 posx,posy,sizx,sizy,key eq
	dw	9,2,3,1,'R'		;item 2 posx,posy,sizx,sizy,key eq
	dw	14,2,4,1,'B'		;item 3 posx,posy,sizx,sizy,key eq
	dw	20,2,6,1,'Y'		;item 4 posx,posy,sizx,sizy,key eq
;
DBOX:	mov	ax,DS
	mov	ES,ax
	lea	di,DBoxD		;point to dialog data
	SVC	SDLOG			;start the dialog
	SVC	QDLOG			;pick a choice
	push	ax			;save item #
	SVC	EDLOG			;clear the dialog
	pop	ax			;restore item #
	cmp	ax,0			;cancel on item 0 (R-Button etc.)
	jz	short BoxDn
	SVC	NEWCLR			;set new draw color
BoxDn:	EXIT
;
;
;	---------------------------------------------------------------
;	VALBOX	Demonstrates dialog with editable and non-editable
;		value buttons. User enters value in one button,
;		command displays ACOS and ATAN results in non-editable
;		buttons.
;
;	Command also tests ACOS and ATAN functions on math chip.
;	---------------------------------------------------------------
;
VBoxT	db	'                    ',0	;text image for dialog
	db	' Value: ........  0 ',0
	db	'                    ',0
	db	' ACos:  ........ 90 ',0
	db	'                    ',0
	db	' ATan:  ........  0 ',0
	db	'                    ',0	;note: button 1 need not
	db	'          Done      ',0	;be at top of dialog
	db	'                    ',0
VBoxD	dw	offset VBoxT		;dialog box data
	dw	20,9,4
	dw	8,7,8,1,'D'		;1=Done
	dw	8,1,8,1,'V'		;2=User enters value here
	dw	8,3,8,1,0		;3=ACos (display only)
	dw	8,5,8,1,0		;4=ATan (display only)
;
ValDta	db	0,0,0,0			;value-query data structure
	dw	2,01h,offset UsrVal	;editable real number
	dw	3,81h,offset ACosVal	;display-only real number
	dw	4,81h,offset ATanVal	;display-only real number
	dw	0			;end of value-query item list
;
UsrVal	dd	0.0
ACosVal	dd	0.0
ATanVal	dd	0.0
;
VALBOX:	fzero	UsrVal			;initialize value to zero
	call	CalcVal			;calc initial display values
	mov	ax,DS
	mov	ES,ax
	lea	di,VBoxD		;pointer to dialog data
	SVC	SDLOG
MorVal:	mov	ax,DS			;get value and display results
	mov	ES,ax
	lea	di,ValDta		;pointer to value-query data
	SVC	VDLOG
	cmp	ax,1			;cancel or done?
	jbe	short VBDone		;close dialog if so
	call	CalcVal			;otherwise calc results
	jmp	short MorVal		;and loop back to display them
VBDone:	SVC	EDLOG			;end dialog
	EXIT
;
CalcVal	proc	near			;calculate function values
	fld	UsrVal	
	SVC	ACOS			;arccosine
	SVC	DEG			;change to degrees
	fstp	ACosVal			;store result for display
	fld	UsrVal	
	SVC	ATAN			;arctangent
	SVC	DEG			;change to degrees
	fstp	ATanVal			;store result for display
	ret
calcval	endp
;
;
;	---------------------------------------------------------------
;	SWBOX	Demonstrates dialog with button that switches
;		among three settings. Displays selected switch setting
;		number on text screen after user closes dialog.
;	---------------------------------------------------------------
;
SwBoxT	db	'                         ',0	;text image for dialog
	db	' Select: .........   OK  ',0
	db	'                         ',0
;
SwBoxD	dw	offset SwBoxT		;dialog box data
	dw	25,3,2
	dw	20,1,4,1,'O'		;item #1 (OK button)
	dw	9,1,9,1,'S'		;item #2 (the switch)
;
SwVDta	db	0,0,0,0			;value-query data structure
	dw	2,00h,offset SwDta	;pointer to switch data structure
	dw	0			;end of value-query item list
;
SwDta	db	1			;current setting
	db	3			;number of different settings
	dw	0			;resource (0 means offsets follow)
	dw	offset SwTxt1		;Point to text for setting 1
	dw	offset SwTxt2		;Point to text for setting 2
	dw	offset SwTxt3		;Point to text for setting 3
;
SwTxt1	db	'Setting 1',0		;actual text for setting 1
SwTxt2	db	'Set on 2',0		;actual text for setting 2
SwTxt3	db	'Switch=3',0		;actual text for setting 3
;
OldSw	db	0			;old switch setting # for cancel
;
SwDispT	db	'Switch setting #!3 was selected.',13,0	;results string
SwDispV	dw	offset SwDta		;variable to format in above string
;
;
SWBOX:	mov	al,SwDta		;preserve prior setting for cancel
	mov	OldSw,al
	mov	ax,DS
	mov	ES,ax
	lea	di,SwBoxD		;pointer to dialog data
	SVC	SDLOG
MoreSw:	mov	ax,DS			;get value and display results
	mov	ES,ax
	lea	di,SwVDta		;pointer to value-query data
	SVC	VDLOG
	cmp	ax,2			;loop if item2 (switch button)
	jae	short MoreSw
	push	ax			;save item #
	SVC	EDLOG
	pop	ax			;restore item #
	cmp	ax,1			;OK button (item 1)?
	je	short SwDsp		;display result if so
	mov	al,OldSw		;else restore old setting
	mov	SwDta,al
	jmp	short SwDone		;and skip display
SwDsp:	SVC	TSINIT			;display results on text screen
	mov	ax,DS
	mov	ES,ax
	mov	si,offset SwDispT	;pointer to format string
	mov	dx,offset SwDispV	;pointer to variable list
	SVC	FORMDS			;display formatted results
	SVC	GKEY			;wait for keypress
	SVC	TSEND			;restore graphics screen
SwDone:	EXIT
;
;
;	---------------------------------------------------------------
;	PGBOX	Demonstrates dialog with paging list item. User clicks
;		triangles to page up or down, then selects string
;		from list. Command displays selected string
;		number on text screen after user closes dialog.
;	---------------------------------------------------------------
;
PgBoxT	db	'                          ',0
	db	' Page Up ................ ',0
	db	'         ................ ',0
	db	'         ................ ',0
	db	'         ................ ',0
	db	' Page Dn ................ ',0
	db	'                          ',0
	db	'             D O N E      ',0
	db	'                          ',0
;
PgBoxD	dw	offset PgBoxT		;dialog box data
	dw	26,9,2
	dw	9,7,16,1,'D'		;item 1 ("DONE" button)
	dw	9,1,16,5,0		;item 2 (paging list)
;
PgVDta	db	0,0,0,0			;value-query data structure
	dw	2,70h,offset PgLDta	;pointer to paging list data
	dw	0			;end of value-query item list
;
PgLDta	db	0			;selected string #
	db	1			;string # currently at top of list
	db	0			;(current max string #)
	db	0			;(current item box height) 
	dw	offset PgLTxt		;pointer to list of strings
	dw	0			;reserved (for segment?)
;
PgLTxt	db	'Alpha',0		;strings to page in the list
	db	'Qwerty',0
	db	'Zzzyx',0
	db	'Item # 4',0
	db	'Item # 5',0
	db	'Sixth place',0
	db	'7s too long for a line item!',0
	db	'8 is not the last.',0
	db	'99999 etc.',0
	db	'Ten little indians',0
	db	'11 is the last.',0
	db	0		;end of list
;
PgDispT	db	'String #!3 was selected.',13,0		;results string
PgDispV	dw	offset PgLDta		;variable to format in above string
;
PGBOX:	mov	PgLDta,0		;start with nothing selected
	mov	PgLDta+1,1		;start with string #1 at top
	mov	ax,DS			;start the dialog
	mov	ES,ax
	lea	di,PgBoxD		;pointer to dialog data
	SVC	SDLOG
MorePg:	mov	ax,DS			;select paging list or DONE
	mov	ES,ax
	lea	di,PgVDta		;pointer to value-query data
	SVC	VDLOG
	cmp	ax,2			;loop if item 2 (the paging list)
	jae	short MorePg
	push	ax			;save item #
	SVC	EDLOG			;clear the dialog
	pop	ax			;restore item #
	cmp	ax,1			;DONE button (item 1)?
	jne	short PgDone		;skip display if cancel (item 0)
	SVC	TSINIT			;display results on text screen
	mov	ax,DS
	mov	ES,ax
	mov	si,offset PgDispT	;pointer to format string
	mov	dx,offset PgDispV	;pointer to variable list
	SVC	FORMDS			;display formatted results
	SVC	GKEY			;wait for keypress
	SVC	TSEND			;restore graphics screen
PgDone:	EXIT
;
;
;	---------------------------------------------------------------
;	MTRBOX	Demonstrates dialog with byte meter bar.
;		Position of marker in meter represents value 0-255.
;		Dialog also displays numeric value in editable
;		value button. Moving marker updates value button and
;		typing value updates meter.
;	---------------------------------------------------------------
;
MtrBoxT	db	'                                  ',0	;text image 
	db	' ................................ ',0
	db	'                                  ',0
	db	' Value: ....                 Done ',0
	db	'                                  ',0
;
MtrBoxD	dw	offset MtrBoxT		;dialog box data
	dw	34,5,3
	dw	29,3,4,1,'D'		;item #1 (DONE button)
	dw	1,1,32,1,0		;item #2 (the meter)
	dw	8,3,4,1,'V'		;item #3 (value button
;
MtrVDta	db	0,0,0,0			;value-query data structure
	dw	2,71h,offset MtrDta	;item 2 is meter bar
	dw	3,03h,offset MtrDta	;item 3 is numeric meter value
	dw	0			;end of value-query item list
;
MtrDta	dw	128			;current setting
	dw	255			;max allowable (must be 255 for now)
;
OldMtr	dw	0			;old meter setting for cancel
;
;
MTRBOX:	mov	ax,MtrDta		;preserve prior setting for cancel
	mov	OldMtr,ax
	mov	ax,DS
	mov	ES,ax
	lea	di,MtrBoxD		;pointer to dialog data
	SVC	SDLOG
MtrLp:	mov	ax,DS
	mov	ES,ax
	lea	di,MtrVDta		;pointer to value-query data
	SVC	VDLOG
	and	MtrDta,00FFh		;range limit to 255
	cmp	ax,2			;loop if item2 (meter or valbutton)
	jae	short MtrLp
	cmp	ax,1			;DONE button (item 1)?
	je	short MtrDn
	mov	ax,OldMtr		;restore old setting if
	mov	MtrDta,ax		;cancelled (item 0)
MtrDn:	SVC	EDLOG
	EXIT
;
;
	include	XPEND.CPY
