;	XPWIN - WINBKD Test XP
;
;	(c) Copyright 1990 Evolution Computing
;	All rights reserved.
;	Written by Michael Riddle 2-7-90
;
	name	XPWIN
;
	include	XPSTART.CPY
;
;	---------------------------------------------------------------
;	XCMD - External Process Command - command # BX
;
;	commands 0..10 are preassigned signals
;	user commands start with command #11
;	---------------------------------------------------------------
;
XCMD:	ENTRY
	shl	bx,1			;make word index
	add	bx,offset cmdtbl
	mov	bx,[bx]			;get command offset
	jmp	bx			;go to command handler
cmdtbl	dw	offset XPLD		;0 = Startup ExtProc
	dw	offset XPUNLD		;1 = Ending use of ExtProc
	dw	offset nulcmd		;2 = Drawing renamed
	dw	offset nulcmd		;3 = Drawing Just Loaded
	dw	offset nulcmd		;4 = Drawing about to be saved
	dw	offset nulcmd		;5 = Drawing REVERTed to prior save
	dw	offset nulcmd		;6 = before getting next command
	dw	offset nulcmd		;7 = regen completed - repath
	dw	offset nulcmd		;8 = About to write part
	dw	offset nulcmd		;9 = unused
	dw	offset nulcmd		;10 = unused
;	other commands offsets go here
nulcmd:	EXIT
;
;	---------------------------------------------------------------
;	XENTITY - External Process Entity Support
;	---------------------------------------------------------------
;
XENT:	ENTRY
	mov	bx,ax			;desired op # in AX
	shl	bx,1			;make word index
	add	bx,offset eftbl
	mov	bx,[bx]			;get entity function offset
	jmp	bx			;go to function  handler
eftbl	dw	offset nullop		;0 = draw entity
	dw	offset nullop		;1 = pick test entity
	dw	offset nullop		;2 = transform entity
	dw	offset nullop		;3 = stretch entity
	dw	offset nullop		;4 = list entity
	dw	offset nullop		;5 = check entity extents
	dw	offset nullop		;6 = attach to entity
	dw	offset nullop		;7 = actuate entity
nullop:	finit				;clear 8087
	clc				;no pick/attach
	EXIT
;
;	---------------------------------------------------------------
;	XCSTG - Command Name String
;
;	Each command word is UPPERCASE, space delimited.
;	---------------------------------------------------------------
;
XPEXID	dw	0			;no EXT entities in this module
;
XCSTG	db	0			;end of command word table
;
;	---------------------------------------------------------------
;	DOS Identification Message
;	---------------------------------------------------------------
;
ident	db	'XPWIN - WINBKD Test Program.',13,10,'$'
;
;	---------------------------------------------------------------
;	XP Load Signal Process
;	---------------------------------------------------------------
;
XPLD:	mov	ax,DS			;specify WINBKD routine
	mov	ES,ax
	mov	di,offset WPaint
	SVC	WINBKD
	EXIT
;
;	---------------------------------------------------------------
;	XP Unload Signal Process
;	---------------------------------------------------------------
;
XPUNLD:	SVC	EWINBKD			;stop using WINBKD routine
	EXIT
;
;	---------------------------------------------------------------
;	Window Background Paint Routine
;
;	On entry, SI,DI = lower left screen corner of window
;		  DX,AX = Upper right screen corner of window
;		  8087 = LowX, LowY, HighX, HighY (tos)
;	---------------------------------------------------------------
;
WPaint:	ENTRY
	finit				;discard real coordinates
	push	si			;save screen coordinates
	push	di
	push	dx
	push	ax
;
	mov	ax,15			;specify color
	CALLDP	DSCOLOR
	mov	ax,1			;specify fill pattern
	CALLDP	DSFPAT
;
	pop	ax			;fill window with pattern
	pop	dx
	pop	di
	pop	si
	CALLDP	DSFREC
;
	EXIT
;
	include	XPEND.CPY
